XMLF90
======

xmlf90 is a suite of libraries to handle XML in Fortran. It has two
major components:

- A XML parsing library. The parser was designed to be a useful
  tool in the extraction and analysis of data in the context of
  scientific computing, and thus the priorities were efficiency and the
  ability to deal with very large XML files while maintaining a small
  memory footprint. The most complete programming interface is
  based on the very successful SAX (Simple API for XML) model,
  although a partial DOM interface and a very experimental XPATH interface
  are also present.
- A library (xmlf90_wxml) that facilitates the writing of well-formed
  XML, including such features as automatic start-tag completion,
  attribute pretty-printing, and element indentation. There are also
  helper routines to handle the output of numerical arrays.
  Layered on top of this library is xmlf90_cml, a library to generate
  Chemical-Markup-Language (CML) files.

Documentation is available in doc/Tutorial, and can be seen online
in [https://xmlf90.readthedocs.io](https://xmlf90.readthedocs.io).


INSTALLATION
------------

A) With CMake:

    cmake -S. -B_build -DCMAKE_INSTALL_PREFIX=/path/to/install/directory
    cmake --build _build
    (push _build; ctest ; popd)  # To run a simple test
    cmake --install _build

B) With auto-tools

    ./configure --prefix=/path/to/install/directory
    make
    make check
    make install

You can go into the subdirectories 'doc/Examples' and explore, and go
into 'doc/Tutorial' and try the exercises in the User Guide.


COMPILING USER PROGRAMS
-----------------------

A) With CMake

Just use the standard CMake idiom in your CMakeLists.txt file:

    add_executable(your_program your_sources)
    find_package(xmlf90 REQUIRED)
    target_link_libraries(your_program xmlf90::xmlf90)

The above assumes that the installation directory for xmlf90 can
be found by CMake. This can be achieved by adding it to the CMAKE_PREFIX_PATH
CMake or enviroment variable:

    cmake -S. -B_your_build -DCMAKE_PREFIX_PATH=$XMLF90_ROOT .......
    CMAKE_PREFIX_PATH=$XMLF90_ROOT cmake -S. -B_your_build .......

B) With a makefile

Both methods above will create a pkg-config file with information
for client programs. It is suggested that the user create a
separate directory to hold the program files and prepare a Makefile
following this example (FC, FFLAGS, and LDFLAGS need to be set appropriately
for the Fortran compiler used):

    #---------------------------------------------------------------
    #
    default: example
    #
    #---------------------------
    XMLF90_ROOT=/path/to/installation
    PKG_CONFIG_PATH=$(XMLF90_ROOT)/lib/pkgconfig:$(PKG_CONFIG_PATH)
    #
    XMLF90_LIBS=$(pkg-config --libs xmlf90)
    XMLF90_INCFLAGS=$(pkg-config --cflags xmlf90)
    #
    INCFLAGS := $(XMLF90_INCFLAGS) $(INCFLAGS)
    LIBS:= $(XMLF90_LIBS) $(LIBS)
    #---------------------------
    #
    OBJS= m_handlers.o example.o
     
    example:  $(OBJS)
            $(FC) $(LDFLAGS) -o $@ $(OBJS)  $(LIBS)
    #
    clean: 
            rm -f *.o example *.mod
    #
    # Building rules
    #
    .F.o:
            $(FC) -c $(FFLAGS) $(INCFLAGS)  $(FPPFLAGS) $<
    .f.o:
            $(FC) -c $(FFLAGS) $(INCFLAGS)   $<
    .F90.o:
            $(FC) -c $(FFLAGS) $(INCFLAGS)  $(FPPFLAGS) $<
    .f90.o:
            $(FC) -c $(FFLAGS) $(INCFLAGS)   $<
    #
    #---------------------------------------------------------------

Here it is assumed that the user has two source files,
'example.f90' and 'm_handlers.f90'. Simply typing
'make' will compile 'example', pulling in all the needed
modules and library objects.


NOTE: The FoX project, started by Toby White and now maintained by
Andrew Walker, has produced a more robust and feature-rich package
starting from xmlf90, although not as fast and trim in some areas.  It
can be found in [https://github.com/andreww/fox](https://github.com/andreww/fox).

The documentation has been updated to use RST.

It can be built locally if a sphinx installation is available:

   make -f makefile.sphinx html
   
or read directly in Read-the-Docs (https://xmlf90.readthedocs.io).

The sax and xpath directories contain the source for the exercises in
the User Guide.



-- OLD, deprecated, documentation:

See UserGuide.pdf for a tutorial and a reference to the 
SAX and stream XPATH parser APIs.

The DOM interface is documented in html/DOM.html (directly readable in a web browser).

The WXML writing library and the "Jumbo90" (CML writer by Jon Wakelin)
are documented in html/WXML.html, html/jumbo.html and
html/jumbodocs.html.

There are further enhancements in the Siesta distribution:

- Use of (home-made) dynamic strings in the stack and dictionary modules.
- Use of error-handling routines
- New overloads for the add_pcdata and add_attribute interfaces
- New overloads for the str interface

This directory contains the source for the SAX examples in the User Guide.


Release Notes:

Changes with respect to the text in the User Guide:

* Obvious typos and missing declarations have been corrected. 

* Subroutine begin_element_print in simple.f90 
  cannot apparently be both an internal subprogram and an actual argument. 
  It has been put in a module.

This directory contains the source for the XPATH examples in the User Guide.


Release Notes:

Changes with respect to the text in the User Guide:

* Obvious typos and missing declarations have been corrected. 

* Due to a bug in xmlf90 Version 0.9.8, it is necessary to add an "attributes"
argument in the call to "get_node" in euros.f90.

DOM examples

features.f90 : Illustrates the types of nodes created for
               the different parsing events.

data.f90     : Dynamics of the DOM tree: cloning, inserting,
               destroying, and dumping to XML.

text.f90     : Example of the "normalize" method.

pseudo.f90   : Real-world example of parsing a pseudopotential file.

pseudo_dom.f90 : A more sophisticated, more DOM-like version of
                 pseudo processing (incomplete picture -- more
                 routines need to be written).
                    

Examples of use of the XPATH API for XML parsing.

text		: Extracts text from an element.
relative	: Illustrates relative searches.
pseudo		: A more complete example of the use of the XPATH API. It
                  replicates the functionality of the SAX example of the 
                  same name, illustrating in particular the concept of
                  context delegation.

Just type "make" to build all three examples.

Some examples of the use of the SAX API in Fortran.

Start by looking at the "simple" directory. That will give you a
feeling for the workings of the parser. Feel free to experiment
with "malforming" the "test.xml", and to turn on the "verbose"
flag in the call to "xml_parse" in example.f90.

"Count" contains a simple yet meaningful application of the parser: counting
the number of elements of different types in an XML file.

"Pseudo" is a scaled-down real-world physics application: reading a
data file and populating internal structures. It showcases the use of
"build_data_array" to turn homogeneous PCDATA sections into numerical arrays.

"Features" shows small snippets of all the constructs recognized by the
parser: treatment of quotes in attributes, standard entities, CDATA sections,
declarations, comments, etc. 

Alberto Garcia 
wdpgaara at lg ehu es

This directory contains a real-world example of processing an XML file.

Pseudo.xml is a prototype XML pseudopotential file, containing, apart
from identification information, several datasets representing functions
of a radial coordinate. These functions are given as tables with an underlying 
grid. The grid can be common to all, or each radial function ("radfunc") can
have its own.

The program reads the XML file and then constructs a data structure
with all the information in the file, ready to be processed by other
utilities, such as an electronic-structure program.

Pseudo.xml is just a prototype, and this program is just an illustration
of the kinds of idioms one can use to process a non-trivial XML file
using a SAX-like parser.

The basic data structures are defined in module m_pseudo_types, and the 
handlers are in m_pseudo.f90.

Type 'make' to compile, and 'pseudo' to execute.
(In the interest of simplicity, this program is hardwired to process
the 'pseudo.xml' file. For command-line control, one could use the
routines in the f2kcli module.)

This directory contains a very simple but complete example of the use
of the XML parser.

The program, in file "example.f90", uses the module "m_handlers", which
contains the handlers for the basic events:  begin_element, end_element, and 
pcdata_chunk, as well as for the other, less useful events: XML and SGML
declarations, and comments.

The program opens the XML file, obtaining a file object, and calls
xml_parse with the above handlers.

In this particular case, the handler action is just to print out 
element/attribute information, and to dump any PCDATA sections, comments, and
declarations, but "test.xml" shows all the constructs that the parser
recognizes: standard and character entities, CDATA sections, etc.

Turning on the 'verbose' flag in the call to xml_parse will result in a
more detailed look at the workings of the parser.

Type 'make' to compile, and 'example' to execute.

**

As a trivial example, the program xmlcheck will just check for
well-formedness and print a count of characters processed. The
name of the input file is hardwired to "INP" (one should of course
pick it from the command line, perhaps using the f2kcli module).

This directory contains a very simple example of the use
of the XML parser.

The program, in file "example.f90", uses the module "m_handlers", which
contains the handlers for the basic events:  begin_element, end_element, and 
pcdata_chunk.

The program opens the XML file, obtaining a file object, and calls
xml_parse with the above handlers.

In this particular case, the handlers' action is just to print out 
element/attribute information, and to dump any PCDATA sections.

Turning on the 'verbose' flag in the call to xml_parse will result in a
more detailed look at the workings of the parser.

Type 'make' to compile, and 'example' to execute.

program inventory
use xmlf90_sax
use m_handlers

type(xml_t)        :: fxml      ! XML file object (opaque)
integer            :: iostat    

call open_xmlfile(SAX_DATA_DIR//"inventory.xml",fxml,iostat)
if (iostat /= 0) stop "cannot open xml file"

call xml_parse(fxml, begin_element_handler=begin_element, &
                     end_element_handler=end_element,     &
                     pcdata_chunk_handler=pcdata_chunk )
                     
end program inventory

module m_wxml_elstack

use m_wxml_error

implicit none

private

!
! Simple stack to keep track of which elements have appeared so far
!
! Initial stack size:
integer, parameter, private            :: STACK_SIZE_INIT = 10
! Multiplier when stack is exceeded:
real, parameter, private            :: STACK_SIZE_MULT = 1.5

type, private :: elstack_item
  character(len=200) :: data
end type

type, public :: elstack_t
private
      integer                                   :: n_items
      type(elstack_item), pointer, dimension(:) :: stack
end type elstack_t

public  :: push_elstack, pop_elstack, init_elstack, reset_elstack, print_elstack
public  :: get_top_elstack, is_empty, get_elstack_signature
public  :: len

interface len
   module procedure number_of_items
end interface
private :: number_of_items

interface is_empty
      module procedure is_empty_elstack
end interface
private :: is_empty_elstack

CONTAINS

!-----------------------------------------------------------------
subroutine init_elstack(elstack)
  type(elstack_t), intent(inout)  :: elstack

  allocate(elstack%stack(STACK_SIZE_INIT))
  elstack%n_items = 0

end subroutine init_elstack

!-----------------------------------------------------------------
subroutine reset_elstack(elstack)
  type(elstack_t), intent(inout)  :: elstack

  deallocate(elstack%stack)
  call init_elstack(elstack)

end subroutine reset_elstack

!-----------------------------------------------------------------
subroutine resize_elstack(elstack)
  type(elstack_t), intent(inout)  :: elstack
  type(elstack_item), pointer, dimension(:) :: temp
  integer :: s

  s = size(elstack%stack)

  temp=>elstack%stack
  allocate(elstack%stack(nint(s*STACK_SIZE_MULT)))
  elstack%stack(:s) = temp
  deallocate(temp)

end subroutine resize_elstack

!-----------------------------------------------------------------
function is_empty_elstack(elstack) result(answer)
type(elstack_t), intent(in)  :: elstack
logical                    :: answer

answer = (elstack%n_items == 0)
end function is_empty_elstack

!-----------------------------------------------------------------
function number_of_items(elstack) result(n)
type(elstack_t), intent(in)  :: elstack
integer                      :: n

n = elstack%n_items
end function number_of_items

!-----------------------------------------------------------------
subroutine push_elstack(item,elstack)
character(len=*), intent(in)      :: item
type(elstack_t), intent(inout)  :: elstack

integer   :: n

n = elstack%n_items
if (n == size(elstack%stack)) then
  call resize_elstack(elstack)
endif
n = n + 1
elstack%stack(n)%data = item
elstack%n_items = n

end subroutine push_elstack

!-----------------------------------------------------------------
subroutine pop_elstack(elstack,item)
type(elstack_t), intent(inout)     :: elstack
character(len=*), intent(out)        :: item

integer   :: n

n = elstack%n_items
if (n == 0) then
      call wxml_error("Element stack empty")
endif
item = elstack%stack(n)%data
elstack%n_items = n - 1

end subroutine pop_elstack

!-----------------------------------------------------------------
subroutine get_top_elstack(elstack,item)
!
! Get the top element of the stack, *without popping it*.
!
type(elstack_t), intent(in)        :: elstack
character(len=*), intent(out)        :: item

integer   :: n

n = elstack%n_items
if (n == 0) then
  call wxml_error("Element stack empty")
endif
item = elstack%stack(n)%data

end subroutine get_top_elstack

!-----------------------------------------------------------------
subroutine print_elstack(elstack,unit)
type(elstack_t), intent(in)   :: elstack
integer, intent(in)           :: unit
integer   :: i

do i = elstack%n_items, 1, -1
  write(unit=unit,fmt=*) trim(elstack%stack(i)%data)
enddo

end subroutine print_elstack

!-------------------------------------------------------------
subroutine get_elstack_signature(elstack,string)
type(elstack_t), intent(in)   :: elstack
character(len=*), intent(out) :: string
integer   :: i, length, j

string = ' '
j = 0
do i = 1, elstack%n_items
   length = len_trim(elstack%stack(i)%data)
   string(j+1:j+1) = "/"
   j = j+1
   string(j+1:j+length) = trim(elstack%stack(i)%data)
   j = j + length
enddo

end subroutine get_elstack_signature

end module m_wxml_elstack

program example
!
! Example driver for a stand-alone parsing of an xml document
!
use xmlf90_sax
use m_handlers      ! Defines begin_element, end_element, pcdata_chunk, etc

  integer :: iostat
  type(xml_t)  :: fxml

  !  call open_xmlfile(SAX_DATA_DIR//"test.xml",fxml,iostat)
  call open_xmlfile("test.xml",fxml,iostat)
  if (iostat /= 0) stop "Cannot open file."

  call xml_parse(fxml, &
               begin_element_handler = begin_element_handler , &
               end_element_handler = end_element_handler, &
               pcdata_chunk_handler = pcdata_chunk_handler, &
               comment_handler = comment_handler, &
               xml_declaration_handler = xml_declaration_handler, &
               sgml_declaration_handler = sgml_declaration_handler, &
               verbose = .false., &
               empty_element_handler = empty_element_handler)

end program example

module m_sax_entities
!
! Entity management
!
! It deals with: 
!    1. The five standard entities (gt,lt,amp,apos,quot)
!    2. Character entities  (but only within the range of the char intrinsic)
!
use m_sax_buffer
use m_xml_error
private

integer, parameter, private      :: MAX_REPLACEMENT_SIZE = 200
!
type, private :: entity_t
 character(len=40)                     :: code
 character(len=MAX_REPLACEMENT_SIZE)   :: replacement
end type entity_t

integer, parameter, private                          ::  N_ENTITIES  = 5

type(entity_t), private, dimension(N_ENTITIES), save :: predefined_ent =  &
      (/                  &
      entity_t("gt",">"), &
      entity_t("lt","<"),  &
      entity_t("amp","&"),  &
      entity_t("apos","'"),  &
      entity_t("quot","""")  &
      /)
      
public :: code_to_str , entity_filter

CONTAINS

subroutine code_to_str(code,str,status)
character(len=*), intent(in)  :: code
character(len=*), intent(out) :: str
integer, intent(out)          :: status         
integer :: i

integer   :: number, ll
character(len=4)  :: fmtstr

status = -1
do i = 1, N_ENTITIES
      if (code == predefined_ent(i)%code) then
         str = predefined_ent(i)%replacement
         status = 0
         return
      endif
enddo
!
! Replace character references  (but only within the range of the
! char intrinsic !!)
!
if (code(1:1) == "#") then
   if (code(2:2) == "x") then       ! hex character reference
      ll = len_trim(code(3:))
      write(unit=fmtstr,fmt="(a2,i1,a1)") "(Z", ll,")"
      read(unit=code(3:),fmt=fmtstr) number
      str = char(number)
      status = 0
      return
   else                             ! decimal character reference
      read(unit=code(2:),fmt=*) number
      str = char(number)
      status = 0
      return
   endif
endif

end subroutine code_to_str

!----------------------------------------------------------------
!
! Replaces entity references in buf1 and creates a new buffer buf2.
!
subroutine entity_filter(buf1,buf2,stat,msg)
type(buffer_t), intent(in)    :: buf1
type(buffer_t), intent(out)   :: buf2
integer, intent(out), optional           :: stat
character(len=*), intent(out), optional  :: msg
!
! Replaces entity references by their value
!
integer :: i, k, len1
character(len=MAX_BUFF_SIZE)           :: s1
character(len=1)                       :: c
character(len=MAX_REPLACEMENT_SIZE)    :: repl

character(len=120)                     :: message
integer                                :: status

logical                                :: error_handling_vars_present 

error_handling_vars_present = present(stat) .and. present(msg)

if (error_handling_vars_present) then
   stat = 0
   msg = ""
endif

call buffer_to_character(buf1,s1)        !! Avoid allocation of temporary
len1 = len(buf1)

i = 1

call reset_buffer(buf2)

do
   if (i > len1) exit
   c = s1(i:i)
   if (c == "&") then
      if (i+1 > len1) then
         message=  " Unmatched & in entity reference"
         if (error_handling_vars_present) then
            stat = -1
            msg = message
         else
            call general_error(trim(message),SEVERE_ERROR_CODE)
         endif
         return
      endif
      k = index(s1(i+1:),";")
      if (k == 0) then
         message=  " Unmatched & in entity reference"
         if (error_handling_vars_present) then
            stat = -1
            msg = message
         else
            call general_error(trim(message),SEVERE_ERROR_CODE)
         endif
         return
      endif
      call code_to_str(s1(i+1:i+k-1),repl,status)
      if (status /= 0) then
         message= "Ignored unknown entity: &" // s1(i+1:i+k-1) // ";"
         call general_error(trim(message),WARNING_CODE)
      else
         call add_to_buffer(trim(repl),buf2)
      endif
      i = i + k + 1
   else
     call add_to_buffer(c,buf2)
     i = i + 1
   endif
enddo

end subroutine entity_filter

end module m_sax_entities

module m_wxml_overloads
  
  use m_wxml_text, only: str
  use m_wxml_core, only: xmlf_t
  use m_wxml_core, only: xml_AddPcData_Ch => xml_AddPcData
  use m_wxml_core, only: xml_AddAttribute_Ch => xml_AddAttribute

  implicit none

  integer, parameter ::  sp = selected_real_kind(6,30)
  integer, parameter ::  dp = selected_real_kind(14,100)

  private

  public :: xml_AddPcdata
  public :: xml_AddAttribute

  interface xml_AddPcData
     module procedure xml_AddPcdata_SP
     module procedure xml_AddPcdata_DP
     module procedure xml_AddPcdata_Int
     module procedure xml_AddPcdata_Log
  end interface

  interface xml_AddAttribute
     module procedure xml_AddAttribute_SP
     module procedure xml_AddAttribute_DP
     module procedure xml_AddAttribute_Int
     module procedure xml_AddAttribute_Log
  end interface

CONTAINS

  !-------------------------------------------------------------------

  subroutine xml_AddPcdata_SP(xf,pcdata,fmt, space,line_feed)
    type(xmlf_t), intent(inout)    :: xf
    real(kind=sp), intent(in)      :: pcdata
    logical,          intent(in), optional  :: space
    logical,          intent(in), optional  :: line_feed
    character(len=*), intent(in), optional  :: fmt

    call xml_AddPcdata_Ch(xf,trim(str(pcdata,fmt)),space,line_feed)

  end subroutine xml_AddPcdata_SP


  subroutine xml_AddPcdata_DP(xf,pcdata,fmt,space,line_feed)
    type(xmlf_t), intent(inout)    :: xf
    real(kind=dp), intent(in)      :: pcdata
    character(len=*), optional    :: fmt
    logical, intent(in), optional  :: space
    logical, intent(in), optional  :: line_feed

    call xml_AddPcdata_Ch(xf,trim(str(pcdata,fmt)),space,line_feed)

  end subroutine xml_AddPcdata_DP


  subroutine xml_AddPcdata_log(xf,pcdata,fmt,space,line_feed)
    type(xmlf_t), intent(inout)    :: xf
    logical, intent(in)            :: pcdata
    character(len=*), intent(in), optional    :: fmt
    logical, intent(in), optional  :: space
    logical, intent(in), optional  :: line_feed

    if (present(fmt)) then
      call xml_AddPcdata_Ch(xf,trim(str(pcdata,fmt)),space,line_feed)
    else
      call xml_AddPcdata_Ch(xf,trim(str(pcdata)),space,line_feed)
    endif

  end subroutine xml_AddPcdata_log


  subroutine xml_AddPcdata_int(xf,pcdata,fmt,space,line_feed)
    type(xmlf_t), intent(inout)    :: xf
    integer, intent(in)            :: pcdata
    character(len=*), intent(in), optional    :: fmt
    logical, intent(in), optional  :: space
    logical, intent(in), optional  :: line_feed

    if (present(fmt)) then
      call xml_AddPcdata_Ch(xf,trim(str(pcdata,fmt)),space,line_feed)
    else
      call xml_AddPcdata_Ch(xf,trim(str(pcdata)),space,line_feed)
    endif

  end subroutine xml_AddPcdata_int


  !-------------------------------------------------------------------

  subroutine xml_AddAttribute_SP(xf,name,value,fmt)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in)  :: name
    real(kind=sp),    intent(in)  :: value
    character(len=*), intent(in), optional   :: fmt

    call xml_AddAttribute_Ch(xf,name,trim(str(value,fmt)))

  end subroutine xml_AddAttribute_SP

  subroutine xml_AddAttribute_DP(xf,name,value,fmt)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in)  :: name
    real(kind=dp),    intent(in)  :: value
    character(len=*), intent(in), optional   :: fmt

    call xml_AddAttribute_Ch(xf,name,trim(str(value,fmt)))

  end subroutine xml_AddAttribute_DP

  subroutine xml_AddAttribute_log(xf,name,value,fmt)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in)  :: name
    logical, intent(in)           :: value
    character(len=*), intent(in), optional   :: fmt

    if (present(fmt)) then
      call xml_AddAttribute_Ch(xf,name,trim(str(value,fmt)))
    else
      call xml_AddAttribute_Ch(xf,name,trim(str(value)))
    endif

  end subroutine xml_AddAttribute_log

  subroutine xml_AddAttribute_int(xf,name,value,fmt)
    type(xmlf_t), intent(inout)   :: xf
    character(len=*), intent(in)  :: name
    integer, intent(in)           :: value
    character(len=*), intent(in), optional   :: fmt

    if (present(fmt)) then
      call xml_AddAttribute_Ch(xf,name,trim(str(value,fmt)))
    else
      call xml_AddAttribute_Ch(xf,name,trim(str(value)))
    endif

  end subroutine xml_AddAttribute_int

end module m_wxml_overloads

program euros
use xmlf90_xpath
!
type(xml_t) :: fxml

integer  :: status
character(len=100)  :: price

!call enable_debug(sax=.false.)

call open_xmlfile(XPATH_DATA_DIR//"inventory.xml",fxml,status)
!
do
  call get_node(fxml,path="//price", &
                att_name="currency",att_value="euro", &
                pcdata=price,status=status)
  if (status < 0)   exit
  print *, "Price (euro): ", trim(price)
enddo
end program euros

module m_sax_elstack

use m_sax_buffer

private

!
! Simple stack to keep track of which elements have appeared so far
!
integer, parameter, private            :: STACK_SIZE = 40

type, public :: elstack_t
private
      integer                                :: n_items
      type(buffer_t), dimension(STACK_SIZE)  :: data
end type elstack_t

public  :: push_elstack, pop_elstack, reset_elstack, print_elstack
public  :: init_elstack
public  :: get_top_elstack, is_empty, get_elstack_signature

interface is_empty
      module procedure is_empty_elstack
end interface
private :: is_empty_elstack

CONTAINS

!-----------------------------------------------------------------
subroutine init_elstack(elstack)
type(elstack_t), intent(inout)  :: elstack

integer :: i

elstack%n_items = 0
do i = 1, STACK_SIZE                   ! to avoid "undefined status"
      call init_buffer(elstack%data(i))
enddo
end subroutine init_elstack

!-----------------------------------------------------------------
subroutine reset_elstack(elstack)
type(elstack_t), intent(inout)  :: elstack

integer :: i

elstack%n_items = 0
do i = 1, STACK_SIZE                  
      call reset_buffer(elstack%data(i))
enddo
end subroutine reset_elstack

!-----------------------------------------------------------------
function is_empty_elstack(elstack) result(answer)
type(elstack_t), intent(in)  :: elstack
logical                    :: answer

answer = (elstack%n_items == 0)
end function is_empty_elstack

!-----------------------------------------------------------------
subroutine push_elstack(item,elstack)
type(buffer_t), intent(in)      :: item
type(elstack_t), intent(inout)  :: elstack

integer   :: n

n = elstack%n_items
if (n == STACK_SIZE) then
      stop "*Element stack full"
endif
n = n + 1
elstack%data(n) = item
elstack%n_items = n

end subroutine push_elstack

!-----------------------------------------------------------------
subroutine pop_elstack(elstack,item)
type(elstack_t), intent(inout)     :: elstack
type(buffer_t), intent(out)        :: item

!
! We assume the elstack is not empty... (the user has called is_empty first)
!
integer   :: n

n = elstack%n_items
if (n == 0) then
      stop "*********Element stack empty"
endif
item = elstack%data(n)
elstack%n_items = n - 1

end subroutine pop_elstack

!-----------------------------------------------------------------
subroutine get_top_elstack(elstack,item)
!
! Get the top element of the stack, *without popping it*.
!
type(elstack_t), intent(in)        :: elstack
type(buffer_t), intent(out)        :: item

!
! We assume the elstack is not empty... (the user has called is_empty first)
!
integer   :: n

n = elstack%n_items
if (n == 0) then
      stop "*********Element stack empty"
endif
item = elstack%data(n)

end subroutine get_top_elstack

!-----------------------------------------------------------------
subroutine print_elstack(elstack,unit)
type(elstack_t), intent(in)   :: elstack
integer, intent(in)           :: unit
integer   :: i

do i = elstack%n_items, 1, -1
      write(unit=unit,fmt=*) str(elstack%data(i))
enddo

end subroutine print_elstack

!-------------------------------------------------------------
subroutine get_elstack_signature(elstack,string)
type(elstack_t), intent(in)   :: elstack
character(len=*), intent(out) :: string
integer   :: i, length, j

string = ""
j = 0
do i = 1, elstack%n_items
   length = len(elstack%data(i))
   string(j+1:j+1) = "/"
   j = j+1
   string(j+1:j+length) = str(elstack%data(i))
   j = j + length
enddo

end subroutine get_elstack_signature

end module m_sax_elstack

module m_wxml_core

use m_wxml_buffer
use m_wxml_array_str, only: assign_array_to_str
use m_wxml_array_str, only: assign_str_to_array
use m_wxml_escape, only: check_Name
use m_wxml_elstack
use m_wxml_dictionary

implicit none

logical, private, save  :: pcdata_advance_line_default = .false.
logical, private, save  :: pcdata_advance_space_default = .false.

integer, private, parameter ::  sp = selected_real_kind(6,30)
integer, private, parameter ::  dp = selected_real_kind(14,100)

private

type, public :: xmlf_t
   character, pointer      :: filename(:)
   integer                 :: lun
   type(buffer_t)          :: buffer
   type(elstack_t)         :: stack
   type(wxml_dictionary_t) :: dict
   logical                 :: start_tag_closed
   logical                 :: root_element_output
   logical                 :: indenting_requested
   logical                 :: inhibit_lf
end type xmlf_t

public :: xml_OpenFile, xml_NewElement, xml_EndElement, xml_Close
public :: xml_AddXMLDeclaration
public :: xml_AddXMLStylesheet
public :: xml_AddXMLPI
public :: xml_AddComment, xml_AddCdataSection
public :: xml_AddPcdata, xml_AddAttribute
interface  xml_AddPcdata
   module procedure xml_AddPcdata_Ch
end interface
!
interface  xml_AddAttribute
   module procedure xml_AddAttribute_Ch
end interface
!
public :: xml_AddArray
interface xml_AddArray
   module procedure  xml_AddArray_integer,  &
                xml_AddArray_real_dp, xml_AddArray_real_sp
end interface
private :: xml_AddArray_integer,  xml_AddArray_real_dp, xml_AddArray_real_sp

private :: get_unit
private :: add_eol
private :: write_attributes

!overload error handlers to allow file info
interface wxml_warning
  module procedure wxml_warning_xf
end interface
interface wxml_error
  module procedure wxml_error_xf
end interface
interface wxml_fatal
  module procedure wxml_fatal_xf
end interface

!
! Heuristic (approximate) target for justification of output
! Large unbroken pcdatas will go beyond this limit
! 
integer, private, parameter  :: COLUMNS = 80

! TOHW - This is the longest string that may be output without
! a newline. The buffer must not be larger than this, but its size 
! can be tuned for performance.
integer, private, parameter  :: xml_recl = 4096

CONTAINS

!-------------------------------------------------------------------
subroutine xml_OpenFile(filename, xf, indent)
character(len=*), intent(in)  :: filename
type(xmlf_t), intent(inout)   :: xf
logical, intent(in), optional :: indent

integer :: iostat

allocate(xf%filename(len(filename)))
call assign_str_to_array(xf%filename,filename)

call get_unit(xf%lun,iostat)
if (iostat /= 0) call wxml_fatal(xf, "cannot open file")
!
! Use large I/O buffer in case the O.S./Compiler combination
! has hard-limits by default (i.e., NAGWare f95's 1024 byte limit)
! This is related to the maximum size of the buffer.
! TOHW - This is the longest string that may be output without
! a newline. The buffer must not be larger than this, but its size 
! can be tuned for performance.

open(unit=xf%lun, file=filename, form="formatted", status="replace", &
     action="write", position="rewind", recl=xml_recl)

call init_elstack(xf%stack)

call init_dict(xf%dict)
call reset_buffer(xf%buffer)

xf%start_tag_closed = .true.
xf%root_element_output = .false.
xf%inhibit_lf = .false.

xf%indenting_requested = .false.
if (present(indent)) then
   xf%indenting_requested = indent
endif
end subroutine xml_OpenFile

!-------------------------------------------------------------------
subroutine xml_AddXMLDeclaration(xf,encoding)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in), optional :: encoding

if (present(encoding)) then
   call add_to_buffer("<?xml version=""1.0"" encoding=""" &
                     // trim(encoding) // """ ?>", xf%buffer)
else
   call add_to_buffer("<?xml version=""1.0"" ?>", xf%buffer)
endif
end subroutine xml_AddXMLDeclaration

!-------------------------------------------------------------------
subroutine xml_AddXMLStylesheet(xf, href, type, title, media, charset, alternate)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in) :: href
character(len=*), intent(in) :: type
character(len=*), intent(in), optional :: title
character(len=*), intent(in), optional :: media
character(len=*), intent(in), optional :: charset
logical,          intent(in), optional :: alternate

call add_eol(xf)
call add_to_buffer("<?xml-stylesheet href=""" //trim(href)// &
     """ type=""" //trim(type)// """", xf%buffer)

if (present(title)) call add_to_buffer(" title="""//trim(title)// """", xf%buffer)
if (present(media)) call add_to_buffer(" media="""//trim(media)// """", xf%buffer)
if (present(charset)) call add_to_buffer(" charset="""//trim(charset)// """", xf%buffer)
if (present(alternate)) then
   if (alternate) then
      call add_to_buffer(" alternate=""yes""", xf%buffer)
   else
      call add_to_buffer(" alternate=""no""", xf%buffer)
   endif
endif
call add_to_buffer(" ?>", xf%buffer)

end subroutine xml_AddXMLStylesheet

!-------------------------------------------------------------------
subroutine xml_AddXMLPI(xf, name, data)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in) :: name
character(len=*), intent(in), optional :: data

call add_eol(xf)
call add_to_buffer("<?" // trim(name) // " ", xf%buffer)
if(present(data)) call add_to_buffer(data, xf%buffer)
call add_to_buffer(" ?>", xf%buffer)

end subroutine xml_AddXMLPI


!-------------------------------------------------------------------
subroutine xml_AddComment(xf,comment)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in)  :: comment

call close_start_tag(xf,">")
call add_eol(xf)
call add_to_buffer("<!--", xf%buffer)
call add_to_buffer(comment, xf%buffer)
call add_to_buffer("-->", xf%buffer)
end subroutine xml_AddComment

!-------------------------------------------------------------------
subroutine xml_AddCdataSection(xf,cdata,line_feed)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in)  :: cdata
logical, intent(in), optional :: line_feed

call close_start_tag(xf,">")
call dump_buffer(xf,line_feed)
call add_to_buffer("<![CDATA[", xf%buffer)
call add_to_buffer(cdata, xf%buffer)
call add_to_buffer("]]>", xf%buffer)
call dump_buffer(xf,line_feed)
if (present(line_feed)) then
   if (line_feed) xf%inhibit_lf = .true.
endif
end subroutine xml_AddCdataSection

!-------------------------------------------------------------------
subroutine xml_NewElement(xf,name)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in)  :: name

if (is_empty(xf%stack)) then
   if (xf%root_element_output) call wxml_error(xf, "two root elements")
   xf%root_element_output = .true.
endif

if (.not.check_Name(name)) then
  call wxml_warning(xf, 'attribute name '//name//' is not valid')
endif


call close_start_tag(xf,">")
call push_elstack(name,xf%stack)
call add_eol(xf)
call add_to_buffer("<" // trim(name),xf%buffer)
xf%start_tag_closed = .false.
call reset_dict(xf%dict)

end subroutine xml_NewElement
!-------------------------------------------------------------------
subroutine xml_AddPcdata_Ch(xf,pcdata,space,line_feed)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in)  :: pcdata
logical, intent(in), optional  :: space
logical, intent(in), optional  :: line_feed

logical :: advance_line , advance_space

advance_line = pcdata_advance_line_default 
if (present(line_feed)) then
   advance_line = line_feed
endif

advance_space = pcdata_advance_space_default 
if (present(space)) then
   advance_space = space
endif

if (is_empty(xf%stack)) then
   call wxml_error(xf, "pcdata outside element content")
endif

call close_start_tag(xf,">")

if (advance_line) then
   call add_eol(xf)
   advance_space = .false.
else
   if (xf%indenting_requested) then
      if ((len(xf%buffer) + len_trim(pcdata) + 1) > COLUMNS ) then
         call add_eol(xf)
         advance_space = .false.
      endif
   endif
endif
if (advance_space) call add_to_buffer(" ",xf%buffer)

call add_to_buffer_escaping_markup(pcdata, xf%buffer)

end subroutine xml_AddPcdata_Ch

!-------------------------------------------------------------------
subroutine xml_AddAttribute_Ch(xf,name,value)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in)  :: name
character(len=*), intent(in)  :: value

if (is_empty(xf%stack)) then
   call wxml_error(xf, "attributes outside element content")
endif

if (xf%start_tag_closed)  then
   call wxml_error(xf, "attributes outside start tag")
endif

if (has_key(xf%dict,name)) then
   call wxml_error(xf, "duplicate att name")
endif

call add_item_to_dict(xf%dict, name, value)

end subroutine xml_AddAttribute_Ch

!-----------------------------------------------------------
subroutine xml_EndElement(xf,name)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in)  :: name

character(len=2000)  :: current

if (is_empty(xf%stack)) then
   call wxml_fatal(xf, "Out of elements to close")
endif

call get_top_elstack(xf%stack,current)
if (current /= name) then
   call wxml_fatal(xf, 'Trying to close '//Trim(name)//' but '//Trim(current)//' is open.') 
endif
if (.not. xf%start_tag_closed)  then                ! Empty element
   if (len(xf%dict) > 0) call write_attributes(xf)
   call add_to_buffer(" />",xf%buffer)
   xf%start_tag_closed = .true.
else
   ! This statement will introduce a newline after array data...
   call add_eol(xf)
   call add_to_buffer("</" // trim(name) // ">", xf%buffer)
endif
call pop_elstack(xf%stack,current)

end subroutine xml_EndElement

!----------------------------------------------------------------

subroutine xml_Close(xf)
type(xmlf_t), intent(inout)   :: xf

character(len=2000) :: name

do
   if (is_empty(xf%stack)) exit
   call get_top_elstack(xf%stack,name)
   call xml_EndElement(xf,trim(name))
enddo

write(unit=xf%lun,fmt="(a)") char(xf%buffer)
close(unit=xf%lun)

deallocate(xf%filename)

end subroutine xml_Close

!==================================================================
!-------------------------------------------------------------------
subroutine get_unit(lun,iostat)

! Get an available Fortran unit number

integer, intent(out)  :: lun
integer, intent(out)  :: iostat

integer :: i
logical :: unit_used

do i = 10, 99
   lun = i
   inquire(unit=lun,opened=unit_used)
   if (.not. unit_used) then
      iostat = 0
      return
   endif
enddo
iostat = -1
lun = -1
end subroutine get_unit

!----------------------------------------------------------
subroutine add_eol(xf)
type(xmlf_t), intent(inout)   :: xf

integer :: indent_level


! Flush with a linefeed except if a previous operation has raised
! the inhibit_lf flag

if (xf%inhibit_lf) then
   call dump_buffer(xf,lf=.false.)
   xf%inhibit_lf = .false.
else
   call dump_buffer(xf,lf=.true.)
endif

! In case we still have a zero-length stack, we must make
! sure indent_level is not less than zero.

indent_level = max(len(xf%stack) - 1, 0)
if (xf%indenting_requested) &
   call add_to_buffer(repeat(' ',indent_level),xf%buffer)

end subroutine add_eol
!------------------------------------------------------------
subroutine dump_buffer(xf,lf)
type(xmlf_t), intent(inout)   :: xf
logical, intent(in), optional :: lf

if (present(lf)) then
   if (lf) then
      write(unit=xf%lun,fmt="(a)",advance="yes") char(xf%buffer)
   else
      write(unit=xf%lun,fmt="(a)",advance="no") char(xf%buffer)
   endif
else
   write(unit=xf%lun,fmt="(a)",advance="no") char(xf%buffer)
endif
call reset_buffer(xf%buffer)

end subroutine dump_buffer

!------------------------------------------------------------
subroutine close_start_tag(xf,s)
type(xmlf_t), intent(inout)   :: xf
character(len=*), intent(in)  :: s

if (.not. xf%start_tag_closed)  then
   if (len(xf%dict) > 0)  call write_attributes(xf)
   call add_to_buffer(s, xf%buffer)
   xf%start_tag_closed = .true.
endif

end subroutine close_start_tag

!-------------------------------------------------------------
subroutine write_attributes(xf)
type(xmlf_t), intent(inout)   :: xf

integer  :: i, status, size, key_len, value_len
character(len=2000)  :: key, value

do i = 1, len(xf%dict)
   call get_key(xf%dict,i,key,key_len,status)
   call get_value(xf%dict,i,value,value_len,status)
   size = key_len + value_len + 4
   if ((len(xf%buffer) + size) > COLUMNS) call add_eol(xf)
   call add_to_buffer(" ", xf%buffer)
   call add_to_buffer(key(:key_len), xf%buffer)
   call add_to_buffer("=", xf%buffer)
   call add_to_buffer("""",xf%buffer)
   call add_to_buffer_escaping_markup(value(:value_len), xf%buffer)
   call add_to_buffer("""", xf%buffer)
enddo

end subroutine write_attributes

!---------------------------------------------------------------
    subroutine xml_AddArray_integer(xf,a,format)
      type(xmlf_t), intent(inout)         :: xf
      integer, intent(in), dimension(:)   :: a
      character(len=*), intent(in), optional  :: format

      call close_start_tag(xf,">")
      if (len(xf%buffer) > 0) call dump_buffer(xf,lf=.true.)
      if (present(format)) then
         write(xf%lun,format) a
      else
         write(xf%lun,"(6(i12))") a
      xf%inhibit_lf = .true.
      endif
    end subroutine xml_AddArray_integer

!-------------------------------------------------------------------
    subroutine xml_AddArray_real_dp(xf,a,format)
      type(xmlf_t), intent(inout)         :: xf
      real(kind=dp), intent(in), dimension(:)   :: a
      character(len=*), intent(in), optional  :: format

      call close_start_tag(xf,">")
      if (len(xf%buffer) > 0) call dump_buffer(xf,lf=.true.)
      if (present(format)) then
         write(xf%lun,format) a
      else
         write(xf%lun,"(4(es20.12))") a
      endif
      xf%inhibit_lf = .true.
    end subroutine xml_AddArray_real_dp

!------------------------------------------------------------------
    subroutine xml_AddArray_real_sp(xf,a,format)
      type(xmlf_t), intent(inout)         :: xf
      real(kind=sp), intent(in), dimension(:)   :: a
      character(len=*), intent(in), optional  :: format

      call close_start_tag(xf,">")
      if (len(xf%buffer) > 0) call dump_buffer(xf,lf=.true.)
      if (present(format)) then
         write(xf%lun,format) a
      else
         write(xf%lun,"(4(es20.12))") a
      endif
      xf%inhibit_lf = .true.
    end subroutine xml_AddArray_real_sp

!---------------------------------------------------------
! Error handling/trapping routines:

    subroutine wxml_warning_xf(xf, msg)
      ! Emit warning, but carry on.
      type(xmlf_t), intent(in) :: xf
      character(len=*), intent(in) :: msg

      write(6,'(a)') 'WARNING(wxml) in writing to file ', xmlf_name(xf)
      write(6,'(a)')  msg

    end subroutine wxml_warning_xf

    subroutine wxml_error_xf(xf, msg)
      ! Emit error message, clean up file and stop.
      type(xmlf_t), intent(inout) :: xf
      character(len=*), intent(in) :: msg

      write(6,'(a)') 'ERROR(wxml) in writing to file ', xmlf_name(xf)
      write(6,'(a)')  msg

      call xml_Close(xf)
      stop

    end subroutine wxml_error_xf

    subroutine wxml_fatal_xf(xf, msg)
      !Emit error message and abort with coredump. Does not try to
      !close file, so should be used from anything xml_Close might
      !itself call (to avoid infinite recursion!)

      type(xmlf_t), intent(in) :: xf
      character(len=*), intent(in) :: msg

      write(6,'(a)') 'ERROR(wxml) in writing to file ', xmlf_name(xf)
      write(6,'(a)')  msg

      !call pxfabort
      stop

    end subroutine wxml_fatal_xf

    function xmlf_name(xf) result(fn)
      Type (xmlf_t), intent(in) :: xf
      character(len=size(xf%filename)) :: fn
      call assign_array_to_str(fn,xf%filename)
    end function xmlf_name
      

end module m_wxml_core

module m_dom_attribute

use m_dom_types
use m_dom_node
use m_dom_strings

private
  !-------------------------------------------------------  
  ! METHODS FOR ATTRIBUTE NODES
  !------------------------------------------------------- 

  public :: getName
  public :: getValue
  public :: setValue

CONTAINS

  function getName(attribute)

    type(fnode), intent(in) :: attribute
    type(string)            :: getName

    if (attribute % nodeType == ATTRIBUTE_NODE) then
       getName = attribute%nodeName
    else
       getName = ''
    endif

  end function getName

  !-----------------------------------------------------------

  function getValue(attribute)

    type(fnode), intent(in) :: attribute
    type(string)            :: getValue

    if (attribute % nodeType == ATTRIBUTE_NODE) then
       getValue = attribute%nodeValue
    else
       getValue = ''
    endif

  end function getValue

  !-----------------------------------------------------------

  subroutine setValue(attribute, value)

    character(len=*), intent(in) :: value
    type(fnode), pointer  :: attribute

    if (attribute % nodeType == ATTRIBUTE_NODE) then
       call setNodeValue(attribute,value)
    endif

  end subroutine setValue

  !-----------------------------------------------------------


!!! NB Is this a good idea?
!!! NB pure functions have no side effects

  pure function attr_name_len(attribute)
    type(fnode), intent(in) :: attribute
    integer :: attr_name_len
    if (attribute % nodeType == ATTRIBUTE_NODE) then
       attr_name_len = len_trim(attribute % nodeName)
    else
       attr_name_len = 0
    end if
  end function attr_name_len
  
  pure function attr_val_len(attribute)   
    type(fnode), intent(in) :: attribute
    integer :: attr_val_len
    if (attribute % nodeType == ATTRIBUTE_NODE) then
       attr_val_len = len_trim(attribute % nodeValue)
    else
       attr_val_len = 0
    end if
  end function attr_val_len


end module m_dom_attribute

program item_context
use xmlf90_xpath

type(xml_t) :: fxml, context

integer  :: status
character(len=100)  :: what, price, currency
type(dictionary_t)  :: attributes

call open_xmlfile(XPATH_DATA_DIR//"inventory.xml",fxml,status)
!
do
  call mark_node(fxml,path="//item",status=status)
  if (status < 0)   exit      ! No more items
  context = fxml               ! Save item context   
  !
  ! Search relative to context
  !
  call get_node(fxml,path="price", &
                attributes=attributes,pcdata=price,status=status)
  call get_value(attributes,"currency",currency,status)
  if (status /= 0) stop "missing currency attribute!"
  !
  ! Rewind to beginning of context
  !
  fxml = context
  call sync_xmlfile(fxml,status)  
  !
  ! Search relative to context
  !
  call get_node(fxml,path="description",pcdata=what,status=status)
  write(unit=*,fmt="(6a)") "Appliance: ", trim(what), &
                            ". Price: ", trim(price), " ", trim(currency)
enddo
end program item_context

module m_sax_fsm
!
use m_sax_buffer
use m_sax_dictionary
use m_sax_charset
use m_sax_entities
use m_sax_elstack

private

type, public :: fsm_t
      !
      ! Contains information about the "finite state machine"
      ! Some of the components (marked *) could at this point be made into
      ! saved module variables.
      ! 
      !
      integer              :: state
      integer              :: context
      integer              :: nbrackets             !*
      integer              :: nlts                  !*
      character(len=1)     :: quote_char            !*
      type(buffer_t)       :: buffer                !*
      type(buffer_t)       :: tmpbuf                !*
      type(buffer_t)       :: element_name
      type(dictionary_t)   :: attributes
      type(buffer_t)       :: pcdata
      logical              :: entities_in_pcdata
      logical              :: entities_in_attributes
      type(elstack_t)      :: element_stack
      logical              :: root_element_seen
      type(buffer_t)       :: root_element_name
      character(len=150)   :: action
      logical              :: debug
end type fsm_t

public :: init_fsm, reset_fsm, evolve_fsm

!
! State parameters
!
integer, parameter, public   ::  ERROR = -1
integer, parameter, public   ::  INIT = 1         
integer, parameter, private  ::  START_TAG_MARKER = 2
integer, parameter, private  ::  END_TAG_MARKER = 3
integer, parameter, private  ::  IN_NAME = 4
integer, parameter, private  ::  WHITESPACE_IN_TAG = 5
integer, parameter, private  ::  IN_PCDATA = 6
integer, parameter, private  ::  SINGLETAG_MARKER = 7
integer, parameter, private  ::  CLOSINGTAG_MARKER = 8
integer, parameter, private  ::  IN_COMMENT = 9
integer, parameter, private  ::  IN_ATT_NAME = 10
integer, parameter, private  ::  IN_ATT_VALUE = 11
integer, parameter, private  ::  EQUAL = 12
integer, parameter, private  ::  SPACE_AFTER_EQUAL = 13
integer, parameter, private  ::  SPACE_BEFORE_EQUAL = 14
integer, parameter, private  ::  START_QUOTE = 15
integer, parameter, private  ::  END_QUOTE = 16
integer, parameter, private  ::  BANG = 17
integer, parameter, private  ::  BANG_HYPHEN = 18
integer, parameter, private  ::  ONE_HYPHEN = 19
integer, parameter, private  ::  TWO_HYPHEN = 20
integer, parameter, private  ::  QUESTION_MARK = 21
integer, parameter, private  ::  START_XML_DECLARATION = 22
integer, parameter, private  ::  IN_SGML_DECLARATION = 23
integer, parameter, private  ::  IN_CDATA_SECTION = 24
integer, parameter, private  ::  ONE_BRACKET = 25
integer, parameter, private  ::  TWO_BRACKET = 26
integer, parameter, private  ::  CDATA_PREAMBLE = 27
integer, parameter, private  ::  IN_PCDATA_AT_EOL = 30
!
! Context parameters
!
integer, parameter, public   ::  OPENING_TAG  = 100
integer, parameter, public   ::  CLOSING_TAG  = 110
integer, parameter, public   ::  SINGLE_TAG   = 120
integer, parameter, public   ::  COMMENT_TAG  = 130
integer, parameter, public   ::  XML_DECLARATION_TAG  = 140
integer, parameter, public   ::  SGML_DECLARATION_TAG  = 150
integer, parameter, public   ::  CDATA_SECTION_TAG  = 160
integer, parameter, public   ::  NULL_CONTEXT          = 200
!
! Signal parameters
!
integer, parameter, public   ::  QUIET             = 1000
integer, parameter, public   ::  END_OF_TAG        = 1100
integer, parameter, public   ::  CHUNK_OF_PCDATA   = 1200
integer, parameter, public   ::  CHUNK_OF_CDATA_SECTION  = 1300
integer, parameter, public   ::  EXCEPTION         = 1500

CONTAINS

!------------------------------------------------------------
! Initialize once and for all the derived types (Fortran90 restriction)
!
subroutine init_fsm(fx) 
type(fsm_t), intent(inout)   :: fx

 fx%state = INIT
 call setup_xml_charsets()
 fx%context = NULL_CONTEXT
 call init_elstack(fx%element_stack)
 fx%root_element_seen = .false.
 fx%debug = .false.
 fx%entities_in_pcdata = .false.
 fx%entities_in_attributes = .false.
 fx%action = ""
 call init_buffer(fx%buffer)
 call init_buffer(fx%element_name)
 call init_buffer(fx%pcdata)
 call init_buffer(fx%root_element_name)
 call init_dict(fx%attributes)
end subroutine init_fsm
!------------------------------------------------------------
subroutine reset_fsm(fx) 
type(fsm_t), intent(inout)   :: fx

 fx%state = INIT
 call setup_xml_charsets()
 fx%context = NULL_CONTEXT
 call reset_elstack(fx%element_stack)
 fx%action = ""
 fx%root_element_seen = .false.
 call reset_buffer(fx%buffer)
 call reset_buffer(fx%element_name)
 call reset_buffer(fx%pcdata)
 call reset_buffer(fx%root_element_name)
 call reset_dict(fx%attributes)
end subroutine reset_fsm

!------------------------------------------------------------
subroutine evolve_fsm(fx,c,signal)
!
! Finite-state machine evolution rules for XML parsing.
!
type(fsm_t), intent(inout)      :: fx    ! Internal state
character(len=1), intent(in)    :: c
integer, intent(out)            :: signal

integer :: filter_stat
character(len=100) :: filter_msg
!
! Reset signal
!
signal = QUIET
!

if (.not. (c .in. valid_chars)) then
!
!      Let it pass (in case the underlying encoding is UTF-8)
!      But this chars in a name will cause havoc
!
!      signal = EXCEPTION
!      fx%state = ERROR
!      fx%action = trim("Not a valid character in simple encoding: "//c)
!      RETURN
endif

select case(fx%state)

 case (INIT)
      if (c == "<") then
         fx%state = START_TAG_MARKER
         if (fx%debug) fx%action = ("Starting tag")
      else if (c == ">") then
         fx%state = ERROR
         fx%action = ("Ending tag without being in one!")
      else
         if (fx%debug) fx%action = ("Reading garbage chars")
      endif

 case (START_TAG_MARKER)
      if (c == ">") then
         fx%state = ERROR
         fx%action = ("Tag empty!")
      else if (c == "<") then
         fx%state = ERROR
         fx%action = ("Double opening of tag!!")
      else if (c == "/") then
         fx%state = CLOSINGTAG_MARKER
         if (fx%debug) fx%action = ("Starting endtag: ")
         fx%context = CLOSING_TAG
      else if (c == "?") then
         fx%state = START_XML_DECLARATION
         if (fx%debug) fx%action = ("Starting XML declaration ")
         fx%context = XML_DECLARATION_TAG
      else if (c == "!") then
         fx%state = BANG
         if (fx%debug) fx%action = ("Saw ! -- comment or SGML declaration expected...")
      else if (c .in. whitespace) then
         fx%state = ERROR
         fx%action = ("Cannot have whitespace after <")
      else if (c .in. initial_name_chars) then
         fx%context = OPENING_TAG
         fx%state = IN_NAME
         call add_to_buffer(c,fx%buffer)
         if (fx%debug) fx%action = ("Starting to read name in tag")
      else 
         fx%state = ERROR
         fx%action = ("Illegal initial character for name")
      endif


 case (BANG)
      if (c == "-") then
         fx%state = BANG_HYPHEN
         if (fx%debug) fx%action = ("Almost ready to start comment ")
      else if (c .in. uppercase_chars) then
         fx%state = IN_SGML_DECLARATION
         fx%nlts = 0
         fx%nbrackets = 0
         if (fx%debug) fx%action = ("SGML declaration ")
         fx%context = SGML_DECLARATION_TAG
         call add_to_buffer(c,fx%buffer)
      else if (c == "[") then
         fx%state = CDATA_PREAMBLE
         if (fx%debug) fx%action = ("Declaration with [ ")
         fx%context = CDATA_SECTION_TAG
      else
         fx%state = ERROR
         fx%action = ("Wrong character after ! ")
      endif

 case (CDATA_PREAMBLE)
      ! We assume a CDATA[ is forthcoming, we do not check
      if (c == "[") then
         fx%state = IN_CDATA_SECTION
         if (fx%debug) fx%action = ("About to start reading CDATA contents")
      else if (c == "]") then
         fx%state = ERROR
         fx%action = ("Unexpected ] in CDATA preamble")
      else
         if (fx%debug) fx%action = ("Reading CDATA preamble")
      endif

 case (IN_CDATA_SECTION)
      if (c == "]") then
         fx%state = ONE_BRACKET
         if (fx%debug) fx%action = ("Saw a ] in CDATA section")
      else
         ! Check whether we are close to the end of the buffer. 
         ! If so, make a chunk and reset the buffer
         ! Note that we do not split in whitespace (there might not be)
         call add_to_buffer(c,fx%buffer)
         if (buffer_nearly_full(fx%buffer)) then
               signal = CHUNK_OF_CDATA_SECTION
               if (fx%debug) fx%action = ("Resetting almost full CDATA buffer")
               fx%pcdata = fx%buffer
               call reset_buffer(fx%buffer)
         else
            if (fx%debug) fx%action = ("Reading contents of CDATA section")
         endif
      endif

 case (ONE_BRACKET)
      if (c == "]") then
         fx%state = TWO_BRACKET
         if (fx%debug) fx%action = ("Maybe finish a CDATA section")
      else
         fx%state = IN_CDATA_SECTION
         call add_to_buffer("]",fx%buffer)
         if (fx%debug) fx%action = ("Continue reading contents of CDATA section")
      endif

 case (TWO_BRACKET)
      if (c == ">") then
         fx%state = END_TAG_MARKER
         signal = CHUNK_OF_CDATA_SECTION
         if (fx%debug) fx%action = ("End of CDATA section")
         fx%pcdata = fx%buffer    ! Not quite the same behavior
                                  ! as pcdata... (not filtered)
         call reset_buffer(fx%buffer)
      else
         fx%state = IN_CDATA_SECTION
         call add_to_buffer("]",fx%buffer)
         if (fx%debug) fx%action = ("Continue reading contents of CDATA section")
      endif

 case (IN_SGML_DECLARATION)
      if (c == "<") then
         fx%nlts = fx%nlts + 1
         call add_to_buffer("<",fx%buffer)
         fx%action = "Read an intermediate < in SGML declaration"
      else if (c == "[") then
         fx%nbrackets = fx%nbrackets + 1
         call add_to_buffer("[",fx%buffer)
         fx%action = "Read a [ in SGML declaration"
      else if (c == "]") then
         fx%nbrackets = fx%nbrackets - 1
         call add_to_buffer("]",fx%buffer)
         fx%action = "Read a ] in SGML declaration"
      else if (c == ">") then
         if (fx%nlts == 0) then
            if (fx%nbrackets == 0) then
               fx%state = END_TAG_MARKER
               signal  = END_OF_TAG
               if (fx%debug) fx%action = ("Ending SGML declaration tag")
               fx%pcdata = fx%buffer       ! Same behavior as pcdata
               call reset_buffer(fx%buffer)
            else
               fx%state = ERROR
               fx%action = ("Unmatched ] in SGML declaration")
            endif
         else
            fx%nlts = fx%nlts -1
            call add_to_buffer(">",fx%buffer)
            fx%action = "Read an intermediate > in SGML declaration"
         endif
      else
         if (fx%debug) fx%action = ("Keep reading SGML declaration")
         call add_to_buffer(c,fx%buffer)
      endif

 case (BANG_HYPHEN)
      if (c == "-") then
         fx%state = IN_COMMENT
         fx%context = COMMENT_TAG
         if (fx%debug) fx%action = ("In comment ")
      else
         fx%state = ERROR
         fx%action = ("Wrong character after <!- ")
      endif

 case (START_XML_DECLARATION)
      if (c .in. initial_name_chars) then
         fx%state = IN_NAME
         call add_to_buffer(c,fx%buffer)
         if (fx%debug) fx%action = ("Starting to read name in XML declaration")
      else
         fx%state = ERROR
         fx%action = "Wrong character after ? in start of XML declaration"
      endif

 case (CLOSINGTAG_MARKER)
      if (c == ">") then
         fx%state = ERROR
         fx%action = ("Closing tag empty!")
      else if (c == "<") then
         fx%state = ERROR
         fx%action = ("Double opening of closing tag!!")
      else if (c == "/") then
         fx%state = ERROR
         fx%action = ("Syntax error (<//)")
      else if (c .in. whitespace) then
         fx%state = ERROR
         fx%action = ("Cannot have whitespace after </")
      else if (c .in. initial_name_chars) then
         fx%state = IN_NAME
         if (fx%debug) fx%action = ("Starting to read name inside endtag")
         call add_to_buffer(c,fx%buffer)
      else 
         fx%state = ERROR
         fx%action = ("Illegal initial character for name")
      endif

 case (IN_NAME)
      if (c == "<") then
         fx%state = ERROR
         fx%action = ("Starting tag within tag")
      else if (c == ">") then
         fx%state = END_TAG_MARKER
         signal  = END_OF_TAG
         if (fx%debug) fx%action = ("Ending tag")
!         call set_element_name(fx%buffer,fx%element)
         fx%element_name = fx%buffer
         call reset_buffer(fx%buffer)
         call reset_dict(fx%attributes)
      else if (c == "/") then
         if (fx%context /= OPENING_TAG) then
            fx%state = ERROR
            fx%action = ("Single tag did not open as start tag")
         else 
            fx%state = SINGLETAG_MARKER
            fx%context = SINGLE_TAG
            if (fx%debug) fx%action = ("Almost ending single tag")
!            call set_element_name(fx%buffer,fx%element)
            fx%element_name = fx%buffer
            call reset_buffer(fx%buffer)
            call reset_dict(fx%attributes)
         endif
      else if (c .in. whitespace) then
         fx%state = WHITESPACE_IN_TAG
         if (fx%debug) fx%action = ("Ending name chars")
!            call set_element_name(fx%buffer,fx%element)
         fx%element_name = fx%buffer
         call reset_buffer(fx%buffer)
         call reset_dict(fx%attributes)
      else if (c .in. name_chars) then
         if (fx%debug) fx%action = ("Reading name chars in tag")
         call add_to_buffer(c,fx%buffer)
      else
         fx%state = ERROR
         fx%action = ("Illegal character for name")
      endif

 case (IN_ATT_NAME)
      if (c == "<") then
         fx%state = ERROR
         fx%action = ("Starting tag within tag")
      else if (c == ">") then
         fx%state = ERROR
         fx%action = ("Ending tag in the middle of an attribute")
      else if (c == "/") then
         fx%state = ERROR
         fx%action = ("Ending tag in the middle of an attribute")
      else if (c .in. whitespace) then
         fx%state = SPACE_BEFORE_EQUAL  
         if (fx%debug) fx%action = ("Whitespace after attr. name (specs?)")
         call add_key_to_dict(fx%buffer,fx%attributes)
         call reset_buffer(fx%buffer)
      else if ( c == "=" ) then
         fx%state = EQUAL
         if (fx%debug) fx%action = ("End of attr. name")
         call add_key_to_dict(fx%buffer,fx%attributes)
         call reset_buffer(fx%buffer)
      else if (c .in. name_chars) then
         if (fx%debug) fx%action = ("Reading attribute name chars")
         call add_to_buffer(c,fx%buffer)
      else
         fx%state = ERROR
         fx%action = ("Illegal character for attribute name")
      endif

 case (EQUAL)
      if ( (c == """") .or. (c == "'") ) then
         fx%state = START_QUOTE
         if (fx%debug) fx%action = ("Found beginning quote")
         fx%quote_char = c
      else if (c .in. whitespace) then
         fx%state = SPACE_AFTER_EQUAL
         if (fx%debug) fx%action = ("Whitespace after equal sign...")
      else
         fx%state = ERROR
         fx%action = ("Must use quotes for attribute values")
      endif

 case (SPACE_BEFORE_EQUAL)
      if ( c == "=" ) then
         fx%state = EQUAL
         if (fx%debug) fx%action = ("Equal sign")
      else if (c .in. whitespace) then
         if (fx%debug) fx%action = ("More whitespace before equal sign...")
      else
         fx%state = ERROR
         fx%action = ("Must use equal sign for attribute values")
      endif

 case (SPACE_AFTER_EQUAL)
      if ( c == "=" ) then
         fx%state = ERROR
         fx%action = ("Duplicate Equal sign")
      else if (c .in. whitespace) then
         if (fx%debug) fx%action = ("More whitespace after equal sign...")
      else  if ( (c == """") .or. (c == "'") ) then
         fx%state = START_QUOTE
         fx%quote_char = c
         if (fx%debug) fx%action = ("Found beginning quote")
      else
         fx%state = ERROR
         fx%action = ("Must use quotes for attribute values")
      endif

 case (START_QUOTE)
      if (c == fx%quote_char) then
         fx%state = END_QUOTE
         if (fx%debug) fx%action = ("Emtpy attribute value...")
         if (fx%entities_in_attributes) then
            call entity_filter(fx%buffer,fx%tmpbuf)
            fx%entities_in_attributes = .false.
            call add_value_to_dict(fx%tmpbuf,fx%attributes)
         else
            call add_value_to_dict(fx%buffer,fx%attributes)
         endif
         call reset_buffer(fx%buffer)
      else if (c == "<") then
         fx%state = ERROR
         fx%action = ("Attribute value cannot contain <")
      else   ! actually allowed chars in att values... Specs: No "<"        
         fx%state = IN_ATT_VALUE
         if (fx%debug) fx%action = ("Starting to read attribute value")
         if (c == "&") fx%entities_in_attributes = .true.
         call add_to_buffer(c,fx%buffer)
      endif

 case (IN_ATT_VALUE)
      if (c == fx%quote_char) then
         fx%state = END_QUOTE
         if (fx%debug) fx%action = ("End of attribute value")
         if (fx%entities_in_attributes) then
            call entity_filter(fx%buffer,fx%tmpbuf,filter_stat,filter_msg)
            if (filter_stat /= 0) then
              fx%state = ERROR   
              fx%action = trim(filter_msg) // " (at attribute value)"
            endif
            fx%entities_in_attributes = .false.
            call add_value_to_dict(fx%tmpbuf,fx%attributes)
         else
            call add_value_to_dict(fx%buffer,fx%attributes)
         endif
         call reset_buffer(fx%buffer)
      else if (c == "<") then
         fx%state = ERROR
         fx%action = ("Attribute value cannot contain <")
      else if ( (c == char(10)) ) then
         fx%state = ERROR
!
!        Aparently other whitespace is allowed...
!
         fx%action = ("No newline allowed in attr. value (specs?)")
      else        ! all other chars allowed in attr value
         if (fx%debug) fx%action = ("Reading attribute value chars")
         call add_to_buffer(c,fx%buffer)
         if (c == "&") fx%entities_in_attributes = .true.
      endif

 case (END_QUOTE)
      if ((c == """") .or. (c == "'")) then
         fx%state = ERROR
         fx%action = ("Duplicate end quote")
      else if (c .in. whitespace) then
         fx%state = WHITESPACE_IN_TAG
         if (fx%debug) fx%action = ("Space in between attributes or to end of tag")
      else if (c == "<") then
         fx%state = ERROR
         fx%action = ("Starting tag within tag")
      else if (c == ">") then
         if (fx%context == XML_DECLARATION_TAG) then
            fx%state = ERROR
            fx%action = "End of XML declaration without ?"
         else
            fx%state = END_TAG_MARKER
            signal  = END_OF_TAG
            if (fx%debug) fx%action = ("Ending tag after some attributes")
         endif
      else if (c == "/") then
         if (fx%context /= OPENING_TAG) then
            fx%state = ERROR
            fx%action = ("Single tag did not open as start tag")
         else 
            fx%state = SINGLETAG_MARKER
            fx%context = SINGLE_TAG
            if (fx%debug) fx%action = ("Almost ending single tag after some attributes")
         endif
      else if (c == "?") then
         if (fx%context /= XML_DECLARATION_TAG) then
            fx%state = ERROR
            fx%action = "Wrong lone ? in tag"
         else
            fx%state = QUESTION_MARK
            if (fx%debug) fx%action = ("About to end XML declaration")
         endif
      else   
         fx%state = ERROR
         fx%action = ("Must have some whitespace after att. value")
      endif


 case (WHITESPACE_IN_TAG)
      if ( c .in. whitespace) then
         if (fx%debug) fx%action = ("Reading whitespace in tag")
      else if (c == "<") then
         fx%state = ERROR
         fx%action = ("Starting tag within tag")
      else if (c == ">") then
         if (fx%context == XML_DECLARATION_TAG) then
            fx%state = ERROR
            fx%action = "End of XML declaration without ?"
         else
            fx%state = END_TAG_MARKER
            signal  = END_OF_TAG
            if (fx%debug) fx%action = ("End whitespace in tag")
         endif
      else if (c == "/") then
         if (fx%context /= OPENING_TAG) then
            fx%state = ERROR
            fx%action = ("Single tag did not open as start tag")
         else 
            fx%state = SINGLETAG_MARKER
            fx%context = SINGLE_TAG
            if (fx%debug) fx%action = ("End whitespace in single tag")
         endif
      else if (c .in. initial_name_chars) then
         fx%state = IN_ATT_NAME
         if (fx%debug) fx%action = ("Starting Attribute name in tag")
         call add_to_buffer(c,fx%buffer)
      else if (c == "?") then
         if (fx%context /= XML_DECLARATION_TAG) then
            fx%state = ERROR
            fx%action = "Wrong lone ? in tag"
         else
            fx%state = QUESTION_MARK
            if (fx%debug) fx%action = ("About to end XML declaration after whitespace")
         endif
      else
         fx%state = ERROR
         fx%action = ("Illegal initial character for attribute")
      endif

 case (QUESTION_MARK)
      if (c == ">") then
         fx%state = END_TAG_MARKER
         signal  = END_OF_TAG
         if (fx%debug) fx%action = ("End of XML declaration tag")
      else
         fx%state = ERROR
         fx%action = "No > after ? in XML declaration tag"
      endif

 case (IN_COMMENT)
      !
      ! End of comment is  "-->", and  ">" can appear inside comments
      !
      if (c == "-") then
         fx%state = ONE_HYPHEN
         if (fx%debug) fx%action = ("Saw - in Comment")
      else
         if (fx%debug) fx%action = ("Reading comment")
         call add_to_buffer(c,fx%buffer)
      endif

 case (ONE_HYPHEN)
      if (c == "-") then
         fx%state = TWO_HYPHEN
         if (fx%debug) fx%action = ("About to end comment")
      else
         fx%state = IN_COMMENT
         if (fx%debug) fx%action = ("Keep reading comment after -: ")
         call add_to_buffer("-",fx%buffer)
         call add_to_buffer(c,fx%buffer)
      endif

 case (TWO_HYPHEN)
      if (c == ">") then
         fx%state = END_TAG_MARKER
         signal  = END_OF_TAG
         if (fx%debug) fx%action = ("End of Comment")
         fx%pcdata = fx%buffer                  ! Same behavior as pcdata
         call reset_buffer(fx%buffer)
      else
         fx%state = ERROR
         fx%action = ("Cannot have -- in comment")
      endif

 case (SINGLETAG_MARKER)

      if (c == ">") then
         fx%state = END_TAG_MARKER
         signal  = END_OF_TAG
         if (fx%debug) fx%action = ("Ending tag")
         ! We have to call begin_element AND end_element
      else 
         fx%state = ERROR
         fx%action = ("Wrong ending of single tag")
      endif

 case (IN_PCDATA)
      if (c == "<") then
         fx%state = START_TAG_MARKER
         signal = CHUNK_OF_PCDATA
         if (fx%debug) fx%action = ("End of pcdata -- Starting tag")
         if (fx%entities_in_pcdata) then
            call entity_filter(fx%buffer,fx%pcdata,filter_stat,filter_msg)
            if (filter_stat /= 0) then
              fx%state = ERROR   
              fx%action = trim(filter_msg) // " (at end of pcdata)"
            endif
            fx%entities_in_pcdata = .false.
         else
            fx%pcdata = fx%buffer
         endif
         call reset_buffer(fx%buffer)
      else if (c == ">") then
         fx%state = ERROR
         fx%action = ("Ending tag without starting it!")
      else if  (c == char(10)) then
         fx%state = IN_PCDATA_AT_EOL
         signal = CHUNK_OF_PCDATA
         if (fx%debug) fx%action = ("Resetting PCDATA buffer at newline")
         call add_to_buffer(c,fx%buffer)
         if (fx%entities_in_pcdata) then
            call entity_filter(fx%buffer,fx%pcdata,filter_stat,filter_msg)
            if (filter_stat /= 0) then
              fx%state = ERROR   
              fx%action = trim(filter_msg) // " (at pcdata buffer nl reset)"
            endif
            fx%entities_in_pcdata = .false.
         else
            fx%pcdata = fx%buffer
         endif
         call reset_buffer(fx%buffer)
      else
         call add_to_buffer(c,fx%buffer)
         if (c=="&") fx%entities_in_pcdata = .true.
         if (fx%debug) fx%action = ("Reading pcdata")
         !
         ! Check whether we are close to the end of the buffer. 
         ! If so, make a chunk and reset the buffer
         if (c .in. whitespace) then
            if (buffer_nearly_full(fx%buffer)) then
               signal = CHUNK_OF_PCDATA
               if (fx%debug) fx%action = ("Resetting almost full PCDATA buffer")
               if (fx%entities_in_pcdata) then
                  call entity_filter(fx%buffer,fx%pcdata,filter_stat,filter_msg)
                  if (filter_stat /= 0) then
                     fx%state = ERROR   
                     fx%action = trim(filter_msg) // " (at pcdata full buff reset)"
                  endif
                  fx%entities_in_pcdata = .false.
               else
                  fx%pcdata = fx%buffer
               endif
               call reset_buffer(fx%buffer)
            endif
         endif
      endif

 case (IN_PCDATA_AT_EOL)
      !
      ! Avoid triggering an extra pcdata event
      !
      if (c == "<") then
         fx%state = START_TAG_MARKER
         if (fx%debug) fx%action = ("No more pcdata after eol-- Starting tag")
      else if (c == ">") then
         fx%state = ERROR
         fx%action = ("Ending tag without starting it!")
      else if  (c == char(10)) then
         fx%state = IN_PCDATA_AT_EOL
         signal = CHUNK_OF_PCDATA
         if (fx%debug) fx%action = ("Resetting PCDATA buffer at repeated newline")
         call add_to_buffer(c,fx%buffer)
         if (fx%entities_in_pcdata) then
            call entity_filter(fx%buffer,fx%pcdata,filter_stat,filter_msg)
            if (filter_stat /= 0) then
              fx%state = ERROR   
              fx%action = trim(filter_msg) // " (at pcdata buff reset at repeated nl)"
            endif
            fx%entities_in_pcdata = .false.
         else
            fx%pcdata = fx%buffer
         endif
         call reset_buffer(fx%buffer)
      else
         fx%state = IN_PCDATA
         call add_to_buffer(c,fx%buffer)
         if (c=="&")  fx%entities_in_pcdata = .true.
         if (fx%debug) fx%action = ("Resuming reading pcdata after EOL")
         !
         ! Check whether we are close to the end of the buffer. 
         ! If so, make a chunk and reset the buffer
         if (c .in. whitespace) then
            if (buffer_nearly_full(fx%buffer)) then
               signal = CHUNK_OF_PCDATA
               if (fx%debug) fx%action = ("Resetting almost full PCDATA buffer")
               if (fx%entities_in_pcdata) then
                  call entity_filter(fx%buffer,fx%pcdata,filter_stat,filter_msg)
                  if (filter_stat /= 0) then
                     fx%state = ERROR   
                     fx%action = trim(filter_msg) // " (at pcdata buff almost full)"
                  endif
                  fx%entities_in_pcdata = .false.
               else
                  fx%pcdata = fx%buffer
               endif
               call reset_buffer(fx%buffer)
            endif
         endif
      endif



 case (END_TAG_MARKER)
!
      if (c == "<") then
         fx%state = START_TAG_MARKER
         if (fx%debug) fx%action = ("Starting tag")
      else if (c == ">") then
         fx%state = ERROR
         fx%action = ("Double ending of tag!")
!
!     We should make this whitespace in general (maybe not?
!     how about indentation in text chunks?)
!     See specs.
!
      else if (c == char(10)) then
        ! Ignoring LF after end of tag is probably non standard...

         if (fx%debug) &
            fx%action = ("---------Discarding newline after end of tag")

        !!!  New code for full compliance
        ! fx%state = IN_PCDATA_AT_EOL
        ! call add_to_buffer(c,fx%buffer)
        ! if (fx%debug) &
        !    fx%action = ("Found LF after end of tag. Emitting PCDATA event")
        ! signal = CHUNK_OF_PCDATA
        ! if (fx%entities_in_pcdata) then
        !    call entity_filter(fx%buffer,fx%pcdata) ... filter_stat, filter_msg...
        !    fx%entities_in_pcdata = .false.
        ! else
        !    fx%pcdata = fx%buffer
        ! endif
        ! call reset_buffer(fx%buffer)
      else
         fx%state = IN_PCDATA
         call add_to_buffer(c,fx%buffer)
         if (c=="&") fx%entities_in_pcdata = .true.
         if (fx%debug) fx%action = ("End of Tag. Starting to read PCDATA")
      endif

 case (ERROR)

      stop "Cannot continue after parsing errors!"

 end select

if (fx%state == ERROR) signal  = EXCEPTION

end subroutine evolve_fsm

end module m_sax_fsm

program text
!
! Example of XPATH-lite  processing
!
use xmlf90_xpath

type(xml_t) :: fxml

integer  :: status
character(len=100)  :: title

call open_xmlfile(XPATH_DATA_DIR//"Ba.xml",fxml,status)
if (status /=0) then
   print * , "Cannot open file."
   stop
endif

!call enable_debug(sax=.false.)

!
! Search for and print all "title" elements
!
do
      call get_node(fxml,path="//title",pcdata=title,status=status)
      if (status /= 0)  then
         exit
      else
         print *, "Title found: ", trim(title)
      endif
enddo

end program text

MODULE m_wstml

  use xmlf90_wxml, only: xmlf_t
  use xmlf90_wxml, only: str, xml_AddArray
  use xmlf90_wxml, only: xml_NewElement, xml_AddPcData, xml_AddAttribute
  use xmlf90_wxml, only: xml_EndElement, xml_AddComment

  implicit none

  private


  integer, private, parameter ::  sp = selected_real_kind(6,30)
  integer, private, parameter ::  dp = selected_real_kind(14,100)


  PUBLIC :: stmAddScalar
  PUBLIC :: stmAddArray
  PUBLIC :: stmAddMatrix
  PUBLIC :: stmAddTriangle
  PUBLIC :: stmAddStartTag

  INTERFACE stmAddScalar
     MODULE PROCEDURE stmAddString
     MODULE PROCEDURE stmAddInteger
     MODULE PROCEDURE stmAddFloatSP
     MODULE PROCEDURE stmAddFloatDP
     MODULE PROCEDURE stmAddLogical
  END INTERFACE

  INTERFACE stmAddArray
     MODULE PROCEDURE stmAddStringArray
     MODULE PROCEDURE stmAddIntegerArray
     MODULE PROCEDURE stmAddFloatArraySP
     MODULE PROCEDURE stmAddFloatArrayDP
     MODULE PROCEDURE stmAddLogicalArray
  END INTERFACE

  INTERFACE stmAddMatrix
     MODULE PROCEDURE stmAddStringMatrix
     MODULE PROCEDURE stmAddIntegerMatrix
     MODULE PROCEDURE stmAddFloatMatrixSP
     MODULE PROCEDURE stmAddFloatMatrixDP
  END INTERFACE

  INTERFACE stmAddTriangle
     MODULE PROCEDURE stmAddTriangleSP
     MODULE PROCEDURE stmAddTriangleDP
  END INTERFACE

 
CONTAINS
  
  
  ! =================================================
  ! STMML convenience routines
  ! =================================================
  
  ! -------------------------------------------------
  ! create STMML start tag in xml channel
  ! -------------------------------------------------
  
  SUBROUTINE stmAddStartTag(xf, name, id, title, dictref, dataType, &
       convention, errorValue, errorBasis, min, max, units)

    implicit none
    type(xmlf_t) :: xf
    character(len=*), intent(in) :: name                   ! the element name
    character(len=*), intent(in), optional :: id           ! the element id; if whitespace, is omitted
    character(len=*), intent(in), optional :: title        ! the title; if whitespace, is omitted
    character(len=*), intent(in), optional :: dictref      ! the dictionary reference; if whitespace, is omitted
    character(len=*), intent(in), optional :: dataType  
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, name)
    if (present(id))         call xml_AddAttribute(xf, 'id', id)
    if (present(title))      call xml_AddAttribute(xf, 'title', title)
    if (present(dictref))    call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(dataType))   call xml_AddAttribute(xf, 'dataType', dataType)
    if (present(convention)) call xml_AddAttribute(xf, 'convention', convention)
    if (present(errorValue)) call xml_AddAttribute(xf, 'errorValue', errorValue)
    if (present(errorBasis)) call xml_AddAttribute(xf, 'errorBasis', errorBasis)
    if (present(min))        call xml_AddAttribute(xf, 'min', min)
    if (present(max))        call xml_AddAttribute(xf, 'max', max)
    if (present(units))      call xml_AddAttribute(xf, 'units', units)

  END SUBROUTINE stmAddStartTag


  ! -------------------------------------------------
  ! outputs STMML scalar in xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddString(xf, value, id, title, dictref, dataType, &
       convention, errorValue, errorBasis, min, max, units)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    character(len=*), intent(in)           :: value         ! the value to be output
    character(len=*), intent(in), optional :: id            ! the id
    character(len=*), intent(in), optional :: title         ! the title
    character(len=*), intent(in), optional :: dictref       ! the dictionary reference
    character(len=*), intent(in), optional :: dataType  
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'scalar')
    if (present(id))         call xml_AddAttribute(xf, 'id', id)
    if (present(title))      call xml_AddAttribute(xf, 'title', title)
    if (present(dictref))    call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(dataType))   call xml_AddAttribute(xf, 'dataType', dataType)
    if (present(convention)) call xml_AddAttribute(xf, 'convention', convention)
    if (present(errorValue)) call xml_AddAttribute(xf, 'errorValue', errorValue)
    if (present(errorBasis)) call xml_AddAttribute(xf, 'errorBasis', errorBasis)
    if (present(min))        call xml_AddAttribute(xf, 'min', min)
    if (present(max))        call xml_AddAttribute(xf, 'max', max)
    if (present(units))      call xml_AddAttribute(xf, 'units', units)
    call xml_AddPcdata(xf, value, line_feed=.false.)
    call xml_EndElement(xf, 'scalar')

  END SUBROUTINE stmAddString

  ! -------------------------------------------------
  ! outputs STMML logical in xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddLogical(xf, value, id, title, dictref, dataType, &
       convention, errorValue, errorBasis, min, max, units)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    logical,          intent(in)           :: value        ! the value to be output
    character(len=*), intent(in), optional :: id           ! the id
    character(len=*), intent(in), optional :: title        ! the title
    character(len=*), intent(in), optional :: dictref      ! the dictionary reference
    character(len=*), intent(in), optional :: dataType  
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: units        ! units (default = none)

    call stmAddString(xf, str(value), id, title, dictref, dataType, &
       convention, errorValue, errorBasis, min, max, units)

  END SUBROUTINE stmAddLogical


  ! -------------------------------------------------
  ! outputs STMML integer in xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddInteger(xf, value, id, title, dictref, dataType, &
       convention, errorValue, errorBasis, min, max, units)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    integer,          intent(in)           :: value        ! the value to be output
    character(len=*), intent(in), optional :: id           ! the id
    character(len=*), intent(in), optional :: title        ! the title
    character(len=*), intent(in), optional :: dictref      ! the dictionary reference
    character(len=*), intent(in), optional :: dataType  
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: units        ! units (default = none)

    call stmAddString(xf, str(value), id, title, dictref, dataType, &
       convention, errorValue, errorBasis, min, max, units)

  END SUBROUTINE stmAddInteger


  ! -------------------------------------------------
  ! 1. create an STMML <scalar> DP float in xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddFloatDP(xf, value, id, title, dictref, dataType, &
       convention, errorValue, errorBasis, min, max, units, fmt)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    real(kind=dp),     intent(in)           :: value        ! the value to be output
    character(len=*), intent(in), optional :: id           ! id
    character(len=*), intent(in), optional :: title        ! the title
    character(len=*), intent(in), optional :: dictref      ! the dictionary reference
    character(len=*), intent(in), optional :: dataType  
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: units        ! units
    character(len=*), intent(in), optional :: fmt          ! the format 


       call stmAddString(xf, str(value,fmt), id, title, dictref, dataType, &
         convention, errorValue, errorBasis, min, max, units)

  END SUBROUTINE stmAddFloatDP

  ! -------------------------------------------------
  ! 2. create an STMML <scalar> SP float in xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddFloatSP(xf, value, id, title, dictref, dataType, &
       convention, errorValue, errorBasis, min, max, units, fmt)

    implicit none
    type(xmlf_t) :: xf
    real(kind=sp), intent(in)               :: value        ! the value to be output
    character(len=*), intent(in), optional :: id           ! id
    character(len=*), intent(in), optional :: title        ! the title
    character(len=*), intent(in), optional :: dictref      ! the dictionary reference
    character(len=*), intent(in), optional :: units        ! units (' ' = none)
    character(len=*), intent(in), optional :: dataType  
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: errorValue
    character(len=*), intent(in), optional :: errorBasis
    character(len=*), intent(in), optional :: min
    character(len=*), intent(in), optional :: max
    character(len=*), intent(in), optional :: fmt
    
       call stmAddString(xf, str(value,fmt), id, title, dictref, dataType, &
         convention, errorValue, errorBasis, min, max, units)

  END SUBROUTINE stmAddFloatSP


  ! -------------------------------------------------
  ! outputs string array to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddStringArray(xf, nvalue, array, id, title, dictref, type, delim, ref)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: nvalue        ! number of values to be output
    character(len=*), intent(in)           :: array(*)      ! the values to be output
    character(len=*), intent(in), optional :: id            ! the id
    character(len=*), intent(in), optional :: title         ! the title
    character(len=*), intent(in), optional :: dictref       ! the dictionary reference
    character(len=*), intent(in), optional :: type          ! the dataType
    character(len=*), intent(in), optional :: delim         ! delimiter
    character(len=*), intent(in), optional :: ref           ! delimiter

    ! splits data into lines whenever it overflows workspace/linelength
    character(len=1) :: delim1
    integer          :: i


    if (present(delim)) then
       delim1 = delim
    else
       delim1 = ' '
    endif

    call xml_NewElement(xf, 'array')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(type))    call xml_AddAttribute(xf, 'type', type)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    ! We must not trim the value of the delimiter - it might be a single space
    call xml_AddAttribute(xf, 'delimiter', delim1)
    call xml_AddAttribute(xf, 'size', nvalue)
    call xml_AddAttribute(xf, 'dataType', 'xsd:string')

    call xml_AddPcdata(xf, array(1))
    do i = 2, nvalue
      call xml_AddPcdata(xf, delim1//array(i))
    enddo
    call xml_EndElement(xf, 'array')

  END SUBROUTINE stmAddStringArray


  ! -------------------------------------------------
  ! outputs string array to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddLogicalArray(xf, nvalue, array, id, title, dictref, type, delim, ref)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    integer,          intent(in)           :: nvalue        ! number of values to be output
    logical,          intent(in)           :: array(*)      ! the values to be output
    character(len=*), intent(in), optional :: id            ! the id
    character(len=*), intent(in), optional :: title         ! the title
    character(len=*), intent(in), optional :: dictref       ! the dictionary reference
    character(len=*), intent(in), optional :: type          ! the dataType
    character(len=*), intent(in), optional :: delim         ! delimiter
    character(len=*), intent(in), optional :: ref           ! delimiter

    ! splits data into lines whenever it overflows workspace/linelength
    character(len=1) :: delim1
    integer          :: i


    if (present(delim)) then
       delim1 = delim
    else
       delim1 = ' '
    endif

    call xml_NewElement(xf, 'array')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(type))    call xml_AddAttribute(xf, 'type', type)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call xml_AddAttribute(xf, 'delimiter', delim1)
    call xml_AddAttribute(xf, 'size', nvalue)
    call xml_AddAttribute(xf, 'dataType', 'xsd:boolean')

    call xml_AddPcdata(xf, array(1))
    do i = 2, nvalue
       if (delim1 .eq. ' ') then
          call xml_AddPcdata(xf, ' ')
          call xml_AddPcdata(xf, array(i))
       else
          call xml_AddPcdata(xf, delim1)
          call xml_AddPcdata(xf, array(i))
       endif
    enddo
    call xml_EndElement(xf, 'array')

  END SUBROUTINE stmAddLogicalArray


  ! -------------------------------------------------
  ! outputs integer array to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddIntegerArray(xf, nvalue, array, id, title, dictref, ref, units)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    integer,          intent(in)           :: nvalue        ! the number of values to be output
    integer,          intent(in)           :: array(*)      ! the values to be output
    character(len=*), intent(in), optional :: id            ! the id
    character(len=*), intent(in), optional :: title         ! the title
    character(len=*), intent(in), optional :: dictref       ! the dictionary reference
    character(len=*), intent(in), optional :: units         ! scienitific units (default ' ')
    character(len=*), intent(in), optional :: ref           ! scienitific units (default ' ')

    ! splits data into lines wherever it overflows the workspace
    integer          :: i

    ! Flush on entry and exit

    call xml_NewElement(xf, 'array')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call xml_AddAttribute(xf, 'size', nvalue)
    call xml_AddAttribute(xf, 'dataType', 'xsd:integer')

    call xml_AddArray(xf,array(1:nvalue))

    call xml_EndElement(xf, 'array')
    
  END SUBROUTINE stmAddIntegerArray


  ! -------------------------------------------------
  ! 1. outputs DP float array to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddFloatArrayDP(xf, nvalue, array, id, title, dictref, units, ref, fmt)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: nvalue        ! number of values to be output
    real(kind=dp), intent(in)              :: array(*)      ! the values to be output
    character(len=*), intent(in), optional :: id            ! the id
    character(len=*), intent(in), optional :: title         ! the title
    character(len=*), intent(in), optional :: dictref       ! the dictionary reference
    character(len=*), intent(in), optional :: units         ! scienitific units (default ' ')
    character(len=*), intent(in), optional :: ref           ! 
    character(len=*), intent(in), optional :: fmt           ! the output format

    ! splits data into lines whenever it overflows workspace/linelength
    ! Flush on entry and exit

    call xml_NewElement(xf, 'array')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call xml_AddAttribute(xf, 'size', nvalue)
    call xml_AddAttribute(xf, 'dataType', 'xsd:double')

    call xml_AddArray(xf,array(1:nvalue),fmt)
    call xml_EndElement(xf, 'array')

  END SUBROUTINE stmAddFloatArrayDP

  ! -------------------------------------------------
  ! 2. outputs SP float array to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddFloatArraySP(xf, nvalue, array, id, title, dictref, units, ref, fmt)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: nvalue        ! number of values to be output
    real(kind=sp), intent(in)               :: array(*)       ! the values to be output
    character(len=*), intent(in), optional :: id            ! the id
    character(len=*), intent(in), optional :: title         ! the title
    character(len=*), intent(in), optional :: dictref       ! the dictionary reference
    character(len=*), intent(in), optional :: units         ! scienitific units (default ' ')
    character(len=*), intent(in), optional :: fmt           ! the output format
    character(len=*), intent(in), optional :: ref           ! the output format


    ! splits data into lines whenever it overflows workspace/linelength
    ! Flush on entry and exit

    call xml_NewElement(xf, 'array')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call xml_AddAttribute(xf, 'size', nvalue)
    call xml_AddAttribute(xf, 'dataType', 'xsd:float')

    call xml_AddArray(xf,array(1:nvalue),fmt)
    call xml_EndElement(xf, 'array')

  END SUBROUTINE stmAddFloatArraySP


  ! -------------------------------------------------
  ! outputs integer matrix to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddStringMatrix(xf, nrows, ncols, matrix, id, title, dictref, units)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    integer,          intent(in)           :: nrows         ! the number of rows to be output
    integer,          intent(in)           :: ncols         ! the number of rows to be output
    character(len=*), intent(in)           :: matrix(nrows,ncols) ! the values to be output
    character(len=*), intent(in), optional :: id            ! the id
    character(len=*), intent(in), optional :: title         ! the title
    character(len=*), intent(in), optional :: dictref       ! the dictionary reference
    character(len=*), intent(in), optional :: units         ! scienitific units (default ' ')

    ! splits data into lines wherever it overflows the workspace
    integer ::  i, j

    call xml_AddComment(xf,"In matrix, row (first) index is fastest")
    call xml_NewElement(xf, 'matrix')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(dictref))   call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    call xml_AddAttribute(xf, 'columns', ncols)
    call xml_AddAttribute(xf, 'rows', nrows)
    call xml_AddAttribute(xf, 'dataType', 'xsd:string')

    do i = 1, ncols
       do j = 1, nrows
          call xml_AddPcdata(xf, matrix(j, i), space=.true.)
       enddo
    enddo
    call xml_EndElement(xf, 'matrix')

  END SUBROUTINE stmAddstringMatrix



  ! -------------------------------------------------
  ! outputs integer matrix to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddIntegerMatrix(xf, nrows, ncols, matrix, id, title, dictref, units)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: nrows         ! the number of rows to be output
    integer, intent(in)                    :: ncols         ! the number of rows to be output
    integer, intent(in)                    :: matrix(nrows,ncols) ! the values to be output
    character(len=*), intent(in), optional :: id            ! the id
    character(len=*), intent(in), optional :: title         ! the title
    character(len=*), intent(in), optional :: dictref       ! the dictionary reference
    character(len=*), intent(in), optional :: units         ! scienitific units (default ' ')

    ! splits data into lines wherever it overflows the workspace
    ! Flush on entry and exit
    integer ::  i, j



    call xml_AddComment(xf,"In matrix, row (first) index is fastest")
    call xml_NewElement(xf, 'matrix')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(dictref))   call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    call xml_AddAttribute(xf, 'columns', ncols)
    call xml_AddAttribute(xf, 'rows', nrows)
    call xml_AddAttribute(xf, 'dataType', 'xsd:integer')

    do i = 1, ncols
       call xml_AddArray(xf,matrix(1:nrows,i))
    enddo
    call xml_EndElement(xf, 'matrix')

  END SUBROUTINE stmAddIntegerMatrix

  ! -------------------------------------------------

  SUBROUTINE stmAddLogicalMatrix(xf, nrows, ncols, matrix, id, title, dictref, units)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: nrows         ! the number of rows to be output
    integer, intent(in)                    :: ncols         ! the number of rows to be output
    logical, intent(in)                    :: matrix(nrows,ncols) ! the values to be output
    character(len=*), intent(in), optional :: id            ! the id
    character(len=*), intent(in), optional :: title         ! the title
    character(len=*), intent(in), optional :: dictref       ! the dictionary reference
    character(len=*), intent(in), optional :: units         ! scienitific units (default ' ')
    
    ! splits data into lines wherever it overflows the workspace
    ! Flush on entry and exit
    integer ::  i, j 

    call xml_AddComment(xf,"In matrix, row (first) index is fastest")
    call xml_NewElement(xf, 'matrix')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(dictref))   call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    call xml_AddAttribute(xf, 'columns', ncols)
    call xml_AddAttribute(xf, 'rows', nrows)
    call xml_AddAttribute(xf, 'dataType', 'xsd:boolean')
    
    do i = 1, ncols
       do j = 1, nrows
          call xml_AddPcdata(xf, matrix(j, i), space=.true.)
       enddo
    enddo
    call xml_EndElement(xf, 'matrix')
    
  END SUBROUTINE stmAddLogicalMatrix



  ! -------------------------------------------------
  ! 1. outputs DP float matrix to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddFloatMatrixDP(xf, ncols, nrows, matrix, id, title, dictref, units, fmt)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: ncols                ! the number of cols to be output
    integer, intent(in)                    :: nrows                ! the number of rows to be output
    real(kind=dp), intent(in)               :: matrix(nrows,ncols)  ! the values to be output
    character(len=*), intent(in), optional :: id                   ! the id
    character(len=*), intent(in), optional :: title                ! the title
    character(len=*), intent(in), optional :: dictref              ! the dictionary reference
    character(len=*), intent(in), optional :: units                ! scienitific units (default ' ')
    character(len=*), intent(in), optional :: fmt                  ! format

    integer ::  i, j

    ! splits data into lines wherever it overflows the workspace
    ! Flush on entry and exit      
    !-------------
    call xml_AddComment(xf,"In matrix, row (first) index is fastest")
    call xml_NewElement(xf, 'matrix')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    call xml_AddAttribute(xf, 'columns', ncols)
    call xml_AddAttribute(xf, 'rows', nrows)
    call xml_AddAttribute(xf, 'dataType', 'xsd:double')
    !-------------
    do i = 1, ncols
       call xml_AddArray(xf,matrix(1:nrows,i),fmt)
    enddo
    call xml_EndElement(xf, 'matrix')

  END SUBROUTINE stmAddFloatMatrixDP

  ! -------------------------------------------------
  ! 2. outputs SP float matrix to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddFloatMatrixSP(xf, ncols, nrows, matrix, id, title, dictref, units, fmt)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: ncols               ! the number of cols to be output
    integer, intent(in)                    :: nrows               ! the number of rows to be output
    real(kind=sp), intent(in)              :: matrix(nrows,ncols) ! the values to be output
    character(len=*), intent(in), optional :: id                  ! the id
    character(len=*), intent(in), optional :: title               ! the title
    character(len=*), intent(in), optional :: dictref             ! the dictionary reference
    character(len=*), intent(in), optional :: units               ! scienitific units (default ' ')
    character(len=*), intent(in), optional :: fmt                 ! format

    ! internal variable
    integer ::  i, j

    ! splits data into lines wherever it overflows the workspace
    ! Flush on entry and exit      
    !
    call xml_AddComment(xf,"In matrix, row (first) index is fastest")
    call xml_NewElement(xf, 'matrix')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    call xml_AddAttribute(xf, 'columns', ncols)
    call xml_AddAttribute(xf, 'rows', nrows)
    call xml_AddAttribute(xf, 'dataType', 'xsd:float')
    do i = 1, ncols
       call xml_AddArray(xf,matrix(1:nrows,i),fmt)
    enddo
    call xml_EndElement(xf, 'matrix')

  END SUBROUTINE stmAddFloatMatrixSP


  ! -------------------------------------------------
  ! 1. outputs DP lower triangle array to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddTriangleDP(xf, nvalue, array, id, title, dictref, units, fmt)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: nvalue         ! number of values to be output
    real(kind=dp), intent(in)              :: array(*)       ! the values to be output
    character(len=*), intent(in), optional :: id             ! the id
    character(len=*), intent(in), optional :: title          ! the title
    character(len=*), intent(in), optional :: dictref        ! the dictionary reference
    character(len=*), intent(in), optional :: units          ! units (' ' = none)
    character(len=*), intent(in), optional :: fmt            ! the output format

    ! splits data into lines whenever it overflows workspace/linelength
    ! Flush on entry and exit
    integer           :: size
    character(len=200) :: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    size = (nvalue*(nvalue+1))/2
    call xml_NewElement(xf, 'array')
    call xml_AddAttribute(xf, 'size', size)
    call xml_AddAttribute(xf, 'rows', nvalue)
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    call STMARCF9DP(xf, size, array, formt)
    call xml_EndElement(xf, 'matrix')

  END SUBROUTINE stmAddTriangleDP

  ! -------------------------------------------------
  ! 2. outputs SP lower triangle array to xml channel
  ! -------------------------------------------------

  SUBROUTINE stmAddTriangleSP(xf, nvalue, array, id, title, dictref, units, fmt)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: nvalue         ! number of values to be output
    real(kind=sp), intent(in)              :: array(*)       ! the values to be output
    character(len=*), intent(in), optional :: id             ! the id
    character(len=*), intent(in), optional :: title          ! the title
    character(len=*), intent(in), optional :: dictref        ! the dictionary reference
    character(len=*), intent(in), optional :: units          ! units (' ' = none)
    character(len=*), intent(in), optional :: fmt            ! the output format

    ! splits data into lines whenever it overflows workspace/linelength
    ! Flush on entry and exit
    integer           :: size
    character(len=200) :: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    size = (nvalue*(nvalue+1))/2
    call xml_NewElement(xf, 'array')
    call xml_AddAttribute(xf, 'size', size)
    call xml_AddAttribute(xf, 'rows', nvalue)
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    call STMARCF9SP(xf, size, array, formt)
    call xml_EndElement(xf, 'matrix')

  END SUBROUTINE stmAddTriangleSP


  ! -------------------------------------------------
  ! outputs fatal error message
  ! -------------------------------------------------

  SUBROUTINE stmErrorMessage(xf, msg, id, title, dictref)

    implicit none
    type(xmlf_t) :: xf
    character(len=*), intent(in)           :: msg            ! the message
    character(len=*), intent(in), optional :: id             ! the id
    character(len=*), intent(in), optional :: title          ! the title
    character(len=*), intent(in), optional :: dictref        ! the dictionary reference

    call xml_NewElement(xf, 'message')
    call xml_AddAttribute(xf, 'severity', 'fatal')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    call xml_AddPcdata(xf, msg)
    call xml_EndElement(xf, 'message')

  END SUBROUTINE stmErrorMessage


  ! -------------------------------------------------
  ! outputs informational message
  ! -------------------------------------------------

  SUBROUTINE stmInfoMessage(xf, msg, id, title, dictref)

    implicit none
    type(xmlf_t) :: xf
    character(len=*), intent(in)           :: msg            ! the message
    character(len=*), intent(in), optional :: id             ! the id
    character(len=*), intent(in), optional :: title          ! the title
    character(len=*), intent(in), optional :: dictref        ! the dictionary reference

    call xml_NewElement(xf, 'message')
    call xml_AddAttribute(xf, 'severity', 'warning')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    call xml_AddPcdata(xf, msg)
    call xml_EndElement(xf, 'message')

  END SUBROUTINE stmInfoMessage


  ! -------------------------------------------------
  ! outputs warning message
  ! -------------------------------------------------

  SUBROUTINE stmWarningMessage(xf, msg, id, title, dictref)

    implicit none
    type(xmlf_t) :: xf
    character(len=*), intent(in)           :: msg            ! the message
    character(len=*), intent(in), optional :: id             ! the id
    character(len=*), intent(in), optional :: title          ! the title
    character(len=*), intent(in), optional :: dictref        ! the dictionary reference

    call xml_NewElement(xf, 'message')
    call xml_AddAttribute(xf, 'severity', 'info')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    call xml_AddPcdata(xf, msg)
    call xml_EndElement(xf, 'message')

  END SUBROUTINE stmWarningMessage



  ! =================================================
  ! basic STMML routines
  ! =================================================


  ! -------------------------------------------------
  ! creates STMML <scalar> string
  ! -------------------------------------------------

  SUBROUTINE STMSCAS9(xf, value, id, title, dictref, type)

    implicit none
    type(xmlf_t) :: xf
    character(len=*), intent(in) :: value                 ! the value to be output
    character(len=*), intent(in), optional :: id          ! the id
    character(len=*), intent(in), optional :: title       ! the title
    character(len=*), intent(in), optional :: dictref     ! the dictionary reference
    character(len=*), intent(in), optional :: type        ! the data type (default 'xsd:string')

    call xml_NewElement(xf, 'scalar')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(dictref)) call xml_AddAttribute(xf, 'title', title)
    if (present(type))    call xml_AddAttribute(xf, 'dataType', type)

!    if (XMLCHKS9(value)) then
    call xml_AddPcdata(xf, value)
    call xml_EndElement(xf, 'scalar')

  END SUBROUTINE STMSCAS9



  ! -------------------------------------------------
  ! output start tag for an STMML array
  ! -------------------------------------------------

  SUBROUTINE STMARST9(xf, nvalue, id, title, dictref, tuval, delim)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: nvalue      ! the number of values to be output
    character(len=*), intent(in), optional :: id          ! the id
    character(len=*), intent(in), optional :: title       ! the title
    character(len=*), intent(in), optional :: dictref     ! the dictionary reference
    character(len=*), intent(in), optional :: tuval       ! data type (default 'xsd:string') or units (' ' = none)
    character(len=*), intent(in), optional :: delim       ! the delimiter (default ' ')

    ! Internal Variables
    character(len=1) :: delim1

    if (present(delim)) then
       delim1 = delim
    else
       delim1 = ' '
    endif

    call xml_NewElement(xf, 'array')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(dictref)) call xml_AddAttribute(xf, 'title', title)
    if (present(tuval))   call xml_AddAttribute(xf, 'type', tuval)
    call xml_AddAttribute(xf, 'delimiter', delim1)
    call xml_AddAttribute(xf, 'size', nvalue)
    call xml_EndElement(xf, 'array')

  END SUBROUTINE STMARST9



  ! -------------------------------------------------
  ! 2. outputs SP float array to channel
  ! -------------------------------------------------

  SUBROUTINE STMARF9SP(xf, nvalue, arrf, id, title, dictref, units, fmt)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)                    :: nvalue      ! the number of values to be output
    real(kind=sp), intent(in)               :: arrf(*)     ! the values to be output
    character(len=*), intent(in), optional :: id          ! the id
    character(len=*), intent(in), optional :: title       ! the title
    character(len=*), intent(in), optional :: dictref     ! the dictionary reference
    character(len=*), intent(in), optional :: units       ! units (' ' = none)
    character(len=*)                       :: fmt         ! the output format

    call xml_NewElement(xf, 'scalar')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(dictref)) call xml_AddAttribute(xf, 'title', title)
    if (present(units))   call xml_AddAttribute(xf, 'units', units)
    call xml_AddAttribute(xf, 'size', nvalue)
    call STMARCF9SP(xf, nvalue, arrf, fmt)
    call xml_NewElement(xf, 'scalar')

  END SUBROUTINE STMARF9SP


  ! -------------------------------------------------
  ! 1. outputs content of DP float array to channel
  ! -------------------------------------------------

  SUBROUTINE STMARCF9DP(xf, nvalue, arrf, fmt)

    implicit none
    type(xmlf_t) :: xf
    integer, intent(in)         :: nvalue   
    real(kind=dp), intent(in)   :: arrf(*) 
    character(len=*), optional :: fmt

    integer :: i
    character(len=30) :: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    call xml_AddPcdata(xf, arrf(1), formt)
    do i = 2, nvalue
       call xml_AddPcdata(xf, arrf(i), formt, space=.true.)
    enddo
  END SUBROUTINE STMARCF9DP


  ! -------------------------------------------------
  ! 2. outputs content of SP float array to channel
  ! -------------------------------------------------

  SUBROUTINE STMARCF9SP(xf, nvalue, arrf, fmt)

    implicit none
    type(xmlf_t) :: xf
    integer,       intent(in)   :: nvalue     ! the number of values to be output
    real(kind=sp), intent(in)   :: arrf(*)    ! the values to be output
    character(len=*), optional :: fmt

    integer :: i
    character(len=30) :: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    call xml_AddPcdata(xf, arrf(1), formt)
    do i = 2, nvalue
       call xml_AddPcdata(xf, arrf(i), formt, space=.true.)
    enddo
  END SUBROUTINE STMARCF9SP

end module m_wstml

module xmlf90_sax

!
! Stub module to gather all the functionality needed by the user
! 
! In future m_dictionary and m_converters could be exported by
! other parts of a more general fortran library.
!
! m_xml_error is necessary in order to use a custom error handler.
!
use m_sax_dictionary
use m_xml_parser
use m_sax_converters
use m_xml_error

public

end module xmlf90_sax

module m_dom_element

use m_dom_types
use m_dom_namednodemap
use m_dom_nodelist
use m_dom_attribute
use m_dom_document
use m_dom_debug
use m_dom_node
use m_dom_strings

private

  !-------------------------------------------------------   
  ! METHODS FOR ELEMENT NODES
  !-------------------------------------------------------   
  public :: getTagName
  public :: getElementsByTagName
  public :: getElementsByTagAttrName
  public :: getAttribute
  public :: getAttributeNode
  public :: setAttribute
  public :: setAttributeNode
  public :: removeAttribute
  public :: normalize       !--- combines adjacent text nodes ---!

CONTAINS

  !-----------------------------------------------------------
  !  METHODS FOR ELEMENT NODES
  !-----------------------------------------------------------
  function getTagName(element)

    type(fnode), intent(in) :: element   
    type(string)            :: getTagName

    if (element % nodeType == ELEMENT_NODE) then
       getTagName = element % nodeName 
    else
       getTagName = ''
    endif

  end function getTagName

  !-----------------------------------------------------------
 

 function getElementsByTagName(element, tag) result(nodelist)
    type(fnode), pointer         :: element
    character(len=*), intent(in) :: tag
    type(fnodeList), pointer     :: nodelist 

    type(fnode), pointer        :: np

    nodelist => null()

    np => element
    if (dom_debug) print *, "Going into search for tag: ", trim(tag)
    call search(np)

    CONTAINS

    recursive subroutine search(np)
    type(fnode), pointer        :: np

    type(string)                :: name

    !
    ! Could replace the calls to helper methods by direct lookups of node 
    ! components to make it faster.
    ! 
    
    do
       if (.not. associated(np)) exit
       select case(np%nodeType)

          case(DOCUMENT_NODE) 
             ! special case ... search its children 
             if (hasChildNodes(np)) call search(getFirstChild(np))
             ! will exit for lack of siblings
          case(ELEMENT_NODE)

             name = getNodeName(np)
             if (dom_debug) print *, "exploring node: ", char(name)
             if ((tag == "*") .or. (tag == name)) then
                call append(nodelist,np)
                if (dom_debug) print *, "found match ", nodelist%length
             endif
             if (hasChildNodes(np)) call search(getFirstChild(np))

          case default
             
             ! do nothing

        end select

        if (associated(np,element)) exit  ! no siblings of element...
        np => getNextSibling(np)

     enddo
    
    end subroutine search

  end function getElementsByTagName

  !-----------------------------------------------------------

 function getElementsByTagAttrName(element, tag, attr,value) result(nodelist)
    type(fnode), pointer         :: element
    character(len=*), intent(in) :: tag,attr
    character(len=*), intent(in) :: value

    type(fnodeList), pointer     :: nodelist, sametag
    integer                      :: i, length
    type(fnode), pointer         :: np, attr_n
    logical                      :: dom_debug_local
    type(string)                 :: value_s,name_s

    nodelist => null()

    dom_debug_local = .false.

    sameTag => getElementsByTagName(element,tag)
    if (dom_debug .or. dom_debug_local) then
       print *, "Going into search for nodes with tag: ", trim(tag)
       print *, "Going into search for node with attr: ", trim(attr)
    endif

    length=getLength(sameTag)

    do i=0,length-1
       np => item(sameTag,i)
       attr_n => getAttributeNode(np,attr)
       if (associated(attr_n)) then
          name_s = getNodeName(attr_n)
          value_s = getNodeValue(attr_n)
          if (len(value_s) > 0) then
             if (trim(char(value_s)) == trim(value))then
                call append(nodelist,np)
             endif
          endif
       endif
    enddo

  end function getElementsByTagAttrName

!--------------------------------------------------------------

  function getAttribute(element, name)
    
    type(fnode), intent(in) :: element
    character(len=*), intent(in) :: name
    type(string)                 :: getAttribute

    type(fnode), pointer :: nn

    getAttribute = ""  ! as per specs, if not found
    if (element % nodeType /= ELEMENT_NODE) RETURN
    nn => getNamedItem(element%attributes,name)
    if (.not. associated(nn)) RETURN
    
    getAttribute = nn%nodeValue

        
  end function getAttribute

  !-----------------------------------------------------------

  function getAttributeNode(element, name)
    
    type(fnode), intent(in) :: element
    type(fnode), pointer    :: getAttributeNode
    character(len=*), intent(in) :: name

    getAttributeNode => null()     ! as per specs, if not found
    if (element % nodeType /= ELEMENT_NODE) RETURN
    getAttributeNode => getNamedItem(element%attributes,name)

  end function getAttributeNode
  
  !-----------------------------------------------------------

  subroutine setAttributeNode(element, newattr)
    type(fnode), pointer :: element
    type(fnode), pointer :: newattr

    type(fnode), pointer :: dummy

    if (element % nodeType /= ELEMENT_NODE) then
       if (dom_debug) print *, "not an element node in setAttributeNode..."
       RETURN
    endif

    dummy => setNamedItem(element%attributes,newattr)
     
  end subroutine setAttributeNode

!-------------------------------------------------------------------
  subroutine setAttribute(element, name, value)
    type(fnode), pointer :: element
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: value

    type(fnode), pointer      :: newattr

    newattr => createAttribute(name)
    call setValue(newattr,value)
    call setAttributeNode(element,newattr)

  end subroutine setAttribute

  !-----------------------------------------------------------

  subroutine removeAttribute(element, name)
    type(fnode), pointer :: element
    character(len=*), intent(in) :: name

    type(fnode), pointer :: dummy

    if (element % nodeType /= ELEMENT_NODE) RETURN
    if (.not. associated(element%attributes)) RETURN

    dummy => removeNamedItem(element%attributes,name)
     
  end subroutine removeAttribute

  !-----------------------------------------------------------
  recursive subroutine normalize(element)
    type(fnode), pointer         :: element

    type(fnode), pointer        :: np, ghost
    logical                     :: first

    type(fnode), pointer        :: head

    first = .true.  ! next Text node will be first

    if (dom_debug) print *, "Normalizing: ", trim(element%nodeName)
    np => element%firstChild
    ! 
    do
       if (.not. associated(np)) exit
       select case(np%nodeType)

          case(TEXT_NODE) 
             if (first) then
                if (dom_debug) print *, "normalize: found first in chain"
                head => np
                first = .false.
                np => getNextSibling(np)
             else                    ! a contiguous text node
                if (dom_debug) print *, "normalize: found second in chain"
                head%nodeValue = head%nodeValue // np%nodeValue
                head%nextSibling => np%nextSibling
                if (associated(np,np%parentNode%lastChild)) then
                   np%parentNode%lastChild => head
                   head%nextSibling => null()
                else
                   np%nextSibling%previousSibling => head
                endif
                ghost => np
                np => getNextSibling(np)
                call destroyNode(ghost)
             endif

          case(ELEMENT_NODE)

             first = .true.
             if (dom_debug) print *, "element sibling: ", trim(np%nodeName)
             if (hasChildNodes(np)) call normalize(np)
             np => getNextSibling(np)

          case default
             
             ! do nothing, just mark that we break the chain of text nodes
             if (dom_debug) print *, "other sibling: ", trim(np%nodeName)
             first = .true.
             np => getNextSibling(np)

        end select

     enddo

    end subroutine normalize


end module m_dom_element

program relative
!
! Example of XPATH-lite  processing
!
use xmlf90_xpath

type(dictionary_t) :: attributes
type(xml_t) :: fxml

integer  :: status

call open_xmlfile(XPATH_DATA_DIR//"Ba.xml",fxml,status)
if (status /=0) then
   print * , "Cannot open file."
   stop
endif

!call enable_debug(sax=.false.)

!
job_search: do
   !
   ! This will search for all the 'job' elements and all the
   ! 'shell' elements with l=0 contained in them at any depth
   ! (relative search).

   call mark_node(fxml,path="/atom/job",attributes=attributes,status=status)
   if (status /= 0)  then
      print *, "No more 'job' elements"
      exit job_search
   else
      print *, ">>>>>>>>>>> New job: "
      call print_dict(attributes)
   endif

   shell_search: do
      !
      ! The initial dot (.) signals a relative search
      !
      call get_node(fxml,path=".//shell",att_name="l", &
           att_value="0",attributes=attributes,status=status)
      if (status /= 0)  then
         print *, "end of job"
         exit shell_search
      endif
      print *, " Found Shell with l=0: "
      call print_dict(attributes)
      print *, "------------------------------------***"
   enddo shell_search

enddo job_search

end program relative

module m_aux
use xmlf90_sax
private
public :: begin_element_print

contains !---------------- handler subroutine follows

subroutine begin_element_print(name,attributes)
   character(len=*), intent(in)     :: name
   type(dictionary_t), intent(in)   :: attributes
   
   character(len=3)  :: id
   integer           :: status
   
   print *, "Start of element: ", name
   if (has_key(attributes,"id")) then
      call get_value(attributes,"id",id,status)
      print *, "  Id attribute: ", id
   endif
end subroutine begin_element_print

end module m_aux

program simple
use xmlf90_sax
use m_aux

type(xml_t)        :: fxml      ! XML file object (opaque)
integer            :: iostat    ! Return code (0 if OK)

call open_xmlfile(SAX_DATA_DIR//"inventory.xml",fxml,iostat)
if (iostat /= 0) stop "cannot open xml file"

call xml_parse(fxml, begin_element_handler=begin_element_print)


end program simple

program pseudo_read
!
! Example of XPATH-lite  processing for pseudo xml file
! Shows the use of constrained searches, context delegation, etc.
!
use xmlf90_xpath
use m_pseudo_types

type(dictionary_t) :: attributes
type(xml_t) :: fxml

type(pseudo_t), target, save :: pseudo
type(grid_t),  save          :: global_grid
!
! Pointers to make it easier to manage the data
!
type(header_t),  pointer   :: hp
type(vps_t),  pointer      :: pp

integer               :: status, ndata
character(len=200)    :: value

!-----------------------------------------------------------------
call open_xmlfile(XPATH_DATA_DIR//"pseudo.xml",fxml,status)
if (status /=0) call die("Cannot open file.")

!call enable_debug(sax=.false.)

!
!------------------------------------------------------------
! Root element with version information
!
call get_node(fxml,path="/pseudo",attributes=attributes,status=status)
if (status /= 0)  call die("Cannot find pseudo element")

         call get_value(attributes,"version",value,status)
         if (value == "0.5") then
            print *, "Processing a PSEUDO version 0.5 XML file"
         else
            call die("Can only work with PSEUDO version 0.5 XML files")
         endif

!------------------------------------------------------------
! Header
!
call get_node(fxml,path="/pseudo/header", &
              attributes=attributes,status=status)
if (status /= 0)  call die("Cannot find /pseudo/header")

         hp => pseudo%header
         
         call get_value(attributes,"symbol",hp%symbol,status)
         if (status /= 0 ) call die("Cannot determine atomic symbol")

         call get_value(attributes,"zval",value,status)
         if (status /= 0 ) call die("Cannot determine zval")
         read(unit=value,fmt=*) hp%zval
!
         call get_value(attributes,"creator",hp%creator,status)
         if (status /= 0 ) hp%creator="unknown"

         call get_value(attributes,"flavor",hp%flavor,status)
         if (status /= 0 ) hp%flavor="unknown"

         call get_value(attributes,"relativistic",value,status)
         if (status /= 0 ) value = "no"
         hp%relativistic = (value == "yes")

         call get_value(attributes,"polarized",value,status)
         if (status /= 0 ) value = "no"
         hp%polarized = (value == "yes")

         call get_value(attributes,"core-corrections", &
                                    hp%core_corrections,status)
         if (status /= 0 ) hp%core_corrections = "nc"


!------------------------------------------------------------
! Global grid information
!
call rewind_xmlfile(fxml)
call get_node(fxml,path="/pseudo/grid", &
              attributes=attributes,status=status)

if (status == 0)  then
   print *, "This file has a global grid... "
   call get_grid_data(attributes,global_grid)
else
   global_grid%npts = 0          ! To flag absence of global grid info
endif
!
!------------------------------------------------------------
! Valence charge
!
call rewind_xmlfile(fxml)
!
call mark_node(fxml,path="/pseudo/valence-charge", &
              attributes=attributes,status=status)
if (status == 0)  then
   !
   !  Get the data (and possible private grid)
   !
   call get_radfunc_data(fxml,global_grid,pseudo%valence_charge)
endif
!
!------------------------------------------------------------
! Core charge
!
call rewind_xmlfile(fxml)
!
call mark_node(fxml,path="/pseudo/pseudocore-charge", &
              attributes=attributes,status=status)
if (status == 0)  then
   !
   !  Get the data (and possible private grid)
   !
   call get_radfunc_data(fxml,global_grid,pseudo%core_charge)
endif
!
!------------------------------------------------------------
! Semilocal pseudopotentials
!
call rewind_xmlfile(fxml)
!
call get_node(fxml,path="//semilocal", &
              attributes=attributes,status=status)
if (status /= 0)  call die("Cannot find semilocal element")

         call get_value(attributes,"npots-down",value,status)
         if (status /= 0 ) call die("Cannot determine npots-down")
         read(unit=value,fmt=*) pseudo%npots_down

         call get_value(attributes,"npots-up",value,status)
         if (status /= 0 ) call die("Cannot determine npots-up")
         read(unit=value,fmt=*) pseudo%npots_up

!
! Loop over pseudopotentials
!
pseudo%npots = 0
do
   !
   ! This will search for all the 'vps' elements, marking the context 
   ! in turn
   !
      call mark_node(fxml,path="//vps",attributes=attributes,status=status)
      if (status /= 0) exit          ! exit loop

         pseudo%npots = pseudo%npots + 1
         pp => pseudo%pot(pseudo%npots)

         call get_value(attributes,"l",value,status)
         if (status /= 0 ) call die("Cannot determine l for Vps")
         read(unit=value,fmt=*) pp%l

         call get_value(attributes,"principal-n",value,status)
         if (status /= 0 ) call die("Cannot determine n for Vps")
         read(unit=value,fmt=*) pp%n

         call get_value(attributes,"cutoff",value,status)
         if (status /= 0 ) call die("Cannot determine cutoff for Vps")
         read(unit=value,fmt=*) pp%cutoff

         call get_value(attributes,"occupation",value,status)
         if (status /= 0 ) call die("Cannot determine occupation for Vps")
         read(unit=value,fmt=*) pp%occupation

         call get_value(attributes,"spin",value,status)
         if (status /= 0 ) call die("Cannot determine spin for Vps")
         read(unit=value,fmt=*) pp%spin

         !
         !  Get the data (and possible private grid)
         !
         call get_radfunc_data(fxml,global_grid,pp%V)
         !
         ! After context delegation it is essential to sync the handle
         ! (or to rewind it)
         !
         call sync_xmlfile(fxml,status)
enddo

!
!  Show some of the information
!
call dump_pseudo(pseudo)

!=======================================================================
CONTAINS

!-----------------------------------------------------------------------
subroutine get_radfunc_data(context,global_grid,rp)
!
! Example of routine which packages parsing functionality for a
! common element. The <radfunc> element can appear under <vps>,
! <valence-charge>, and <pseudocore-charge> elements. 
! In all cases the parsing steps are exactly  the same.
! This routine accepts the appropriate context handle and returns
! the data structure.
!
type(xml_t), intent(in)      :: context
type(grid_t), intent(in)     :: global_grid
type(radfunc_t), intent(out) :: rp

type(xml_t)           :: ff
character(len=2000)   :: pcdata

ff = context           ! It inherits the "ancestor element" markings, etc

      call get_node(ff,path="./radfunc/grid", &
              attributes=attributes,status=status)
      if (status == 0)  then
         print *, " >> local grid found"
         call get_grid_data(attributes,rp%grid)
      else
         rp%grid = global_grid
      endif

      ff = context
      call sync_xmlfile(ff,status)  ! Go back to beginning of context 

      call get_node(ff,path="./radfunc/data", &
              pcdata=pcdata,status=status)
      if (status < 0) call die("Cannot find data element")
      if (status > 0) call die("Not enough space for pcdata")
      if (rp%grid%npts == 0) call die("Need grid information!")
      allocate(rp%data(rp%grid%npts))
      ndata = 0             ! To start the build up
      call build_data_array(pcdata,rp%data,ndata)
      if (ndata /= size(rp%data)) STOP "npts mismatch"
end subroutine get_radfunc_data
!-----------------------------------------------------------------------
subroutine get_grid_data(attributes,grid)
type(dictionary_t), intent(in)  :: attributes
type(grid_t), intent(out)       :: grid

         call get_value(attributes,"type",grid%type,status)
         if (status /= 0 ) call die("Cannot determine grid type")

         call get_value(attributes,"npts",value,status)
         if (status /= 0 ) call die("Cannot determine grid npts")
         read(unit=value,fmt=*) grid%npts

         call get_value(attributes,"scale",value,status)
         if (status /= 0 ) call die("Cannot determine grid scale")
         read(unit=value,fmt=*) grid%scale

         call get_value(attributes,"step",value,status)
         if (status /= 0 ) call die("Cannot determine grid step")
         read(unit=value,fmt=*) grid%step

end subroutine get_grid_data

!-----------------------------------------------------------------------
      subroutine die(str)
      character(len=*), intent(in), optional   :: str
      if (present(str)) then
         write(unit=0,fmt="(a)") trim(str)
      endif
      write(unit=0,fmt="(a)") "Stopping Program"
      stop
      end subroutine die

end program pseudo_read

MODULE m_count
!
! Contributed by Jon Wakelin
!

  USE xmlf90_sax

  IMPLICIT NONE

  private 
  PUBLIC :: begin_element_handler, end_element_handler, pcdata_chunk_handler

  TYPE, public :: hash
     CHARACTER(len=50) :: elm
     INTEGER           :: num
  END TYPE hash

  TYPE(hash), DIMENSION(50), public  :: element_hash
  INTEGER, public, save              ::  nhash = 0

  INTEGER, private, save             :: n = 0 

!--------------------------------------------------------
CONTAINS

  SUBROUTINE begin_element_handler(name,attributes)
    character(len=*), intent(in)   :: name
    TYPE(dictionary_t), INTENT(in) :: attributes

    LOGICAL :: match  
    INTEGER :: pmatch
    INTEGER :: i

    match = .false.

!!! First time through loop element must be unique...
    IF (n == 0) THEN
       element_hash(n+1)%elm = name
       element_hash(n+1)%num = 1
       nhash=nhash+1
    ELSE

!!! ...thereafter we will have to check if it is unique
       DO i=1,nhash
          IF (name == element_hash(i)%elm) THEN
             match = .true. ! set .true. if element already exists
             pmatch = i     ! and record the position at which the match occured
                            ! NB there can only ever be 1 or 0 matches
          ENDIF
       ENDDO

!!! If element already exists increment the counter for THIS element
       IF (match) THEN
          element_hash(pmatch)%num = element_hash(pmatch)%num + 1
       ELSE
!!! Otherwise make a new entry in the hash 
          element_hash(n+1)%elm = name
          element_hash(n+1)%num = 1
          nhash=nhash+1
       ENDIF
    ENDIF
    n=nhash

  END SUBROUTINE begin_element_handler


!--------------------------------------------------------------------------
! End tag handler
  SUBROUTINE end_element_handler(name)
    character(len=*), intent(in)     :: name
  END SUBROUTINE end_element_handler
  
  ! PCDATA handler
  SUBROUTINE pcdata_chunk_handler(chunk)
    CHARACTER(len=*), INTENT(in) :: chunk
  END SUBROUTINE pcdata_chunk_handler
  
END MODULE m_count

module m_xml_parser

!
! Basic module to parse XML in the SAX spirit.
!

use m_sax_buffer
use m_sax_reader
use m_sax_fsm
use m_sax_dictionary
use m_sax_debug
use m_xml_error
use m_sax_elstack          ! For element nesting checks
!
private

!
!  XML file handle
!
type, public :: xml_t
private
      type(file_buffer_t)  :: fb
      type(fsm_t)          :: fx
      character(len=200)   :: path_mark
      !
      ! error reporting section
      !
      type(xml_error_t)    :: error_info
end type xml_t

!
public :: xml_parse
public :: open_xmlfile, close_xmlfile
public :: endfile_xmlfile, rewind_xmlfile
public :: eof_xmlfile, sync_xmlfile
public :: xml_char_count
public :: xml_error_report
public :: xml_path, xml_mark_path, xml_get_path_mark
public :: xml_name, xml_attributes

CONTAINS  !=============================================================

subroutine open_xmlfile(fname,fxml,iostat,record_size)
  character(len=*), intent(in)      :: fname
  integer, intent(out)              :: iostat
  type(xml_t), intent(out)          :: fxml
  integer, intent(in), optional     :: record_size
  
  call open_file(fname,fxml%fb,iostat,record_size)
  call init_fsm(fxml%fx)
  call reset_error_info(fxml%error_info) 
  fxml%path_mark = ""
  
end subroutine open_xmlfile
!-------------------------------------------------------------------------

subroutine rewind_xmlfile(fxml)
  type(xml_t), intent(inout) :: fxml
  
  call rewind_file(fxml%fb)
  call reset_fsm(fxml%fx)
  call reset_error_info(fxml%error_info) 
  fxml%path_mark = ""
  
end subroutine rewind_xmlfile

!-----------------------------------------
subroutine endfile_xmlfile(fxml)
  type(xml_t), intent(inout) :: fxml

  call mark_eof_file(fxml%fb) 

end subroutine endfile_xmlfile

!-----------------------------------------
subroutine close_xmlfile(fxml)
  type(xml_t), intent(inout) :: fxml
  
  call close_file_buffer(fxml%fb)
  call reset_fsm(fxml%fx)         ! just in case
  call reset_error_info(fxml%error_info) ! ""
  fxml%path_mark = ""             ! ""

end subroutine close_xmlfile

!-----------------------------------------
subroutine sync_xmlfile(fxml,iostat)
  type(xml_t), intent(inout) :: fxml
  integer, intent(out)       :: iostat
  
  call sync_file(fxml%fb,iostat)
  ! Do not reset fx: that's the whole point of synching.
  
end subroutine sync_xmlfile

!----------------------------------------------------
function eof_xmlfile(fxml) result (res)
  type(xml_t), intent(in)          :: fxml
  logical                          :: res
  
  res = eof_file(fxml%fb)
  
end function eof_xmlfile
!
!----------------------------------------------------
!----------------------------------------------------
function xml_char_count(fxml) result (nc)
  type(xml_t), intent(in)          :: fxml
  integer                          :: nc
  nc = nchars_processed(fxml%fb)
end function xml_char_count
!
!----------------------------------------------------
subroutine xml_error_report(fxml,lun)
  type(xml_t), intent(in)          :: fxml
  integer, intent(in)              :: lun

  call print_error_report(fxml%error_info, lun)
  
end subroutine xml_error_report
!
!----------------------------------------------------
!

recursive subroutine xml_parse(fxml, begin_element_handler,    &
                           end_element_handler,      &
                           pcdata_chunk_handler,     &
                           comment_handler,          &
                           xml_declaration_handler,  &
                           cdata_section_handler,    &
                           sgml_declaration_handler, &
                           error_handler,            &
                           signal_handler,           &
                           verbose,                  &
                           empty_element_handler,    &
                           start_document_handler,   & 
                           end_document_handler,     &
                           stat)   

type(xml_t), intent(inout), target  :: fxml

optional                            :: begin_element_handler
optional                            :: end_element_handler
optional                            :: pcdata_chunk_handler
optional                            :: comment_handler
optional                            :: xml_declaration_handler
optional                            :: sgml_declaration_handler
optional                            :: cdata_section_handler
optional                            :: error_handler
optional                            :: signal_handler
logical, intent(in), optional       :: verbose
optional                            :: empty_element_handler
optional                            :: start_document_handler
optional                            :: end_document_handler
integer, intent(out), optional      :: stat

interface
   subroutine begin_element_handler(name,attributes)
   use m_sax_dictionary
   character(len=*), intent(in)     :: name
   type(dictionary_t), intent(in)   :: attributes
   end subroutine begin_element_handler

   subroutine end_element_handler(name)
   character(len=*), intent(in)     :: name
   end subroutine end_element_handler

   subroutine pcdata_chunk_handler(chunk)
   character(len=*), intent(in) :: chunk
   end subroutine pcdata_chunk_handler

   subroutine comment_handler(comment)
   character(len=*), intent(in) :: comment
   end subroutine comment_handler

   subroutine xml_declaration_handler(name,attributes)
   use m_sax_dictionary
   character(len=*), intent(in)     :: name
   type(dictionary_t), intent(in)   :: attributes
   end subroutine xml_declaration_handler

   subroutine sgml_declaration_handler(sgml_declaration)
   character(len=*), intent(in) :: sgml_declaration
   end subroutine sgml_declaration_handler

   subroutine cdata_section_handler(cdata)
   character(len=*), intent(in) :: cdata
   end subroutine cdata_section_handler

   subroutine error_handler(error_info)
   use m_xml_error
   type(xml_error_t), intent(in)            :: error_info
   end subroutine error_handler

   subroutine signal_handler(code)
   logical, intent(out) :: code
   end subroutine signal_handler

   subroutine empty_element_handler(name,attributes)
   use m_sax_dictionary
   character(len=*), intent(in)     :: name
   type(dictionary_t), intent(in)   :: attributes
   end subroutine empty_element_handler

   subroutine start_document_handler()   
   end subroutine start_document_handler 

   subroutine end_document_handler()     
   end subroutine end_document_handler   

end interface

character(len=1)     :: c
integer              :: iostat

integer              :: signal

type(buffer_t)       :: name, oldname, dummy

logical              :: have_begin_handler, have_end_handler, &
                        have_pcdata_handler, have_comment_handler, &
                        have_xml_declaration_handler, &
                        have_sgml_declaration_handler, &
                        have_cdata_section_handler, have_empty_handler, &
                        have_error_handler, have_signal_handler, &
                        have_start_document_handler, have_end_document_handler
logical              :: have_stat_argument
logical              :: return_flag
logical              :: pause_signal

type(file_buffer_t), pointer :: fb
type(fsm_t), pointer         :: fx

have_begin_handler = present(begin_element_handler)
have_end_handler = present(end_element_handler)
have_pcdata_handler = present(pcdata_chunk_handler)
have_comment_handler = present(comment_handler)
have_xml_declaration_handler = present(xml_declaration_handler)
have_sgml_declaration_handler = present(sgml_declaration_handler)
have_cdata_section_handler = present(cdata_section_handler)
have_error_handler = present(error_handler)
have_signal_handler = present(signal_handler)
have_empty_handler = present(empty_element_handler)
have_start_document_handler = present(start_document_handler)  
have_end_document_handler = present(end_document_handler)      

have_stat_argument = present(stat)

fb => fxml%fb
fx => fxml%fx
if (present(verbose)) then
   debug = verbose                 ! For m_converters
   fx%debug = verbose              ! job-specific flag
endif

if (fx%debug) print *, " Entering xml_parse..."
if (have_start_document_handler) call start_document_handler()

!---------------------------------------------------------------------
do
      call get_character(fb,c,iostat)

      if (iostat /= 0) then          ! End of file...
         if (.not. is_empty(fx%element_stack)) then
            call build_error_info(fxml%error_info, &
                 "Early end of file.", &
                 line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
            call process_error(return_flag); if (return_flag) RETURN
         endif
         if (have_end_document_handler) call end_document_handler()
         call endfile_xmlfile(fxml)  ! Mark it as eof
         EXIT
      endif

      call evolve_fsm(fx,c,signal)

      if (fx%debug) print *, c, " ::: ", trim(fx%action)

      if (signal == END_OF_TAG) then
         !
         ! We decide whether we have ended an opening tag or a closing tag
         !
         if (fx%context == OPENING_TAG) then
            name = fx%element_name

            if (fx%debug) print *, "We have found an opening tag"
            if (fx%root_element_seen) then
               if (name .equal. fx%root_element_name) then
                  call build_error_info(fxml%error_info, &
                  "Duplicate root element: " // str(name), &
                  line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
                  call process_error(return_flag); if (return_flag) RETURN
               endif
               if (is_empty(fx%element_stack)) then
                  call build_error_info(fxml%error_info, &
                  "Opening tag beyond root context: " // str(name), &
                  line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
                  call process_error(return_flag); if (return_flag) RETURN
               endif
            else
               fx%root_element_name = name
               fx%root_element_seen = .true.
            endif
            call push_elstack(name,fx%element_stack)
            if (have_begin_handler) &
                call begin_element_handler(str(name),fx%attributes)

         else if (fx%context == CLOSING_TAG) then
            name = fx%element_name
         
            if (fx%debug) print *, "We have found a closing tag"
            if (is_empty(fx%element_stack)) then
               call build_error_info(fxml%error_info, &
                  "Nesting error: End tag: " // str(name) //  &
                  " does not match -- too many end tags", &
                  line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
               call process_error(return_flag); if (return_flag) RETURN
            else
               call get_top_elstack(fx%element_stack,oldname)
               if (oldname .equal. name) then
                  call pop_elstack(fx%element_stack,oldname)
                  if (have_end_handler) call end_element_handler(str(name))
!!                  call pop_elstack(fx%element_stack,oldname)
               else
                  call build_error_info(fxml%error_info, &
                       "Nesting error: End tag: " // str(name) //  &
                       ". Expecting end of : " // str(oldname), &
                       line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
                  call process_error(return_flag); if (return_flag) RETURN
               endif
            endif
         else if (fx%context == SINGLE_TAG) then
            name = fx%element_name

            if (fx%debug) print *, "We have found a single (empty) tag: ", &
                                str(name)
            !
            ! Push name on to stack to reveal true xpath
            !
            call push_elstack(name,fx%element_stack)
            if (have_empty_handler) then
               if (fx%debug) print *, "--> calling empty_element_handler."
               call empty_element_handler(str(name),fx%attributes)
               call pop_elstack(fx%element_stack,dummy)
            else
               if (have_begin_handler) then
                  if (fx%debug) print *, "--> calling begin_element_handler..."
                  call begin_element_handler(str(name),fx%attributes)
               endif
               call pop_elstack(fx%element_stack,dummy)
               if (have_end_handler) then
                  if (fx%debug) print *, "--> ... and end_element_handler."
                  call end_element_handler(str(name))
               endif
            endif
!!            call pop_elstack(fx%element_stack,dummy)

         else if (fx%context == CDATA_SECTION_TAG) then

            ! Should not be reached
            if (fx%debug) print *, "We found a CDATA section"
            if (is_empty(fx%element_stack)) then
               if (fx%debug) print *, &
                    "... Warning: CDATA section outside element context"
            endif
            if (have_cdata_section_handler) then
               call cdata_section_handler(str(fx%pcdata))
            else if (have_pcdata_handler) then
               if (fx%debug) print *, &
                    "... Warning: CDATA section chunk processed as pcdata"
               call pcdata_chunk_handler(str(fx%pcdata))
            endif

         else if (fx%context == COMMENT_TAG) then
            ! It might overflow for long comments
            if (fx%debug) print *, "We found a comment tag"
            if (have_comment_handler)  &
                 call comment_handler(str(fx%pcdata))

         else if (fx%context == SGML_DECLARATION_TAG) then

            if (fx%debug) print *, "We found an sgml declaration"
            if (have_sgml_declaration_handler)  &
                      call sgml_declaration_handler(str(fx%pcdata))

         else if (fx%context == XML_DECLARATION_TAG) then

            if (fx%debug) print *, "We found an XML declaration"
            name = fx%element_name
            if (have_xml_declaration_handler)  &
                      call xml_declaration_handler(str(name),fx%attributes)

         else

            ! do nothing

         endif

      else if (signal == CHUNK_OF_PCDATA) then

         if (fx%debug) print *, "We found a chunk of PCDATA"
         if (is_empty(fx%element_stack)) then
            if (fx%debug) print *, "... Warning: PCDATA outside element context"
            ! Just a warning
            call build_error_info(fxml%error_info, &
                 "PCDATA outside of element context", &
                 line(fb),column(fb),fx%element_stack,WARNING_CODE)
            call process_error(return_flag); if (return_flag) RETURN
         else
            if (have_pcdata_handler) &
                 call pcdata_chunk_handler(str(fx%pcdata))
         endif

      else if (signal == CHUNK_OF_CDATA_SECTION) then

         if (fx%debug) print *, "We found a chunk of CDATA"
         if (is_empty(fx%element_stack)) then
            if (fx%debug) print *, "... Warning: CDATA outside element context"
            ! Just a warning
            call build_error_info(fxml%error_info, &
                 "CDATA outside of element context", &
                 line(fb),column(fb),fx%element_stack,WARNING_CODE)
            call process_error(return_flag); if (return_flag) RETURN
         else
            if (have_cdata_section_handler) then
               call cdata_section_handler(str(fx%pcdata))
            ! Note that this will replace entities!
            else if (have_pcdata_handler) then
               if (fx%debug) print *, &
                    "... Warning: CDATA section chunk processed as pcdata"
               call pcdata_chunk_handler(str(fx%pcdata))
            endif
         endif

      else if (signal == EXCEPTION) then
         call build_error_info(fxml%error_info, fx%action, &
                  line(fb),column(fb),fx%element_stack,SEVERE_ERROR_CODE)
         call process_error(return_flag); if (return_flag) RETURN
      else
         ! QUIET, do nothing
      endif
      ! FIXME: Clarify intent, and fix type bug in argument of signal_handler
      if (signal /= QUIET) then
         if (have_signal_handler) then
            call signal_handler(pause_signal)
            if (pause_signal) exit
         endif
      endif

enddo

CONTAINS

  subroutine process_error(return_flag)
    logical, intent(out) :: return_flag

    ! This flag, if .true., will make the parser return to
    ! the caller with a 'stat' code and information in fx
    !
    return_flag = .false.
    if (have_stat_argument) then
       stat = 0
       if (fxml%error_info%severity == SEVERE_ERROR_CODE) then
          stat = -2
          return_flag = .true.
       endif
    else
       if (have_error_handler) then
          call error_handler(fxml%error_info)
       else
          call default_error_handler(fxml%error_info)
       endif
    endif
  end subroutine process_error
  
end subroutine xml_parse

!-----------------------------------------
subroutine xml_path(fxml,path)
  type(xml_t), intent(in) :: fxml
  character(len=*), intent(out)  :: path
  
  call get_elstack_signature(fxml%fx%element_stack,path)
  
end subroutine xml_path

!-----------------------------------------
subroutine xml_mark_path(fxml,path)
  !
  ! Marks the current path
  !
  type(xml_t), intent(inout) :: fxml
  character(len=*), intent(out)  :: path
  
  call get_elstack_signature(fxml%fx%element_stack,fxml%path_mark)
  path = fxml%path_mark
  
end subroutine xml_mark_path

!-----------------------------------------
subroutine xml_get_path_mark(fxml,path)
  !
  ! Returns the currently markd path (or an empty string if there are no marks)
  !
  type(xml_t), intent(in)        :: fxml
  character(len=*), intent(out)  :: path
  
  path = fxml%path_mark
  
end subroutine xml_get_path_mark

!-----------------------------------------
subroutine xml_name(fxml,name)
  type(xml_t), intent(in) :: fxml
  character(len=*), intent(out)  :: name
  
  name = str(fxml%fx%element_name)
  
end subroutine xml_name
!-----------------------------------------
subroutine xml_attributes(fxml,attributes)
  type(xml_t), intent(in) :: fxml
  type(dictionary_t), intent(out)  :: attributes
  
  attributes = fxml%fx%attributes
  
end subroutine xml_attributes

end module m_xml_parser

module m_wxml_buffer

use m_wxml_error

implicit none

!
! At this point we use a fixed-size buffer. 
! Note however that buffer overflows will only be
! triggered by overly long *unbroken* pcdata values, or
! by overly long attribute values. Hopefully
! element or attribute names are "short enough".
! There is code in the parser module  m_fsm to avoid buffer overflows
! caused by pcdata values.
!
! This module is re-used from the parser package, except the size.
! Most of the routines are superfluous at this point.
!
! In a forthcoming implementation it could be made dynamical...
!
integer, parameter, public   :: MAX_BUFF_SIZE  = 10000
integer, parameter, private  :: BUFF_SIZE_WARNING  = 9500
!
type, public  :: buffer_t
private
      integer                       :: size
      character(len=MAX_BUFF_SIZE)  :: str
end type buffer_t

public :: add_to_buffer, add_to_buffer_escaping_markup
public :: print_buffer, str, char, len
public :: operator (.equal.)
public :: buffer_nearly_full, reset_buffer

private
!----------------------------------------------------------------
interface add_to_buffer
      module procedure add_str_to_buffer
end interface
private :: add_char_to_buffer, add_str_to_buffer

interface operator (.equal.)
      module procedure compare_buffers, compare_buffer_str, &
             compare_str_buffer
end interface
private :: compare_buffers, compare_buffer_str, compare_str_buffer

interface str
      module procedure buffer_to_str
end interface
interface char                 ! Experimental
      module procedure buffer_to_str
end interface
private :: buffer_to_str

interface len
   module procedure buffer_length
end interface
private :: buffer_length

CONTAINS
!==================================================================

!----------------------------------------------------------------
function compare_buffers(a,b) result(equal)     ! .equal. generic
type(buffer_t), intent(in)  :: a
type(buffer_t), intent(in)  :: b
logical                     :: equal

equal = ((a%size == b%size) .and. (a%str(1:a%size) == b%str(1:b%size)))

end function compare_buffers

!----------------------------------------------------------------
function compare_buffer_str(buffer,str) result(equal) ! .equal. generic
type(buffer_t), intent(in)   :: buffer
character(len=*), intent(in) :: str
logical                      :: equal

equal = (buffer%str(1:buffer%size) == trim(str))

end function compare_buffer_str

!----------------------------------------------------------------
function compare_str_buffer(str,buffer) result(equal) ! .equal. generic
character(len=*), intent(in) :: str
type(buffer_t), intent(in)   :: buffer
logical                     :: equal

equal = (buffer%str(1:buffer%size) == trim(str))

end function compare_str_buffer

!----------------------------------------------------------------
subroutine add_char_to_buffer(c,buffer)
character(len=1), intent(in)   :: c
type(buffer_t), intent(inout)  :: buffer

integer   :: n
buffer%size = buffer%size + 1
n = buffer%size

if (n> MAX_BUFF_SIZE) then
  call wxml_error("Buffer overflow: long unbroken string of pcdata or attribute value...")
endif

buffer%str(n:n) = c
end subroutine add_char_to_buffer

!----------------------------------------------------------------
subroutine add_str_to_buffer(s,buffer)
character(len=*), intent(in)   :: s
type(buffer_t), intent(inout)  :: buffer

integer   :: i, n, len_s, last_pos

len_s = len(s)
last_pos = buffer%size
buffer%size = buffer%size + len_s
n = buffer%size

if (n> MAX_BUFF_SIZE) then
  call wxml_error("Buffer overflow: long unbroken string of pcdata or attribute value...")
endif

if (len_s.gt.0) buffer%str(last_pos+1:n) = s
end subroutine add_str_to_buffer

subroutine add_to_buffer_escaping_markup(s,buf)
character(len=*), intent(in)      ::   s
type(buffer_t), intent(inout)     ::   buf

integer           :: len_s, i
character(len=1)  :: c

len_s = len(s)
i = 0
do 
 if (i==len_s) exit
 i = i + 1
 c = s(i:i)
 if (c == "<") then
    call add_to_buffer("&lt;",buf)
 else if (c == "&") then
    call add_to_buffer("&amp;",buf)
 else if (c == "'") then
    call add_to_buffer("&apos;",buf)
 else if (c == '"') then
    call add_to_buffer("&quot;",buf)
 else
    call add_to_buffer(c,buf)
 endif
enddo

end subroutine add_to_buffer_escaping_markup

!----------------------------------------------------------------
subroutine reset_buffer(buffer)
type(buffer_t), intent(inout)  :: buffer

buffer%size = 0

end subroutine reset_buffer

!----------------------------------------------------------------
subroutine print_buffer(buffer)
type(buffer_t), intent(in)  :: buffer

integer :: i

do i = 1, buffer%size
      write(unit=6,fmt="(a1)",advance="no") buffer%str(i:i)
enddo

end subroutine print_buffer
!----------------------------------------------------------------
! This is better... but could it lead to memory leaks?
!
function buffer_to_str(buffer) result(str)
type(buffer_t), intent(in)          :: buffer
character(len=buffer%size)          :: str

str = buffer%str(1:buffer%size)
end function buffer_to_str

!----------------------------------------------------------------
function buffer_nearly_full(buffer) result(warn)
type(buffer_t), intent(in)          :: buffer
logical                             :: warn

warn = buffer%size > BUFF_SIZE_WARNING

end function buffer_nearly_full

!----------------------------------------------------------------
function buffer_length(buffer) result(length)
type(buffer_t), intent(in)          :: buffer
integer                             :: length

length = buffer%size 

end function buffer_length


end module m_wxml_buffer

program pseudo
!
! Example driver for the construction of data structures from an xml document
!
use xmlf90_sax
use m_pseudo      ! Defines begin_element, end_element, pcdata_chunk

integer      :: iostat
type(xml_t)  :: fxml

call open_xmlfile(SAX_DATA_DIR//"pseudo.xml",fxml,iostat)
if (iostat /=0) stop "Cannot open file"

call xml_parse(fxml, &
                begin_element,end_element,pcdata_chunk,verbose=.false.)

end program pseudo

module m_pseudo_types
!
! Data structures for a prototype pseudopotential
!
integer, parameter, private    :: MAXN_POTS = 8
integer, parameter, private    :: dp = selected_real_kind(14)
!
public  :: dump_pseudo
!
!-----------------------------------------------------------
type, public :: grid_t
!
!     It should be possible to represent both log and linear
!     grids with a few parameters here.
!
      character(len=20)              :: type
      real(kind=dp)                  :: scale
      real(kind=dp)                  :: step 
      integer                        :: npts 
end type grid_t      
!
type, public :: radfunc_t
      type(grid_t)                            :: grid
      real(kind=dp), dimension(:), pointer    :: data
end type radfunc_t      
      
type, public :: vps_t
      integer                        :: l
      integer                        :: n
      integer                        :: spin
      real(kind=dp)                  :: occupation
      real(kind=dp)                  :: cutoff
      type(radfunc_t)                :: V
end type vps_t

type, public :: header_t
        character(len=2)        :: symbol
        real(kind=dp)           :: zval
        character(len=10)       :: creator
        character(len=10)       :: date
        character(len=40)       :: flavor
        logical                 :: relativistic
        logical                 :: polarized
        character(len=2)        :: correlation
        character(len=4)        :: core_corrections
end type header_t

type, public :: pseudo_t
      type(header_t)                     :: header
      integer                            :: npots 
      integer                            :: npots_down
      integer                            :: npots_up 
      type(vps_t), dimension(MAXN_POTS)  :: pot
      type(radfunc_t)                    :: core_charge
      type(radfunc_t)                    :: valence_charge
end type pseudo_t


CONTAINS !===============================================

subroutine dump_pseudo(pseudo)
type(pseudo_t), intent(in), target   :: pseudo

integer  :: i
type(vps_t), pointer :: pp
type(radfunc_t), pointer :: rp

print *, "---PSEUDO data:"

do i = 1, pseudo%npots
      pp =>  pseudo%pot(i)
      rp =>  pseudo%pot(i)%V
      print *, "VPS ", i, " angular momentum: ", pp%l
      print *, "                 n: ", pp%n
      print *, "                 occupation: ", pp%occupation
      print *, "                 cutoff: ", pp%cutoff
      print *, "                 spin: ", pp%spin
      print *, "grid data: ", rp%grid%npts, rp%grid%scale
enddo
rp => pseudo%valence_charge
print *, "grid data: ", rp%grid%npts, rp%grid%scale
rp => pseudo%core_charge
print *, "grid data: ", rp%grid%npts, rp%grid%scale

end subroutine dump_pseudo

end module m_pseudo_types

program pseudoxml
!
! Converts legacy Froyen-style pseudo files to XML
!
use m_pseudo_utils

type(pseudopotential_t)  :: pseudo

call pseudo_read_formatted("PSF",pseudo)
!
! Complete the information in the data structures if possible
!
call pseudo_complete(pseudo)
call pseudo_header_print(6,pseudo)
!
! Output XML
!
call pseudo_write_xml("PSXML",pseudo)

end program pseudoxml

program xmlcheck
!
! Checks for well-formedness of an XML file
!
  use xmlf90_sax
  use iso_fortran_env, only: output_unit, error_unit

  integer :: iostat
  type(xml_t)  :: fxml
  character(len=256) :: filename

  CALL GET_COMMAND_ARGUMENT(1, filename,STATUS=iostat)
  if (iostat /= 0) stop "Cannot get file name from command line"

  call open_xmlfile(trim(filename),fxml,iostat)
  if (iostat /= 0) then
     write(error_unit,"(a)") "Cannot open file " // trim(filename)
     STOP
  endif

  call xml_parse(fxml, verbose = .false.)

  print *, "Characters processed: ", xml_char_count(fxml)

end program xmlcheck

module m_xml_error
!
! Error handling
!
use m_sax_elstack
private

type, public  :: xml_error_t
      character(len=100)  :: message
      integer             :: line
      integer             :: column
      type(elstack_t)     :: stack
      integer             :: severity
end type xml_error_t

integer, public             ::  xml_stderr = 0    ! Unit for error info
integer, public, parameter  ::  SEVERE_ERROR_CODE=0, WARNING_CODE=1

public  :: build_error_info, default_error_handler, general_error
public  :: reset_error_info
public  :: print_error_report
public  :: set_xml_stderr

CONTAINS

!-------------------------------------------------------------------------
subroutine build_error_info(error_info,message,line,column,stack,severity)
type(xml_error_t), intent(out)        :: error_info
integer, intent(in)                   :: line, column
character(len=*), intent(in)          :: message
type(elstack_t), intent(in)           :: stack
integer, intent(in)                   :: severity

error_info%message = message
error_info%line = line
error_info%column = column
error_info%stack = stack
error_info%severity = severity

end subroutine build_error_info

subroutine reset_error_info(error_info)
type(xml_error_t), intent(out)        :: error_info

error_info%message = ""
error_info%line = -1
error_info%column = -1
call reset_elstack(error_info%stack)
error_info%severity = -1

end subroutine reset_error_info

!--------------------------------------------------

subroutine print_error_report(error_info, lun)
type(xml_error_t), intent(in)            :: error_info
integer, intent(in)                      :: lun

if (error_info%severity == SEVERE_ERROR_CODE)  then
   write(unit=lun,fmt="(a)") "*** XML parsing Error:"
else if (error_info%severity == WARNING_CODE)  then
   write(unit=lun,fmt="(a)") "*** XML parsing Warning:"
endif

write(unit=lun,fmt="(a)") trim(error_info%message)
write(unit=lun,fmt="(a,i8,a,i4)") "Line: ", &
                                         error_info%line, &
                                         " Column: ", &
                                         error_info%column
write(unit=lun,fmt="(a)") "Element traceback:"
call print_elstack(error_info%stack,unit=lun)
!

end subroutine print_error_report

subroutine default_error_handler(error_info)
type(xml_error_t), intent(in)            :: error_info
!
! Default error handling
!
call print_error_report(error_info, xml_stderr)
!
!   If there is a severe error the program should stop...
!
if (error_info%severity == SEVERE_ERROR_CODE)  then
      STOP
else if (error_info%severity == WARNING_CODE)  then
   write(unit=xml_stderr,fmt="(a)") "*** Continuing after Warning..."
endif

end subroutine default_error_handler

subroutine general_error(msg,code)
character(len=*), intent(in)     :: msg
integer, intent(in)              :: code
!

if (code == SEVERE_ERROR_CODE)  then
   write(unit=xml_stderr,fmt="(2a)") "** Error: ", msg
   STOP
else if (code == WARNING_CODE)  then
   write(unit=xml_stderr,fmt="(2a)") "** Warning: ", msg
else
   stop "wrong error code"
endif

end subroutine general_error

!-------------------------------------------------------------------------
subroutine set_xml_stderr(lun)
integer, intent(in)  :: lun

xml_stderr  = lun

end subroutine set_xml_stderr

end module m_xml_error

      module m_pseudo_utils
!
!     Main module for ps input and output, based on 
!     a derived type representation closely resembling
!     the Froyen data structures.
!
!
!     The radial coordinate is reparametrized to allow a more
!     precise sampling of the area near the origin.

!      r: 0->...
!      x: 0->...
!      i: 1->...

!           r(x) = grid_scale *  [ exp( grid_step*x) - 1 ]
!
!     **** WARNING *****
!     In SIESTA, grid_scale = b, grid_step = a
!     In ATOM,   grid_scale = a, grid_step = b
!     ******************
!
!     pseudo%nr and pseudo%nrval are identical
!     (for ATOM and SIESTA use)
!
!     Working precision should be double precision
!     for backwards binary compatibility 
!
      private

      public :: pseudo_read_formatted
      public :: pseudo_header_print
      public :: pseudo_write_xml
      public :: pseudo_complete
      private :: get_unit

      integer, private, parameter :: dp = selected_real_kind(14)

      type, public  ::  pseudopotential_t
        character(len=2)        :: name
        integer                 :: nr
        integer                 :: nrval
        real(dp)                :: zval
        logical                 :: relativistic
        character(len=2)        :: icorr
        character(len=3)        :: irel
        character(len=4)        :: nicore
        real(dp)                :: grid_scale
        real(dp)                :: grid_step
        character(len=10)       :: method(6)
        character(len=70)       :: text
        integer                 :: npotu
        integer                 :: npotd
        real(dp), pointer       :: r(:)
        real(dp), pointer       :: chcore(:)
        real(dp), pointer       :: chval(:)
        real(dp), pointer       :: vdown(:,:)
        real(dp), pointer       :: vup(:,:)
        integer, pointer        :: ldown(:)
        integer, pointer        :: lup(:)
!
!       Extra fields for more functionality
!
        character(len=10)       :: creator
        character(len=10)       :: date
        character(len=40)       :: flavor
        integer                 :: lmax
        integer, pointer        :: principal_n(:)
        real(dp), pointer       :: occupation(:)
        real(dp), pointer       :: cutoff(:)
      end type pseudopotential_t
!
!     These determine the format for ASCII files
!
      character(len=*), parameter, private ::  &
               fmt_int = "(tr1,i2)" ,                  &
               fmt_nam = "(tr1,a2,tr1,a2,tr1,a3,tr1,a4)", &
               fmt_met = "(tr1,6a10,/,tr1,a70)" ,       &
               fmt_pot= "(tr1,2i3,i5,3es20.12)" ,      &
               fmt_rad = "(4(es20.12))"        ,      &
               fmt_txt = "(tr1,a)"

        CONTAINS

!----
        subroutine pseudo_read_formatted(fname,p)
        character(len=*), intent(in) :: fname
        type(pseudopotential_t)                    :: p

        integer  :: io_ps, i, j, status
        character(len=70) :: dummy
        real(kind=dp)  :: r2

        call get_unit(io_ps,status)
        if (status /= 0) stop "cannot get unit number"
        open(unit=io_ps,file=fname,form="formatted",status="old",&
             action="read",position="rewind")
        write(6,"(3a)") "Reading pseudopotential information ", &
            "in formatted form from ", trim(fname)


        read(io_ps,fmt=fmt_nam) p%name, p%icorr, p%irel, p%nicore
        read(io_ps,fmt_met) (p%method(i),i=1,6), p%text
        read(io_ps,fmt=fmt_pot) p%npotd, p%npotu, p%nr, &
                                p%grid_scale, p%grid_step, p%zval

        p%nrval = p%nr + 1
        p%nr = p%nr + 1
        allocate(p%r(1:p%nrval))
        read(io_ps,fmt=fmt_txt) dummy
        read(io_ps,fmt=fmt_rad) (p%r(j),j=2,p%nrval)
        p%r(1) = 0.d0
        r2=p%r(2)/(p%r(3)-p%r(2))

        if (p%npotd.gt.0) then
           allocate(p%vdown(1:p%npotd,1:p%nrval))
           allocate(p%ldown(1:p%npotd))
        endif
        do i=1,p%npotd
           read(io_ps,fmt=fmt_txt) dummy 
           read(io_ps,fmt=fmt_int) p%ldown(i)
           read(io_ps,fmt=fmt_rad) (p%vdown(i,j), j=2,p%nrval)
           p%vdown(i,1) = p%vdown(i,2) - r2*(p%vdown(i,3)-p%vdown(i,2))
        enddo

        if (p%npotu.gt.0) then
           allocate(p%vup(1:p%npotu,1:p%nrval))
           allocate(p%lup(1:p%npotu))
        endif
        do i=1,p%npotu
           read(io_ps,fmt=fmt_txt) dummy 
           read(io_ps,fmt=fmt_int) p%lup(i)
           read(io_ps,fmt=fmt_rad) (p%vup(i,j), j=2,p%nrval)
           p%vup(i,1) = p%vup(i,2) - r2*(p%vup(i,3)-p%vup(i,2))
        enddo

        allocate(p%chcore(1:p%nrval))
        allocate(p%chval(1:p%nrval))

        read(io_ps,fmt=fmt_txt) dummy
        read(io_ps,fmt=fmt_rad) (p%chcore(j),j=2,p%nrval)
        p%chcore(1) = p%chcore(2) - r2*(p%chcore(3)-p%chcore(2))

        read(io_ps,fmt=fmt_txt) dummy
        read(io_ps,fmt=fmt_rad) (p%chval(j),j=2,p%nrval)
        p%chval(1) = p%chval(2) - r2*(p%chval(3)-p%chval(2))

        close(io_ps)
        end subroutine pseudo_read_formatted
!------

        subroutine vps_init(p)
        type(pseudopotential_t)  :: p
        nullify(p%lup,p%ldown,p%r,p%chcore,p%chval,p%vdown,p%vup)
        end subroutine vps_init

!-------
        subroutine pseudo_header_print(lun,p)
        integer, intent(in) :: lun
        type(pseudopotential_t)  :: p

        integer :: i

        write(lun,"(a)") "<pseudopotential_header>"
        write(lun,fmt=fmt_nam) p%name, p%icorr, p%irel, p%nicore
        write(lun,fmt_met) (p%method(i),i=1,6), p%text
        write(lun,"(a)") "</pseudopotential_header>"

        end subroutine pseudo_header_print
!--------
subroutine pseudo_write_xml(fname,p)
use xmlf90_wxml

character(len=*), intent(in) :: fname
type(pseudopotential_t)      :: p

integer  :: i
type(xmlf_t) :: xf

call xml_OpenFile(fname,xf,indent=.true.)
call xml_AddXMLDeclaration(xf)
call xml_NewElement(xf,"pseudo")
call xml_AddAttribute(xf,"version","0.5")
call xml_NewElement(xf,"header")
call xml_AddAttribute(xf,"symbol",trim(p%name))
!call xml_AddAttribute(xf,"zval",trim(str(p%zval)))
call xml_AddAttribute(xf,"zval",p%zval) ! Overloaded
call xml_AddAttribute(xf,"creator",trim(p%creator))
call xml_AddAttribute(xf,"date",trim(p%date))
call xml_AddAttribute(xf,"flavor",trim(p%flavor))
call xml_AddAttribute(xf,"correlation",trim(p%icorr))

      select case (trim(p%irel))
         case ("isp") 
            call xml_AddAttribute(xf,"relativistic","no")
            call xml_AddAttribute(xf,"polarized","yes")
         case ("nrl")
            call xml_AddAttribute(xf,"relativistic","no")
            call xml_AddAttribute(xf,"polarized","no")
         case ("rel")
            call xml_AddAttribute(xf,"relativistic","yes")
            call xml_AddAttribute(xf,"polarized","no")
      end select
      call xml_AddAttribute(xf,"core-corrections",trim(p%nicore))
call xml_EndElement(xf,"header")

call xml_NewElement(xf,"grid")
      call xml_AddAttribute(xf,"type","log")
      call xml_AddAttribute(xf,"units","bohr")
      call xml_AddAttribute(xf,"scale",p%grid_scale)
      call xml_AddAttribute(xf,"step",p%grid_step)
      call xml_AddAttribute(xf,"npts",p%nr-1)
      call xml_EndElement(xf,"grid")

call xml_NewElement(xf,"semilocal")

      call xml_AddAttribute(xf,"units","rydberg")
      call xml_AddAttribute(xf,"format","r*V")
      call xml_AddAttribute(xf,"npots-down",p%npotd)
      call xml_AddAttribute(xf,"npots-up",p%npotu)

      do i=1,p%npotd
         call xml_NewElement(xf,"vps")
         call xml_AddAttribute(xf,"principal-n", &
                p%principal_n(p%ldown(i)))
         call xml_AddAttribute(xf,"l",p%ldown(i))
         call xml_AddAttribute(xf,"cutoff", &
                p%cutoff(p%ldown(i)))
         call xml_AddAttribute(xf,"occupation", &
                p%occupation(p%ldown(i)))
         call xml_AddAttribute(xf,"spin","-1")

         call xml_NewElement(xf,"radfunc")
         call xml_NewElement(xf,"data")
         call xml_AddArray(xf,p%vdown(i,2:p%nr),fmt_rad)
         call xml_EndElement(xf,"data")
         call xml_EndElement(xf,"radfunc")
         call xml_EndElement(xf,"vps")
      enddo

      do i=1,p%npotu
         call xml_NewElement(xf,"vps")
         call xml_AddAttribute(xf,"principal-n", &
                trim(str(p%principal_n(p%lup(i)))))
         call xml_AddAttribute(xf,"l",trim(str(p%lup(i))))
         call xml_AddAttribute(xf,"cutoff", &
                trim(str(p%cutoff(p%lup(i)))))
         call xml_AddAttribute(xf,"occupation", &
                trim(str(p%occupation(p%lup(i)))))
         call xml_AddAttribute(xf,"spin","-1")

         call xml_NewElement(xf,"radfunc")
         call xml_NewElement(xf,"data")
         call xml_AddArray(xf,p%vup(i,2:p%nr),fmt_rad)
         call xml_EndElement(xf,"data")
         call xml_EndElement(xf,"radfunc")
         call xml_EndElement(xf,"vps")
      enddo

      call xml_EndElement(xf,"semilocal")
      
      call xml_NewElement(xf,"valence-charge")
         call xml_NewElement(xf,"radfunc")
         call xml_NewElement(xf,"data")
         call xml_AddArray(xf,p%chval(2:p%nr),fmt_rad)
         call xml_EndElement(xf,"data")
         call xml_EndElement(xf,"radfunc")
         call xml_EndElement(xf,"valence-charge")

      call xml_NewElement(xf,"pseudocore-charge")
         call xml_NewElement(xf,"radfunc")
         call xml_NewElement(xf,"data")
         call xml_AddArray(xf,p%chcore(2:p%nr),fmt_rad)
         call xml_EndElement(xf,"data")
         call xml_EndElement(xf,"radfunc")
         call xml_EndElement(xf,"pseudocore-charge")

   call xml_EndElement(xf,"pseudo")

   call xml_Close(xf)

end subroutine pseudo_write_xml

!
!  Experimental routine to extract information from "text" field.
!  and to set up more rational fields.
!
subroutine pseudo_complete(p)
type(pseudopotential_t), intent(inout) :: p

integer  :: i, lmax, l, itext, n, status
real(dp) :: zup, zdown, ztot, rc_read

p%creator = p%method(1)
p%date = p%method(2)
p%flavor = p%method(3) // p%method(4) // p%method(5) // p%method(6)

lmax = 0
do i = 1, p%npotd
   lmax = max(lmax,p%ldown(i))
enddo
p%lmax = lmax
allocate(p%principal_n(0:lmax))
allocate(p%occupation(0:lmax))
allocate(p%cutoff(0:lmax))
!
! Decode text into useful information. Assumes l's are increasing from 0
!
if (p%irel=="isp") then
      print *, "Polarized........*************"
      print *, "|", p%text, "|"
      do l=0,min(lmax,3)
         itext=l*17
         read(p%text(itext+1:),iostat=status, &
                     fmt="(i1,tr1,f4.2,tr1,f4.2,tr1,f4.2)") &
                     n, zdown, zup, rc_read
         if (status /=0) STOP "fallo text"
         p%principal_n(l) = n
         p%occupation(l) = zdown+zup
         p%cutoff(l) = rc_read
      enddo
else
      do l=0,min(lmax,3)
         itext=l*17
         read(p%text(itext+1:),iostat=status,fmt="(i1,tr1,f5.2,tr4,f5.2)") &
                      n, ztot, rc_read
         if (status /=0) STOP "fallo text"
         p%principal_n(l) = n
         p%occupation(l) = ztot
         p%cutoff(l) = rc_read
      enddo

endif

end subroutine pseudo_complete


! ----------------------------------------------------------------------
subroutine get_unit(lun,iostat)

! Get an available Fortran unit number

integer, intent(out)  :: lun
integer, intent(out)  :: iostat

integer :: i
logical :: unit_used

do i = 10, 99
   lun = i
   inquire(unit=lun,opened=unit_used)
   if (.not. unit_used) then
      iostat = 0
      return
   endif
enddo
iostat = -1
lun = -1
end subroutine get_unit

end module m_pseudo_utils

module m_handlers

use xmlf90_sax

private

!
! It defines the routines that are called by the XML parser in response
! to particular events.
!
! In this particular example we just print the names of the elements,
! the attribute list, and the content of the pcdata chunks
!
! A module such as this could use "utility routines" to convert pcdata
! to numerical arrays, and to populate specific data structures.
!
public :: begin_element_handler, end_element_handler, pcdata_chunk_handler

CONTAINS  !=============================================================

subroutine begin_element_handler(name,attributes)
character(len=*), intent(in)   :: name
type(dictionary_t), intent(in) :: attributes

write(unit=*,fmt="(2a)") ">>Begin Element: ", name
write(unit=*,fmt="(a,i2,a)") "--- ", len(attributes), " attributes:"
call print_dict(attributes)
end subroutine begin_element_handler

!--------------------------------------------------
subroutine end_element_handler(name)
character(len=*), intent(in)     :: name

  write(unit=*,fmt="(/,2a)") ">>-------------End Element: ", trim(name)

end subroutine end_element_handler

!--------------------------------------------------
subroutine pcdata_chunk_handler(chunk)
character(len=*), intent(in) :: chunk

write(unit=*,fmt="(a)",advance="no") trim(chunk)

end subroutine pcdata_chunk_handler

end module m_handlers

program features

  use xmlf90_dom

  implicit none

  type(fnode), pointer :: myDoc

  myDoc => parsefile(DOM_DATA_DIR//"test.xml" ) !! , verbose=.true.)
  print *, getNumberofAllocatedNodes()
  call dumpTree(myDoc)
  call xmlize(myDoc,"features.xml")
  call destroyNode(myDoc)
end program features

module m_dom_error

  !-------------------------------------------------------
  ! EXCEPTION CODES
  !-------------------------------------------------------
  integer, parameter, public :: INDEX_SIZE_ERR              = 1
  integer, parameter, public :: DOMSTRING_SIZE_ERR          = 2
  integer, parameter, public :: HIERARCHY_REQUEST_ERR       = 3
  integer, parameter, public :: WRONG_DOCUMENT_ERR          = 4
  integer, parameter, public :: INVALID_CHARACTER_ERR       = 5
  integer, parameter, public :: NO_DATA_ALLOWED_ERR         = 6
  integer, parameter, public :: NO_MODIFICATION_ALLOWED_ERR = 7
  integer, parameter, public :: NOT_FOUND_ERR               = 8
  integer, parameter, public :: NOT_SUPPORTED_ERR           = 9
  integer, parameter, public :: INUSE_ATTRIBUTE_ERR         = 10
  integer, parameter, public :: INVALID_STATE_ERR           = 11
  integer, parameter, public :: SYNTAX_ERR                  = 12
  integer, parameter, public :: INVALID_MODIFICATION_ERR    = 13
  integer, parameter, public :: NAMESPACE_ERR               = 14
  integer, parameter, public :: INVALID_ACCESS_ERR          = 15
  integer, parameter, public :: VALIDATION_ERR              = 16
  integer, parameter, public :: TYPE_MISMATCH_ERR           = 17

CONTAINS

  subroutine dom_error(name,code,msg)
    character(len=*), intent(in) :: name, msg
    integer, intent(in)          :: code

    print *, "***ERROR***"
    print *, "Routine ", trim(name), ":", trim(msg)
    print *, 1.0 / sin(3.141592654)
  end subroutine dom_error

end module m_dom_error

program item_context
use xmlf90_xpath
type(xml_t) :: fxml, context
integer :: status
character(len=100) :: what, price, currency
type(dictionary_t) :: attributes

call open_xmlfile(XPATH_DATA_DIR//"inventory.xml",fxml,status)
!
do
   call mark_node(fxml,path="//item",status=status)
   if (status < 0) exit ! No more items
   context = fxml ! Save item context
!
! Search relative to context
!
   call get_node(fxml,path="price", &
        attributes=attributes,pcdata=price,status=status)
   call get_value(attributes,"currency",currency,status)
   if (status /= 0) stop "missing currency attribute!"
!
! Rewind to beginning of context

   !FIXME: undefined symbol
   !call sync_to_context(fxml,context)
!
! Search relative to context
!
   call get_node(fxml,path="description",pcdata=what,status=status)
   write(unit=*,fmt="(6a)") "Appliance: ", trim(what), &
        ". Price: ", trim(price), " ", trim(currency)
enddo
end program item_context

program pseudo_dom
!
! Move towards DOM-like routines
! for the pseudo schema
! See details in m_psdom.f90

use m_pseudo_types
use m_psdom

! Module
  use xmlf90_dom

type(pseudo_t), target :: pseudo
type(grid_t)           :: global_grid
!
type(string)           :: s         ! to avoid memory leaks

! Pointers to make it easier to manage the data
!
type(header_t),  pointer   :: hp
type(vps_t),  pointer      :: pp

  type(fnode), pointer          :: myDoc
  type(fnode), pointer          :: myNode, np
  type(fnodeList), pointer      :: myList

  integer :: npseudos, i
  character(len=200)  :: value      ! Could be larger, or made into a string

! Parse
! No constructor method - this is fortran !
  myDoc => parsefile(DOM_DATA_DIR//"pseudo.xml")  !  ,verbose=.true.)
  print *, "Number of active nodes: ", getNumberofAllocatedNodes()

!  call dumpTree(myDoc)
  print *, "Normalizing...(can take long if big file --- not really needed)"
  call normalize(myDoc)
!  call dumpTree(myDoc)

  print *, "Number of active nodes: ", getNumberofAllocatedNodes()  

!----------------------------------------------------------  

  myList => getElementsByTagName(myDoc, "pseudo")
  if (getLength(myList) == 0) then
     call die("Did not found any pseudo elements...")
  endif
  myNode => item(myList, 0)

  value = getAttribute(myNode,"version")
  if (value == "0.5") then
     print *, "Processing a PSEUDO version 0.5 XML file"
     pseudo%npots = 0
     global_grid%npts = 0
  else
     print *, "Can only work with PSEUDO version 0.5 XML files"
     STOP
  endif

  global_grid%npts = 0          ! To flag absence of global grid info
  myList => getChildNodes(myNode)
  do i=0, getLength(myList) - 1
     np => item(myList,i)
     s = getNodeName(np)
     if (s == "grid") then
        print *, "This file has a global grid... "
        call getGrid(np,global_grid)
        exit
     endif
  enddo
!
! Header
!
  myList => getElementsByTagName(myDoc, "header")
  if (getLength(myList) == 0) then
     call die("Did not found any header elements...")
  endif
  myNode => item(myList, 0)
  print *, "Processing header..."
         hp => pseudo%header
         
         hp%symbol = getAttribute(myNode,"symbol")
         if (hp%symbol == "" ) call die("Cannot determine atomic symbol")

         value = getAttribute(myNode,"zval")
         if (value == "") call die("Cannot determine zval")
         read(unit=value,fmt=*) hp%zval
!
         hp%creator = getAttribute(myNode,"creator")
         if (hp%creator == "" ) hp%creator="unknown"

         hp%flavor = getAttribute(myNode,"flavor")
         if (hp%flavor == "" ) hp%flavor="unknown"

         value = getAttribute(myNode,"relativistic")
         if (value == "") hp%relativistic = .false.
         hp%relativistic = (value == "yes")

         value = getAttribute(myNode,"polarized")
         if (value == "") hp%polarized = .false.
         hp%polarized = (value == "yes")

         hp%core_corrections = getAttribute(myNode,"core-corrections")
         if (hp%core_corrections == "" ) hp%core_corrections="nc"

!
!  Valence charge
!
  myList => getElementsByTagName(myDoc, "valence-charge")
  if (getLength(myList) == 0) then
     call die("Did not found the valence charge ...")
  endif
  np => item(myList,0)
  if (associated(np)) then
     print *, "Processing valence charge..."
   !
   !  Get the data (and possible private grid)
   !
     call getRadialFunction(np,global_grid,pseudo%valence_charge)
  endif

!  Core charge
!
  myList => getElementsByTagName(myDoc, "pseudocore-charge")
     np => item(myList,0)
     if (associated(np)) then
        print *, "Processing core charge..."
   !
   !  Get the data (and possible private grid)
   !
     call getRadialFunction(np,global_grid,pseudo%core_charge)
  endif

!
! Semilocal Pseudos
!
  myList => getElementsByTagName(myDoc, "semilocal")
  if (getLength(myList) == 0) then
     call die("Did not found the semilocal element...")
  endif
  np => item(myList, 0)
  if (associated(np)) then
        print *, "Processing semilocal..."

         value = getAttribute(np,"npots-down")
         if (value == "" ) call die("Cannot determine npots-down")
         read(unit=value,fmt=*) pseudo%npots_down

         value = getAttribute(np,"npots-up")
         if (value == "" ) call die("Cannot determine npots-up")
         read(unit=value,fmt=*) pseudo%npots_up

  else
     call die("Cannot find semilocal element")
  endif

  pseudo%npots = 0
  myList => getElementsByTagName(np, "vps")
  if (getLength(myList) == 0) then
     call die("Did not found any vps elements...")
  endif
  npseudos = getLength(myList) 
  do i = 0, npseudos - 1
     print *, "Processing vps i = ", i , "---------------------"
     myNode => item(myList, i)
     pseudo%npots = pseudo%npots + 1
     pp => pseudo%pot(pseudo%npots)
     call getVps(myNode,global_grid,pp)
  enddo

!
!  Show some of the information
!
call dump_pseudo(pseudo)

CONTAINS

!-----------------------------------------------------------------------
      subroutine die(str)
      character(len=*), intent(in), optional   :: str
      if (present(str)) then
         write(unit=0,fmt="(a)") trim(str)
      endif
      write(unit=0,fmt="(a)") "Stopping Program"
      stop
      end subroutine die


end program pseudo_dom

module m_sax_charset
!
! One-byte only, sorry
!
private

integer, parameter, private  :: small_int = selected_int_kind(1)

!--------------------------------------------------------------------------
type, public :: charset_t
! private
      integer(kind=small_int), dimension(0:255) :: mask
end type charset_t


public  :: operator(.in.), operator(+)
public  :: assignment(=)
public  :: print_charset, reset_charset

interface operator(.in.)
      module procedure belongs
end interface
private :: belongs

interface assignment(=)
      module procedure set_string_to_charset, set_codes_to_charset
end interface
private ::  set_string_to_charset, set_codes_to_charset

interface operator(+)
      module procedure add_string_to_charset, &
                       add_code_to_charset, add_codes_to_charset
end interface
private :: add_string_to_charset, add_code_to_charset, add_codes_to_charset

!--------------------------------------------------------------------------

character(len=*), parameter, private :: &
            lowercase = "abcdefghijklmnopqrstuvwxyz",  & 
            uppercase = "ABCDEFGHIJKLMNOPQRSTUVWXYZ", &
            digits    = "0123456789"

integer, parameter, public   :: SPACE           = 32
integer, parameter, public   :: NEWLINE         = 10
integer, parameter, public   :: CARRIAGE_RETURN = 13
integer, parameter, public   :: TAB             =  9

type(charset_t), public    :: initial_name_chars
type(charset_t), public    :: name_chars
type(charset_t), public    :: whitespace
type(charset_t), public    :: valid_chars
type(charset_t), public    :: uppercase_chars

public  :: setup_xml_charsets


CONTAINS !==========================================================

!--------------------------------------------------------------
function belongs(c,charset)  result(res)
character(len=1), intent(in)  :: c
type(charset_t), intent(in)   :: charset
logical                       :: res

integer  :: code

code = ichar(c)
res = (charset%mask(code) == 1)

end function belongs

!--------------------------------------------------------------

function add_string_to_charset(charset,str)  result (sum)
type(charset_t), intent(in)      :: charset
character(len=*), intent(in)     :: str
type(charset_t)                  :: sum

integer :: length, code, i

sum%mask = charset%mask

length = len_trim(str)
do i = 1, length
      code = ichar(str(i:i))
      sum%mask(code) = 1
enddo
end function add_string_to_charset

!--------------------------------------------------------------

function add_code_to_charset(charset,code) result(sum)
type(charset_t), intent(in)      :: charset
integer, intent(in)              :: code
type(charset_t)                  :: sum

if ((code > 255) .or. (code < 0)) return
sum%mask = charset%mask
sum%mask(code) = 1

end function add_code_to_charset

!--------------------------------------------------------------
function add_codes_to_charset(charset,codes) result(sum)
type(charset_t), intent(in)        :: charset
integer, dimension(:), intent(in)  :: codes
type(charset_t)                    :: sum

integer  :: i

sum%mask = charset%mask
do i = 1, size(codes)
      if ((codes(i) > 255) .or. (codes(i) < 0)) cycle
      sum%mask(codes(i)) = 1
enddo
end function add_codes_to_charset

!--------------------------------------------------------------

subroutine set_string_to_charset(charset,str)      
type(charset_t), intent(out)   :: charset
character(len=*), intent(in)   :: str


integer :: length, code, i

charset%mask = 0

length = len_trim(str)
do i = 1, length
      code = ichar(str(i:i))
      charset%mask(code) = 1
enddo

end subroutine set_string_to_charset

!--------------------------------------------------------------

subroutine set_codes_to_charset(charset,codes)      
type(charset_t), intent(out)   :: charset
integer, dimension(:), intent(in)  :: codes

integer :: i

charset%mask = 0

do i = 1, size(codes)
      charset%mask(codes(i)) = 1
enddo

end subroutine set_codes_to_charset


!--------------------------------------------------------------
subroutine print_charset(charset)      
type(charset_t), intent(in)   :: charset

integer :: i

do i = 0, 255
      if (charset%mask(i) == 1) print *, "Code: ", i
enddo
end subroutine print_charset

!--------------------------------------------------------------

subroutine reset_charset(charset)      
type(charset_t), intent(inout)   :: charset

integer :: i

do i = 0, 255
      charset%mask(i) = 0
enddo
end subroutine reset_charset

!--------------------------------------------------------------

!--------------------------------------------------------
subroutine setup_xml_charsets()

integer :: i

uppercase_chars = uppercase
initial_name_chars = (lowercase  // uppercase //  "_:" )
name_chars = initial_name_chars + ( digits // ".-")
whitespace = (/ SPACE, NEWLINE, TAB, CARRIAGE_RETURN /)

valid_chars = whitespace + (/ (i, i=33,255) /)

end subroutine setup_xml_charsets
!--------------------------------------------------------

end module m_sax_charset

program self
use xmlf90_xpath
!
type(xml_t) :: fxml

integer  :: status
character(len=100)  :: pcdata

call open_xmlfile(XPATH_DATA_DIR//"inventory_text.xml",fxml,status)
!
do
      call get_node(fxml,path="//item",pcdata=pcdata,status=status)
      if (status < 0)   exit
      !
      print *, "PCDATA retrieved from item element: ", trim(pcdata)

enddo
end program self

module m_sax_converters

use m_sax_debug

private
!
! Takes a string and turns it into useful data structures,
! such as numerical arrays.
!
! NOTE: The string must contain *homogeneous* data, i.e.: all real numbers,
! all integers, etc.
!
public :: build_data_array

interface build_data_array
      module procedure build_data_array_real_sp,  &
                       build_data_array_real_dp,  &
                       build_data_array_integer
end interface
private :: build_data_array_real_sp
private :: build_data_array_real_dp
private :: build_data_array_integer

private :: token_analysis, is_separator, is_CR_or_LF

CONTAINS

!---------------------------------------------------------------
subroutine build_data_array_real_dp(str,x,n)
integer, parameter  :: dp = selected_real_kind(14)
!
character(len=*), intent(in)                ::  str
real(kind=dp), dimension(:), intent(inout)  ::    x
integer, intent(inout)                      ::    n

integer                            :: ntokens, status, last_pos
character(len=len(str))  :: s

s = str
call token_analysis(s,ntokens,last_pos)
if (debug) print *, "ntokens, last_pos ", ntokens, last_pos
if (debug) print *, s
if ((n + ntokens) > size(x)) STOP "data array full"
read(unit=s(1:last_pos),fmt=*,iostat=status) x(n+1:n+ntokens)
if (status /= 0) STOP "real conversion error"
n = n + ntokens

end subroutine build_data_array_real_dp
!---------------------------------------------------------------

subroutine build_data_array_real_sp(str,x,n)
integer, parameter  :: sp = selected_real_kind(6)
!
character(len=*), intent(in)                :: str
real(kind=sp), dimension(:), intent(inout)  ::    x
integer, intent(inout)                      ::    n

integer                            :: ntokens, status, last_pos
character(len=len(str))  :: s

s = str
call token_analysis(s,ntokens,last_pos)
if (debug) print *, "ntokens, last_pos ", ntokens, last_pos
if (debug) print *, s
if ((n + ntokens) > size(x)) STOP "data array full"
read(unit=s(1:last_pos),fmt=*,iostat=status) x(n+1:n+ntokens)
if (status /= 0) STOP "real conversion error"
n = n + ntokens

end subroutine build_data_array_real_sp

!---------------------------------------------------------------
subroutine build_data_array_integer(str,x,n)
integer, parameter  :: sp = selected_real_kind(14)
!
character(len=*), intent(in)                :: str
integer, dimension(:), intent(inout)        ::    x
integer, intent(inout)                      ::    n

integer                            :: ntokens, status, last_pos
character(len=len(str))  :: s

s = str
call token_analysis(s,ntokens,last_pos)
if (debug) print *, "ntokens, last_pos ", ntokens, last_pos
if (debug) print *, s
if ((n + ntokens) > size(x)) STOP "data array full"
read(unit=s(1:last_pos),fmt=*,iostat=status) x(n+1:n+ntokens)
if (status /= 0) STOP "integer conversion error"
n = n + ntokens

end subroutine build_data_array_integer


!==================================================================

function is_separator(c) result(sep)
character(len=1), intent(in)          :: c
logical                               :: sep

 sep = ((c == char(32)) .or. (c == char(10))             &
         .or. (c == char(9)) .or. (c == char(13)))

end function is_separator
!----------------------------------------------------------------
function is_CR_or_LF(c) result(res)
character(len=1), intent(in)          :: c
logical                               :: res

 res = ((c == char(10)) .or. (c == char(13)))

end function is_CR_or_LF

!==================================================================

subroutine token_analysis(str,ntokens,last_pos)
!
character(len=*), intent(inout)          :: str
integer, intent(out)                     :: ntokens, last_pos
!
!
! Checks the contents of a string and finds the number of tokens it contains
! The standard separator is generalized whitespace (space, tab, CR, or LF)
! It also returns the last useful position in the string (excluding
! separator characters which are not blanks, and thus not caught by the
! (len_)trim fortran intrinsic). This is necessary to perform list-directed
! I/O in the string as an internal file.
! 
! Also, replace on the fly CR and LF by blanks. This is necessary if
! str spans more than one record. In that case, internal reads only 
! look at the first record. 
! -- ** Compiler limits on size of internal record??
!
integer           :: i, str_length
logical           :: in_token
character(len=1)  :: c

in_token = .false.
ntokens = 0
last_pos = 0

str_length = len_trim(str)
!print *, "string length: ", str_length

do i = 1, str_length
      c = str(i:i)

      if (in_token) then
         if (is_separator(c)) then
            in_token = .false.
            if (is_CR_or_LF(c)) str(i:i) = " "
         else
            last_pos = i
         endif

      else   ! not in token
         
         if (is_separator(c)) then
            if (is_CR_or_LF(c)) str(i:i) = " "
            ! do nothing
         else
            in_token = .true.
            last_pos = i
            ntokens = ntokens + 1
         endif
      endif
enddo
!print *, "ntokens, last_pos: ", ntokens, last_pos

end subroutine token_analysis


end module m_sax_converters

module xmlf90_dom

  use m_dom_types
  use m_dom_namednodemap
  use m_dom_nodelist
  use m_dom_attribute
  use m_dom_document
  use m_dom_node
  use m_dom_element
  use m_dom_parse
  use m_dom_utils

  use m_dom_strings

  public

end module xmlf90_dom

module m_wcml

  use xmlf90_wxml, only: xmlf_t, str, xml_OpenFile, xml_Close
  use xmlf90_wxml, only: xml_NewElement, xml_AddPcData, xml_AddAttribute
  use xmlf90_wxml, only: xml_EndElement, xml_AddArray
  use xmlf90_wxml, only: xml_AddXMLDeclaration, xml_AddComment
  use m_wstml, only: stmAddScalar
  use m_wstml, only: stmAddMatrix
  use m_wstml, only: stmAddArray
  use m_wstml, only: stmAddStartTag
  

  PRIVATE

  integer, private, parameter ::  sp = selected_real_kind(6,30)
  integer, private, parameter ::  dp = selected_real_kind(14,100)
  
! CMLUnits
  character(len=*), parameter :: U_ANGSTR = 'units:angstrom'
  character(len=*), parameter :: U_PMETER = 'units:pm'
  character(len=*), parameter :: U_DEGREE = 'units:degree'
  character(len=*), parameter :: U_RADIAN = 'units:radian'
  character(len=*), parameter :: U_INVCM  = 'units:cm-1'
  character(len=*), parameter :: U_KCALMO = 'units:kcal-mole'
  character(len=*), parameter :: U_EVOLT  = 'units:ev'
  character(len=*), parameter :: U_SECOND = 'units:second'
  character(len=*), parameter :: U_VOLT   = 'units:volt'


! CMLCore
  PUBLIC :: cmlAddCoordinates
  PUBLIC :: cmlAddLattice
  PUBLIC :: cmlAddCrystal
  PUBLIC :: cmlAddAngle
  PUBLIC :: cmlAddLength
  PUBLIC :: cmlAddEigenvalue
  PUBLIC :: cmlAddMolecule
  PUBLIC :: cmlAddMetadata
  PUBLIC :: cmlAddProperty
  PUBLIC :: cmlStartMetadataList
  PUBLIC :: cmlEndMetadataList
  PUBLIC :: cmlStartModule
  PUBLIC :: cmlEndModule
  PUBLIC :: cmlStartParameterList
  PUBLIC :: cmlEndParameterList
  PUBLIC :: cmlStartPropertyList
  PUBLIC :: cmlEndPropertyList

! CMLComp
  PUBLIC :: cmlAddParameter
  PUBLIC :: cmlStartStep
  PUBLIC :: cmlEndStep

! CMLComa
  PUBLIC :: cmlStartBandList
  PUBLIC :: cmlEndBandList
  PUBLIC :: cmlAddBand
  public :: cmlAddKpoint

! CMLCore
  INTERFACE cmlAddCoordinates
     MODULE PROCEDURE cmlAddCoordinatesSP
     MODULE PROCEDURE cmlAddCoordinatesDP
  END INTERFACE

  INTERFACE cmlAddLattice
     MODULE PROCEDURE cmlAddLatticeSP
     MODULE PROCEDURE cmlAddLatticeDP
  END INTERFACE

  INTERFACE cmlAddCrystal
     MODULE PROCEDURE cmlAddCrystalSP
     MODULE PROCEDURE cmlAddCrystalDP
  END INTERFACE

  INTERFACE cmlAddAngle
     MODULE PROCEDURE cmlAddAngleSP
     MODULE PROCEDURE cmlAddAngleDP
  END INTERFACE

  INTERFACE cmlAddLength
     MODULE PROCEDURE cmlAddLengthSP
     MODULE PROCEDURE cmlAddLengthDP
  END INTERFACE

  INTERFACE cmlAddEigenvalue
     MODULE PROCEDURE cmlAddEigenvalueSP
     MODULE PROCEDURE cmlAddEigenvalueDP
  END INTERFACE

  INTERFACE cmlAddMolecule
     MODULE PROCEDURE cmlAddMoleculeSP
     MODULE PROCEDURE cmlAddMoleculeDP
     MODULE PROCEDURE cmlAddMolecule3SP
     MODULE PROCEDURE cmlAddMolecule3DP
  END INTERFACE

  INTERFACE cmlAddProperty
     MODULE PROCEDURE cmlAddPropScalarDP
     MODULE PROCEDURE cmlAddPropScalarSP
     MODULE PROCEDURE cmlAddPropScalarI
     MODULE PROCEDURE cmlAddPropScalarCh
     MODULE PROCEDURE cmlAddPropScalarLG  ! only for scalar
     MODULE PROCEDURE cmlAddPropArrayDPSi
     MODULE PROCEDURE cmlAddPropArrayDPSh
     MODULE PROCEDURE cmlAddPropArraySPSi
     MODULE PROCEDURE cmlAddPropArraySPSh
     MODULE PROCEDURE cmlAddPropArrayISi
     MODULE PROCEDURE cmlAddPropArrayISh
     MODULE PROCEDURE cmlAddPropArrayChSi
     MODULE PROCEDURE cmlAddPropArrayChSh
     MODULE PROCEDURE cmlAddPropMatrixDPSi
     MODULE PROCEDURE cmlAddPropMatrixDPSh
     MODULE PROCEDURE cmlAddPropMatrixSPSi
     MODULE PROCEDURE cmlAddPropMatrixSPSh
     MODULE PROCEDURE cmlAddPropMatrixISi
     MODULE PROCEDURE cmlAddPropMatrixISh
     MODULE PROCEDURE cmlAddPropMatrixChSi
     MODULE PROCEDURE cmlAddPropMatrixChSh
  END INTERFACE

  INTERFACE cmlAddParameter
     MODULE PROCEDURE cmlAddParameterCH
     MODULE PROCEDURE cmlAddParameterI
     MODULE PROCEDURE cmlAddParameterSP
     MODULE PROCEDURE cmlAddParameterDP
     MODULE PROCEDURE cmlAddParameterLG
  END INTERFACE

  INTERFACE cmlAddMetadata
     MODULE PROCEDURE cmlAddMetaDataCh
     MODULE PROCEDURE cmlAddMetaDataI
  END INTERFACE

  public :: cmlBeginFile, cmlFinishFile
  public :: cmlStartCML, cmlEndCML
  public :: cmlNamespaceAttribute, cmlAddComment
  
CONTAINS

    subroutine cmlAddComment(xf, comment)
      type(xmlf_t), intent(inout) :: xf
      character(len=*) :: comment

      call xml_AddComment(xf,comment)
    end subroutine cmlAddComment

    subroutine cmlBeginFile(xf, filename, unit, replace)
      type(xmlf_t), intent(out) :: xf
      character(len=*), intent(in) :: filename
      integer, intent(in) :: unit
      logical, intent(in), optional :: replace

      call xml_OpenFile(filename, xf, indent=.true.)
      call xml_AddXMLDeclaration(xf,encoding="UTF-8")

    end subroutine cmlBeginFile

    subroutine cmlFinishFile(xf)
      type(xmlf_t), intent(inout) :: xf

      call xml_Close(xf)

    end subroutine cmlFinishFile
    
    subroutine cmlNamespaceAttribute(xf, prefix, URI)
      ! A fake namespace declaration
      type(xmlf_t), intent(inout) :: xf
      character(len=*), intent(in) :: prefix
      character(len=*), intent(in) :: URI

      call xml_AddAttribute(xf,prefix,URI)

    end subroutine cmlNamespaceAttribute
    
    subroutine cmlStartCml(xf, id, title, convention, dictref, fileId, version)
      type(xmlf_t), intent(inout) :: xf
      character(len=*), intent(in), optional :: id
      character(len=*), intent(in), optional :: title
      character(len=*), intent(in), optional :: convention
      character(len=*), intent(in), optional :: dictref
      character(len=*), intent(in), optional :: fileId
      character(len=*), intent(in), optional :: version

      call xml_NewElement(xf, 'cml')
      if (present(id)) call xml_AddAttribute(xf, 'id', id)
      if (present(title)) call xml_AddAttribute(xf, 'title', title)
      if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)

      call xml_AddAttribute(xf, 'convention', 'CMLComp')

      if (present(fileId)) then
         call xml_AddAttribute(xf, 'fileId', fileId)
      endif
      if (present(version)) then
         call xml_AddAttribute(xf, 'version', version)
      endif

    end subroutine cmlStartCml
    !--------------------------------------------------------------------
    
    subroutine cmlEndCml(xf)
      type(xmlf_t), intent(inout) :: xf

      call cmlAddMetadata(xf, name='dc:contributor', content='Siesta-CML')
      call xml_EndElement(xf, 'cml')

    end subroutine cmlEndCml

  ! =================================================
  ! convenience CML routines
  ! =================================================
  ! -------------------------------------------------
  ! writes a metadataList start/end Tag to xml channel
  ! -------------------------------------------------
  SUBROUTINE cmlStartMetadataList(xf, id, title, conv, dictref, ref, role)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role
    
    call xml_NewElement(xf, 'metadataList')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref)) call xml_AddAttribute(xf, 'ref', ref)
    if (present(role)) call xml_AddAttribute(xf, 'role', role)
    
  END SUBROUTINE cmlStartMetadataList

  SUBROUTINE cmlEndMetadataList(xf)

    implicit none
    type(xmlf_t), intent(inout) :: xf

    Call xml_EndElement(xf, 'metadataList')
    
  END SUBROUTINE cmlEndMetadataList

  ! -------------------------------------------------
  ! writes a Module start/end Tag to xml channel
  ! -------------------------------------------------
  SUBROUTINE cmlStartModule(xf, id, title, conv, dictref, ref, role, serial)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role
    character(len=*), intent(in), optional :: serial
    
    call xml_NewElement(xf, 'module')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref)) call xml_AddAttribute(xf, 'ref', ref)
    if (present(role)) call xml_AddAttribute(xf, 'role', role)
    if (present(serial)) call xml_AddAttribute(xf, 'serial', serial)
    
  END SUBROUTINE cmlStartModule

  SUBROUTINE cmlEndModule(xf)

    implicit none
    type(xmlf_t), intent(inout) :: xf

    Call xml_EndElement(xf, 'module')
    
  END SUBROUTINE cmlEndModule


  ! -------------------------------------------------
  ! writes a propertyList start/end Tag to xml channel
  ! -------------------------------------------------
  SUBROUTINE cmlStartPropertyList(xf, id, title, conv, dictref, ref, role)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role
    
    call xml_NewElement(xf, 'propertyList')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref)) call xml_AddAttribute(xf, 'ref', ref)
    if (present(role)) call xml_AddAttribute(xf, 'role', role)
    
  END SUBROUTINE cmlStartPropertyList

  SUBROUTINE cmlEndPropertyList(xf)

    implicit none
    type(xmlf_t), intent(inout) :: xf

    Call xml_EndElement(xf, 'propertyList')
    
  END SUBROUTINE cmlEndPropertyList


  ! -------------------------------------------------
  ! writes a parameterList start/end Tag to xml channel
  ! -------------------------------------------------
  SUBROUTINE cmlStartParameterList(xf, id, title, conv, dictref, ref, role)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role
    
    call xml_NewElement(xf, 'parameterList')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref)) call xml_AddAttribute(xf, 'ref', ref)
    if (present(role)) call xml_AddAttribute(xf, 'role', role)
    
  END SUBROUTINE cmlStartParameterList

  SUBROUTINE cmlEndParameterList(xf)

    implicit none
    type(xmlf_t), intent(inout) :: xf

    Call xml_EndElement(xf, 'parameterList')
    
  END SUBROUTINE cmlEndParameterList

  ! -------------------------------------------------
  ! writes a step start Tag to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlStartStep(xf, type, index, id, title, conv, ref)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: type
    character(len=*), intent(in), optional :: id
    integer, intent(in), optional :: index
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref

    if (present(index)) then
      call cmlStartModule(xf, id, title, conv, type, ref, 'step', str(index))
    else
      call cmlStartModule(xf, id, title, conv, type, ref, 'step')
    endif
    
  END SUBROUTINE cmlStartStep

  SUBROUTINE cmlEndStep(xf)

    implicit none
    type(xmlf_t), intent(inout) :: xf

    Call xml_EndElement(xf, 'module')
    
  END SUBROUTINE cmlEndStep


  
 
  ! -------------------------------------------------
  ! 1. writes a DP property to xml channel
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddPropScalarDP(xf, value, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)               :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))    call xml_AddAttribute(xf, 'ref', ref)
    call stmAddScalar(xf=xf, value=value, datatype='xsd:double', units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')

  END SUBROUTINE cmlAddPropScalarDP

  ! -------------------------------------------------
  ! 2. writes a Scalar SP property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropScalarSP(xf, property, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    real(kind=sp),    intent(in)           :: property
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref)) call xml_AddAttribute(xf, 'ref', ref)
    call stmAddScalar(xf=xf, value=property, datatype='xsd:float', units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropScalarSP
  
  ! -------------------------------------------------
  ! 3. writes a Scalar integer property to xml channel
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddPropScalarI(xf, value, id, title, conv, dictref, ref, units)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in) :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddScalar(xf=xf, value=value, datatype='xsd:integer', units=units)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropScalarI

  ! -------------------------------------------------
  ! 4. writes a DP Float matrix property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropMatrixDPSi(xf, value, nrows, ncols, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    integer, intent(in)                    :: nrows
    integer, intent(in)                    :: ncols
    real(kind=dp), Intent(in)              :: value(ncols, nrows)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddMatrix(xf=xf, matrix=value, ncols=ncols, nrows=nrows, units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropMatrixDPSi

  SUBROUTINE cmlAddPropMatrixDPSh(xf, value, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    real(kind=dp), intent(in)              :: value(:,:)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units
    
    integer :: nrows, ncols

    ncols=size(value, 2)
    nrows=size(value, 1)

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddMatrix(xf=xf, matrix=value, ncols=ncols, nrows=nrows, units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropMatrixDPSh

  ! -------------------------------------------------
  ! 5. writes an SP Float matrix property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropMatrixSPSi(xf, property, nrows, ncols, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    integer, intent(in)                    :: nrows
    integer, intent(in)                    :: ncols
    real(kind=sp), intent(in)              :: property(ncols,nrows)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddMatrix(xf=xf,matrix=property, ncols=ncols, nrows=nrows, units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropMatrixSPSi

  SUBROUTINE cmlAddPropMatrixSPSh(xf, property, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    real(kind=sp), intent(in)              :: property(:,:)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units

    integer :: nrows, ncols

    ncols=size(property, 2)
    nrows=size(property, 1)

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddMatrix(xf=xf,matrix=property, ncols=ncols, nrows=nrows, units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropMatrixSPSh

  ! -------------------------------------------------
  ! 6. writes an Integer matrix property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropMatrixISi(xf, value, nrows, ncols, id, title, conv, dictref, ref, units)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    integer, intent(in)                    :: nrows
    integer, intent(in)                    :: ncols
    integer, intent(in)                    :: value(nrows,ncols)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(conv))    call xml_AddAttribute(xf, 'ref', ref)
    call stmAddMatrix(xf=xf, matrix=value, ncols=ncols, nrows=nrows, units=units)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropMatrixISi

  SUBROUTINE cmlAddPropMatrixISh(xf, value, id, title, conv, dictref, ref, units)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    integer, intent(in)                    :: value(:,:)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: units

    integer :: nrows, ncols

    ncols=size(value, 2)
    nrows=size(value, 1)

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(conv))    call xml_AddAttribute(xf, 'ref', ref)
    call stmAddMatrix(xf=xf, matrix=value, ncols=ncols, nrows=nrows, units=units)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropMatrixISh


  ! -------------------------------------------------
  ! 7. writes an Array DP property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropArrayDPSi(xf, value, nvalue, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    real(kind=dp), intent(in)              :: value(*)
    integer, intent(in)                    :: nvalue
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref)) call xml_AddAttribute(xf, 'ref', ref)
    call stmAddArray(xf=xf, array=value, nvalue=nvalue, units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropArrayDPSi

  SUBROUTINE cmlAddPropArrayDPSh(xf, value, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    real(kind=dp), intent(in)              :: value(:)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units

    integer :: nvalue
    
    nvalue=size(value)

    call xml_NewElement(xf, 'property')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref)) call xml_AddAttribute(xf, 'ref', ref)
    call stmAddArray(xf=xf, array=value, nvalue=nvalue, units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropArrayDPSh

  ! -------------------------------------------------
  ! 8. writes an Array SP property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropArraySPSi(xf, property, nvalue, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    real(kind=sp), intent(in)              :: property(*)
    integer, intent(in)                    :: nvalue
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddArray(xf=xf, array=property, nvalue=nvalue, units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropArraySPSi

  SUBROUTINE cmlAddPropArraySPSh(xf, property, id, title, conv, dictref, ref, units, fmt)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)              :: property(:)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: fmt
    character(len=*), intent(in), optional :: units

    integer :: nvalue
    
    nvalue=size(property)

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddArray(xf=xf, array=property, nvalue=nvalue, units=units, fmt=fmt)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropArraySPSh

  ! -------------------------------------------------
  ! 9. writes an Array integer property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropArrayISi(xf, value, nvalue, id, title, conv, dictref, ref, units)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    integer, intent(in)                    :: value(*)
    integer, intent(in)                    :: nvalue
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddArray(xf, array=value, nvalue=nvalue, units=units)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropArrayISi

  SUBROUTINE cmlAddPropArrayISh(xf, value, id, title, conv, dictref, ref, units)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    integer, intent(in)                    :: value(:)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: units

    integer :: nvalue

    nvalue=size(value)

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddArray(xf, array=value, nvalue=nvalue, units=units)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropArrayISh


  ! -------------------------------------------------
  ! 10. writes a character property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropScalarCH(xf, value, id, title, conv, dictref, ref, units)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in)           :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddScalar(xf=xf, value=value, units=units)
    call xml_EndElement(xf, 'property')

  END SUBROUTINE cmlAddPropScalarCH


  ! -------------------------------------------------
  ! 11. writes an character matrix property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropMatrixCHSi(xf, value, nrows, ncols, id, title, conv, dictref, ref, units)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    integer,          intent(in)           :: nrows
    integer,          intent(in)           :: ncols
    character(len=*), intent(in)           :: value(ncols,nrows)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddMatrix(xf=xf, matrix=value, ncols=ncols, nrows=nrows, units=units)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropMatrixCHSi


  SUBROUTINE cmlAddPropMatrixCHSh(xf, value, id, title, conv, dictref, ref, units)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    character(len=*), intent(in)           :: value(:,:)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: units

    integer :: nrows, ncols

    ncols=size(value, 2)
    nrows=size(value, 1)

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddMatrix(xf=xf, matrix=value, ncols=ncols, nrows=nrows, units=units)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropMatrixCHSh

  ! -------------------------------------------------
  ! 12. writes an character array value to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropArrayCHSi(xf, value, nvalue, id, title, conv, dictref, ref)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    character(len=*), intent(in)           :: value(*)
    integer,          intent(in)           :: nvalue
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddArray(xf, array=value, nvalue=nvalue)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropArrayCHSi

  SUBROUTINE cmlAddPropArrayCHSh(xf, value, id, title, conv, dictref, ref)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    character(len=*), intent(in)           :: value(:)
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref

    integer :: nvalue

    nvalue=size(value)

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddArray(xf, array=value, nvalue=nvalue)
    call xml_EndElement(xf, 'property')
  END SUBROUTINE cmlAddPropArrayCHSh


  ! -------------------------------------------------
  ! 13. writes a logical property to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddPropScalarLG(xf, value, id, title, conv, dictref, ref, units)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    logical,          intent(in)           :: value
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: units

    call xml_NewElement(xf, 'property')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    call stmAddScalar(xf=xf, value=value, units=units)
    call xml_EndElement(xf, 'property')

  END SUBROUTINE cmlAddPropScalarLG

  !------------------------------------------------------------
  ! END OF PROPERTIES 
  !------------------------------------------------------------



  ! -------------------------------------------------
  ! 1. writes complete DP molecule to xml channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddMoleculeDP(xf, natoms, elements, atomRefs, coords, style, id, title, dictref, fmt)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in)                    :: natoms             ! number of atoms
    real(kind=dp), intent(in)              :: coords(3, natoms)  ! atomic coordinates
    character(len=*), intent(in)           :: elements(natoms)   ! chemical element types
    character(len=*), intent(in), optional :: atomRefs(natoms)       ! id
    character(len=*), intent(in), optional :: id                 ! id
    character(len=*), intent(in), optional :: title              ! the title
    character(len=*), intent(in), optional :: dictref            ! the dictionary reference
    character(len=*), intent(in), optional :: fmt                ! format for coords
    character(len=*), intent(in), optional :: style              ! type of coordinates 

    ! 'x3' for Cartesians, 
    ! 'xFrac' for fractionals
    ! default => cartesians

    ! Internal Variables
    character(len=6) :: id1, id0
    character(len=20):: formt, stylei
    integer          :: i

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f14.8)'
    endif
    if (present(style)) then
       stylei = style
    else
       stylei = 'x3'
    endif

    call stmAddStartTag(xf, 'molecule', id, title, dictref)
    call xml_NewElement(xf, 'atomArray')
    do i = 1, natoms
       write(id0, '(i4)') i
       id0 = adjustl(id0)
       id1 = 'a'
       id1(2:) = id0
       call cmlAddAtom(xf=xf, elem=elements(i), id=trim(id1))
       if (present(atomRefs)) call xml_AddAttribute(xf, 'ref', trim(atomRefs(i)))
       if (stylei .eq. 'x3') then
          call CMLATX39DP(xf, coords(1, i), coords(2, i), coords(3, i), formt)
       elseif (stylei .eq. 'xFrac') then
          call CMLATXF9DP(xf, coords(1, i), coords(2, i), coords(3, i), formt)
       elseif (stylei .eq. 'xyz3') then
          call CMLATXYZ39DP(xf, coords(1, i), coords (2, i), coords(3, i), formt)
       elseif (stylei .eq. 'xyzFrac') then
          call CMLATXYZFRACT9DP(xf, coords(1, i), coords(2, i), coords(3, i), formt)
       endif
       call xml_EndElement(xf, 'atom')
    enddo

    call xml_EndElement(xf, 'atomArray')
    call xml_EndElement(xf, 'molecule')
    
  END SUBROUTINE cmlAddMoleculeDP

  
  ! -------------------------------------------------
  ! 2. writes complete SP molecule to xml channel
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddMoleculeSP(xf, natoms, elements, atomRefs, coords, style, id, title, dictref, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in)                    :: natoms          ! number of atoms
    character(len=*), intent(in)           :: elements(*)     ! chemical element types
    real(kind=sp), intent(in)              :: coords(3, *)    ! atomic coordinates
    character(len=*), intent(in), optional :: atomRefs(natoms)    ! id
    character(len=*), intent(in), optional :: id              ! id
    character(len=*), intent(in), optional :: title           ! the title
    character(len=*), intent(in), optional :: dictref         ! the dictionary reference
    character(len=*), intent(in), optional :: fmt             ! format for coords
    character(len=*), intent(in), optional :: style           ! type of coordinates ('x3'for Cartesians, 'xFrac' 
    ! for fractionals; ' ' = default => cartesians)
    ! Flush on entry and exit
    character(len=6) :: id1, id0
    integer          :: i
    character(len=10):: formt, stylei

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif
    if (present(style)) then
       stylei = style
    else
       stylei = 'x3'
    endif

    call stmAddStartTag(xf, 'molecule', id, title, dictref)
    call xml_NewElement(xf, 'atomArray')
    do i = 1, natoms
       write(id0, '(i4)') i
       id0 = adjustl(id0)
       id1 = 'a'
       id1(2:) = id0
       call cmlAddAtom(xf=xf, elem=elements(i), id=trim(id1))
       if (present(atomRefs)) call xml_AddAttribute(xf, 'ref', trim(atomRefs(i)))
       if (stylei .eq. 'x3') then
          call CMLATX39SP(xf, coords(1, i), coords(2, i), coords(3, i), formt)
       elseif (stylei .eq. 'xFrac') then
          call CMLATXF9SP(xf, coords(1, i), coords(2, i), coords(3, i), formt)
       elseif (stylei .eq. 'xyz3') then
          call CMLATXYZ39SP(xf, coords(1, i), coords(2, i), coords(3, i), formt)
       elseif (stylei .eq. 'xyzFrac') then
          call CMLATXYZFRACT9SP(xf, coords(1, i), coords(2, i), coords(3, i), formt)
       endif
       call xml_EndElement(xf, 'atom')
    enddo

    call xml_EndElement(xf, 'atomArray')
    call xml_EndElement(xf, 'molecule')
    
    
  END SUBROUTINE cmlAddMoleculeSP
  
  
  ! -------------------------------------------------
  ! 1. writes complete DP molecule to xml channel (No. 2)
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddMolecule3DP(xf, natoms, elements, x, y, z, style, id, title, dictref, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in)                    :: natoms          ! number of atoms
    real(kind=dp), intent(in)               :: x(*)
    real(kind=dp), intent(in)               :: y(*)
    real(kind=dp), intent(in)               :: z(*)
    character(len=*), intent(in)           :: elements(*)     ! chemical element types
    character(len=*), intent(in), optional :: id              ! id
    character(len=*), intent(in), optional :: title           ! the title
    character(len=*), intent(in), optional :: dictref         ! the dictionary reference
    character(len=*), intent(in), optional :: fmt             ! format for coords
    character(len=*), intent(in), optional :: style           ! type of coordinates ('x3' for Cartesians, 'xFrac' 
    ! for fractionals; ' ' = default => cartesians)
    character(len=6)  :: id1, id0
    integer           :: i
    character(len=10) :: formt, stylei

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif
    if (present(style)) then
       stylei = trim(style)
    else
       stylei = 'x3'
    endif

    call stmAddStartTag(xf=xf, name='molecule', id=id, title=title, dictref=dictref)
    call xml_NewElement(xf, 'atomArray')

    do i = 1, natoms
       write(id0, '(i4)') i
       id0 = adjustl(id0)
       id1 = 'a'
       id1(2:) = id0
       call cmlAddAtom(xf=xf, elem=elements(i), id=trim(id1))
       if (trim(stylei) .eq. 'x3') then
          call CMLATX39DP(xf, x(i), y(i), z(i), formt)
       elseif (stylei .eq. 'xFrac') then
          call CMLATXF9DP(xf, x(i), y(i), z(i), formt)
       elseif (stylei .eq. 'xyz3') then
          call CMLATXYZ39DP(xf, x(i), y(i), z(i), formt)
       elseif (stylei .eq. 'xyzFrac') then
          call CMLATXYZFRACT9DP(xf, x(i), y(i), z(i), formt)
       endif
       call xml_EndElement(xf, 'atom')
    enddo

    call xml_EndElement(xf, 'atomArray')
    call xml_EndElement(xf, 'molecule')
    
  END SUBROUTINE cmlAddMolecule3DP
  
  
  ! -------------------------------------------------
  ! 2. writes complete SP molecule to xml channel (No. 2)
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddMolecule3SP(xf, natoms, elements, x, y, z, style, id, title, dictref, fmt)


    implicit none
    type(xmlf_t), intent(inout) :: xf
    ! 10 Arguments
    integer, intent(in)                    :: natoms          ! number of atoms
    real(kind=sp), intent(in)               :: x(*)
    real(kind=sp), intent(in)               :: y(*)
    real(kind=sp), intent(in)               :: z(*)
    character(len=*), intent(in)           :: elements(*)      ! chemical element types
    character(len=*), intent(in), optional :: id               ! id
    character(len=*), intent(in), optional :: title            ! the title
    character(len=*), intent(in), optional :: dictref          ! the dictionary reference
    character(len=*), intent(in), optional :: fmt              ! format for coords
    character(len=*), intent(in), optional :: style            ! type of coordinates ('x3' for Cartesians, 'xFrac' 
    ! for fractionals; ' ' = default => cartesians)
    ! Internal variables
    character(len=6)  :: id1, id0
    integer           :: i
    character(len=10) :: formt, stylei

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif
    if (present(style)) then
       stylei = style
    else
       stylei = 'x3'
    endif

    call xml_NewElement(xf, 'molecule')
    call xml_AddAttribute(xf, 'id', id)
    call xml_AddAttribute(xf, 'title', title)
    call xml_AddAttribute(xf, 'dictref', dictref)
    call xml_NewElement(xf, 'atomArray')
    do i = 1, natoms
       write(id0, '(i4)') i
       id0 = adjustl(id0)
       id1 = 'a'
       id1(2:) = id0
       call cmlAddAtom(xf=xf, elem=elements(i), id=trim(id1))
       if (stylei .eq. 'x3') then
          call CMLATX39SP(xf, x(i), y(i), z(i), formt)
       else if (stylei .eq. 'xFrac') then
          call CMLATXF9SP(xf, x(i), y(i), z(i), formt)
       else if (stylei .eq. 'xyz3') then
          call CMLATXYZ39SP(xf, x(i), y(i), z(i), formt)
       else if (stylei .eq. 'xyzFrac') then
          call CMLATXYZFRACT9SP(xf, x(i), y(i), z(i), formt)
       endif
           call xml_EndElement(xf, 'atom')
    enddo

    call xml_EndElement(xf, 'atomArray')
    call xml_EndElement(xf, 'molecule')

  END SUBROUTINE cmlAddMolecule3SP
  
  ! -------------------------------------------------
  ! writes an <atom> start tag
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddAtom(xf, elem, id, charge, hCount, occupancy, fmt)


    implicit none
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in), optional           :: charge     ! formalCharge
    integer, intent(in), optional           :: hCount     ! hydrogenCount
    real(kind=sp), intent(in), optional     :: occupancy  ! hydrogenCount
    character(len=*), intent(in), optional  :: elem       ! chemical element name
    character(len=*), intent(in), optional  :: id         ! atom id
    character(len=*), intent(in), optional  :: fmt        ! format

    ! internal Variable
    character(len=10):: formt
    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    call xml_NewElement(xf, 'atom')
    if (present(elem))      call xml_AddAttribute(xf, 'elementType', trim(elem))
    if (present(id))        call xml_AddAttribute(xf, 'id', id)
    if (present(charge))    call xml_AddAttribute(xf, 'formalCharge', charge)
    if (present(hCount))    call xml_AddAttribute(xf, 'hydrogenCount', hCount)
    if (present(occupancy)) call xml_AddAttribute(xf, 'occupancy', occupancy, formt)

  END SUBROUTINE cmlAddAtom
  
  
  ! -------------------------------------------------
  ! 1. append SP coordinates to atom tag
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddCoordinatesSP(xf, x, y, z, style, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)               :: x, y
    real(kind=sp), intent(in), optional     :: z
    character(len=*), intent(in), optional :: style
    character(len=*), intent(in), optional :: fmt

    ! Internal variable
    character(len=10):: formt
    character(len=10):: stylei
    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif
    if (present(style)) then
       stylei = style
    else
       stylei = 'x3'
    endif

    if (present(z) .and. stylei .eq. 'x3') then
       call CMLATX39SP(xf, x, y, z, formt)
    else if (present(z) .and. stylei .eq. 'xFrac') then
       call CMLATXF9SP(xf, x, y, z, formt)
    else if (present(z) .and. stylei .eq. 'xyz3') then
       call CMLATXYZ39SP(xf, x, y, z, formt)
    else if (present(z) .and. stylei .eq. 'xyzFrac') then
       call CMLATXYZFRACT9SP(xf, x, y, z, formt)
    elseif (.not. present(z) .and. stylei .eq. 'xy2') then
       call CMLATXY9SP(xf, x, y, formt)           
    endif

  END SUBROUTINE cmlAddCoordinatesSP

  ! -------------------------------------------------
  ! 2. append DP coordinates to atom tag
  ! -------------------------------------------------

  SUBROUTINE cmlAddCoordinatesDP(xf, x, y, z, style, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf 
    real(kind=dp), intent(in)               :: x, y
    real(kind=dp), intent(in), optional     :: z
    character(len=*), intent(in), optional :: style
    character(len=*), intent(in), optional :: fmt
    
    ! Internal variable
    character(len=10):: formt
    character(len=10):: stylei
    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif
    if (present(style)) then
       stylei = style
    else
       stylei = 'x3'
    endif
    
    if (present(z) .and. stylei .eq. 'x3') then
       call CMLATX39DP(xf, x, y, z, formt)
    else if (present(z) .and. stylei .eq. 'xFrac') then
       call CMLATXF9DP(xf, x, y, z, formt)
    else if (present(z) .and. stylei .eq. 'xyz3') then
       call CMLATXYZ39DP(xf, x, y, z, formt)
    else if (present(z) .and. stylei .eq. 'xyzFrac') then
       call CMLATXYZFRACT9DP(xf, x, y, z, formt)
    else if (.not. present(z) .and. stylei .eq. 'xy2') then
       call CMLATXY9DP(xf, x, y, formt)           
    endif
    
  END SUBROUTINE cmlAddCoordinatesDP

  
  ! -------------------------------------------------
  ! 1. writes a DP <length> element to output channel
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddLengthDP(xf, length, id, atomRef1, atomRef2, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)     :: length     ! length
    character(len=*), intent(in) :: id         ! length id
    character(len=*), intent(in) :: atomRef1   ! ref to first atom
    character(len=*), intent(in) :: atomRef2   ! ref to second atom
    character(len=*), intent(in) :: fmt        ! format

    optional         :: fmt
    character(len=10):: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    ! Flush on entry and exit
    call CMLLEN9DP(xf, id, atomRef1, atomRef2, length, formt)
  END SUBROUTINE cmlAddLengthDP

  ! -------------------------------------------------
  ! 2. writes a SP <length> element to output channel
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddLengthSP(xf, length, id, atomRef1, atomRef2, fmt)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)     :: length     ! the length
    character(len=*), intent(in) :: id         ! length id
    character(len=*), intent(in) :: atomRef1   ! ref to first atom
    character(len=*), intent(in) :: atomRef2   ! ref to second atom
    character(len=*), intent(in) :: fmt        ! format

    optional         :: fmt
    character(len=10):: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    ! Flush on entry and exit
    call CMLLEN9SP(xf, id, atomRef1, atomRef2, length, formt)
  END SUBROUTINE cmlAddLengthSP


  ! -------------------------------------------------
  ! 1. writes an DP <angle> element to output channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddAngleDP(xf, angle, id, atomRef1, atomRef2, atomRef3, fmt)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)     :: angle        ! the angle
    character(len=*), intent(in) :: id           ! angle id
    character(len=*), intent(in) :: atomRef1     ! ref to first atom
    character(len=*), intent(in) :: atomRef2     ! ref to second atom
    character(len=*), intent(in) :: atomRef3     ! ref to third atom
    character(len=*), intent(in) :: fmt          ! format

    optional         :: fmt
    character(len=10):: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    ! Flush on entry and exit
    call CMLANG9DP(xf, id, atomRef1, atomRef2, atomRef3, angle, formt)
  END SUBROUTINE cmlAddAngleDP

  ! -------------------------------------------------
  ! 2. writes an SP <angle> element to output channel
  ! -------------------------------------------------

  SUBROUTINE cmlAddAngleSP(xf, angle, id, atomRef1, atomRef2, atomRef3, fmt)


    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)     :: angle        ! the angle
    character(len=*), intent(in) :: id           ! angle id
    character(len=*), intent(in) :: atomRef1     ! ref to first atom
    character(len=*), intent(in) :: atomRef2     ! ref to second atom
    character(len=*), intent(in) :: atomRef3     ! ref to third atom
    character(len=*), intent(in) :: fmt          ! format

    optional         :: fmt
    character(len=10):: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    ! Flush on entry and exit
    call CMLANG9SP(xf, id, atomRef1, atomRef2, atomRef3, angle, formt)
  END SUBROUTINE cmlAddAngleSP


  ! -------------------------------------------------
  ! 1. creates and writes a DP <torsion> element
  ! -------------------------------------------------

  SUBROUTINE cmlAddTorsionDP(xf, torsion, id, atomRef1, atomRef2, atomRef3, atomRef4, fmt)


    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)     :: torsion         ! the torsion
    character(len=*), intent(in) :: id              ! torsion id
    character(len=*), intent(in) :: atomRef1        ! ref to first atom
    character(len=*), intent(in) :: atomRef2        ! ref to second atom
    character(len=*), intent(in) :: atomRef3        ! ref to third atom
    character(len=*), intent(in) :: atomRef4        ! ref to fourth atom
    character(len=*), intent(in) :: fmt             ! format

    optional         :: fmt
    character(len=10):: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    ! Flush on entry and exit
    call CMLTOR9DP(xf, id, atomRef1, atomRef2, atomRef3, atomRef4, torsion, formt)
  END SUBROUTINE cmlAddTorsionDP
  
  ! -------------------------------------------------
  ! 2. creates and writes a SP <torsion> element
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddTorsionSP(xf, torsion, id, atomRef1, atomRef2, atomRef3, atomRef4, fmt)


    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)     :: torsion         ! the torsion
    character(len=*), intent(in) :: id              ! torsion id
    character(len=*), intent(in) :: atomRef1        ! ref to first atom
    character(len=*), intent(in) :: atomRef2        ! ref to second atom
    character(len=*), intent(in) :: atomRef3        ! ref to third atom
    character(len=*), intent(in) :: atomRef4        ! ref to fourth atom
    character(len=*), intent(in) :: fmt             ! format

    optional         :: fmt
    character(len=10):: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif

    ! Flush on entry and exit
    call CMLTOR9SP(xf, id, atomRef1, atomRef2, atomRef3, atomRef4, torsion, formt)
  END SUBROUTINE cmlAddTorsionSP


  ! -------------------------------------------------
  ! 1. creates and writes an SP Lattice element
  ! -------------------------------------------------

  SUBROUTINE cmlAddLatticeSP(xf, cell, units, title, id, dictref, conv, lattType, spaceType, fmt)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)               :: cell(3,3)
    character(len=*), intent(in), optional :: units       
    character(len=*), intent(in), optional :: id           ! id
    character(len=*), intent(in), optional :: title        ! title
    character(len=*), intent(in), optional :: dictref      ! dictref
    character(len=*), intent(in), optional :: conv         ! convention
    character(len=*), intent(in), optional :: lattType 
    character(len=*), intent(in), optional :: spaceType    !
    character(len=*), intent(in), optional :: fmt         

    integer :: i
    character(len=10) :: formt
    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'   
    endif

    call xml_NewElement(xf, 'lattice')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(lattType)) call xml_AddAttribute(xf, 'latticeType', lattType)
    if (present(spaceType)) call xml_AddAttribute(xf, 'spaceType', spaceType)

    do i = 1,3
       call xml_NewElement(xf, 'latticeVector')
       if (present(units)) call xml_AddAttribute(xf, 'units', units)
       call xml_AddAttribute(xf, 'dictRef', 'cml:latticeVector')
       call xml_AddPcdata(xf, cell(1,i), formt)
       call xml_AddPcdata(xf, cell(2,i), formt, space=.true.)
       call xml_AddPcdata(xf, cell(3,i), formt, space=.true.)
       call xml_EndElement(xf, 'latticeVector')
    enddo
    call xml_EndElement(xf, 'lattice')
    
  END SUBROUTINE cmlAddLatticeSP


  ! -------------------------------------------------
  ! 2. creates and writes DP Lattice element
  ! -------------------------------------------------

  SUBROUTINE cmlAddLatticeDP(xf, cell, units, title, id, dictref, conv, lattType, spaceType, fmt)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)               :: cell(3,3)
    character(len=*), intent(in), optional :: units       
    character(len=*), intent(in), optional :: id           ! id
    character(len=*), intent(in), optional :: title        ! title
    character(len=*), intent(in), optional :: dictref      ! dictref
    character(len=*), intent(in), optional :: conv         ! 
    character(len=*), intent(in), optional :: lattType     ! 
    character(len=*), intent(in), optional :: spaceType    !
    character(len=*), intent(in), optional :: fmt         

    integer :: i
    character(len=10) :: formt
    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'   
    endif

    call xml_NewElement(xf, 'lattice')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(lattType)) call xml_AddAttribute(xf, 'latticeType', lattType)
    if (present(spaceType)) call xml_AddAttribute(xf, 'spaceType', spaceType)

    do i = 1,3
       call xml_NewElement(xf, 'latticeVector')
       if (present(units)) call xml_AddAttribute(xf, 'units', units)
       call xml_AddAttribute(xf, 'dictRef', 'cml:latticeVector')
       call xml_AddArray(xf,cell(1:,i),fmt)
!       call xml_AddPcdata(xf, cell(1,i), formt)
!       call xml_AddPcdata(xf, cell(2,i), formt, space=.true.)
!       call xml_AddPcdata(xf, cell(3,i), formt, space=.true.)
       call xml_EndElement(xf, 'latticeVector')
    enddo
    call xml_EndElement(xf, 'lattice')

  END SUBROUTINE cmlAddLatticeDP


  ! -------------------------------------------------
  ! 1. creates and writes a DP <cell> element
  ! -------------------------------------------------

  SUBROUTINE cmlAddCrystalDP(xf, a, b, c, alpha, beta, gamma, id, title, dictref, conv, lenunits, angunits, spaceType, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)               :: a, b, c      ! cell parameters
    real(kind=dp), intent(in)               :: alpha        ! alpha cell parameter
    real(kind=dp), intent(in)               :: beta         ! beta cell parameter
    real(kind=dp), intent(in)               :: gamma        ! gamma cell parameter
    character(len=*), intent(in), optional :: id           ! id
    character(len=*), intent(in), optional :: title        ! title
    character(len=*), intent(in), optional :: dictref      ! dictref
    character(len=*), intent(in), optional :: conv         ! convention
    character(len=*), intent(in), optional :: lenunits     ! units for length (default = angstrom)
    character(len=*), intent(in), optional :: angunits     ! units for angles (default = degree)
    character(len=*), intent(in), optional :: spaceType    ! spacegroup
    character(len=*), intent(in), optional :: fmt          ! format

    ! Flush on entry and exit
    character(len=30) ::  lunits, aunits

    if (present(lenunits)) then
       lunits = lenunits
    else
       lunits = U_ANGSTR
    endif
    if (present(angunits)) then
       aunits = angunits
    else
       aunits = U_DEGREE
    endif

    call xml_NewElement(xf=xf, name='crystal')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictRef)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    call stmAddScalar(xf=xf, value=a, title='a', dictref='cml:a', units=lunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=b, title='b', dictref='cml:b', units=lunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=c, title='c', dictref='cml:c', units=lunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=alpha, title='alpha', dictref='cml:alpha', units=aunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=beta,  title='beta',  dictref='cml:beta',  units=aunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=gamma, title='gamma', dictref='cml:gamma', units=aunits, fmt=fmt)
    if (present(spaceType)) then
      call xml_NewElement(xf, 'symmetry')
      call xml_AddAttribute(xf, 'spaceGroup', spaceType)
      call xml_EndElement(xf, 'symmetry')
    endif
    call xml_EndElement(xf, 'crystal')

  END SUBROUTINE cmlAddCrystalDP

  ! -------------------------------------------------
  ! 2. creates and writes a SP <cell> element
  ! -------------------------------------------------

  SUBROUTINE cmlAddCrystalSP(xf, a, b, c, alpha, beta, gamma, id, title, dictref, conv, lenunits, angunits, spaceType, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)     :: a, b, c      ! cell parameters
    real(kind=sp), intent(in)     :: alpha        ! alpha cell parameter
    real(kind=sp), intent(in)     :: beta         ! beta cell parameter
    real(kind=sp), intent(in)     :: gamma        ! gamma cell parameter
    character(len=*), intent(in), optional :: id           ! id
    character(len=*), intent(in), optional :: title        ! title
    character(len=*), intent(in), optional :: dictref      ! dictref
    character(len=*), intent(in), optional :: conv         ! convention
    character(len=*), intent(in), optional :: lenunits     ! units for length (' ' = angstrom)
    character(len=*), intent(in), optional :: angunits     ! units for angles (' ' = degree)
    character(len=*), intent(in), optional :: spaceType    ! spacegroup
    character(len=*), intent(in), optional :: fmt          ! format

    ! Flush on entry and exit
    character(len=30) :: lunits, aunits
    character(len=10) :: formt

    if (present(fmt)) then
       formt = fmt
    else
       formt = '(f8.3)'
    endif
    if (present(lenunits)) then
       lunits = lenunits
    else
       lunits = U_ANGSTR
    endif
    if (present(angunits)) then
       aunits = angunits
    else
       aunits = U_DEGREE
    endif

    call xml_NewElement(xf=xf, name='crystal')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictRef)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    call stmAddScalar(xf=xf, value=a, title='a', dictref='cml:a', units=lunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=b, title='b', dictref='cml:b', units=lunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=c, title='c', dictref='cml:c', units=lunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=alpha, title='alpha', dictref='cml:alpha', units=aunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=beta,  title='beta',  dictref='cml:beta', units=aunits, fmt=fmt)
    call stmAddScalar(xf=xf, value=gamma, title='gamma', dictref='cml:gamma', units=aunits, fmt=fmt)
    if (present(spaceType)) then
      call xml_NewElement(xf, 'symmetry')
      call xml_AddAttribute(xf, 'spaceGroup', spaceType)
      call xml_EndElement(xf, 'symmetry')
    endif
    call xml_EndElement(xf, 'crystal')


  END SUBROUTINE cmlAddCrystalSP
  
  
  ! -------------------------------------------------
  ! 1. creates and writes an DP <eigen> element
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddEigenvalueDP(xf, n, eigvec, eigval, id, title, dictref, fmt)


    implicit none
    type(xmlf_t), intent(inout)            :: xf
    integer, intent(in)                    :: n              ! number of elements
    real(kind=dp), intent(in)              :: eigvec(n, *)   ! eigenvectors
    real(kind=dp), intent(in)              :: eigval(*)      ! eigenvalues
    character(len=*), intent(in), optional :: id             ! id
    character(len=*), intent(in), optional :: title          ! title
    character(len=*), intent(in), optional :: dictref        ! dictionary reference
    character(len=*), intent(in), optional :: fmt            ! format

    ! Flush on entry and exit
    call xml_NewElement(xf, 'eigen')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictRef)
    call stmAddArray(xf=xf, nvalue=n, array=eigval, title='eigenvalues', dictref=dictRef, fmt=fmt)
    call stmAddMatrix(xf=xf, ncols=n, nrows=n, matrix=eigvec, title='eigenvectors', fmt=fmt)
    call xml_EndElement(xf, 'eigen')

  END SUBROUTINE cmlAddEigenvalueDP



  ! -------------------------------------------------
  ! 2. creates and writes an SP <eigen> element
  ! -------------------------------------------------
  
  SUBROUTINE cmlAddEigenvalueSP(xf, n, eigvec, eigval, id, title, dictref, fmt)


    implicit none
    type(xmlf_t), intent(inout) :: xf
    integer, intent(in)          :: n              ! number of elements
    real(kind=sp), intent(in)     :: eigvec(n, *) ! eigenvectors
    real(kind=sp), intent(in)     :: eigval(*)      ! eigenvalues
    character(len=*), intent(in), optional :: id             ! id
    character(len=*), intent(in), optional :: title          ! title
    character(len=*), intent(in), optional :: dictref        ! dictionary reference
    character(len=*), intent(in), optional :: fmt            ! format


    ! Flush on entry and exit
    call xml_NewElement(xf, 'eigen')
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictRef))   call xml_AddAttribute(xf, 'dictRef', dictref)
    call stmAddArray(xf=xf, nvalue=n, array=eigval, title='eigenvalues', dictref=dictRef, fmt=fmt)
    call stmAddMatrix(xf=xf, ncols=n, nrows=n, matrix=eigvec, title='eigenvectors', fmt=fmt)
    call xml_EndElement(xf, 'eigen')

  END SUBROUTINE cmlAddEigenvalueSP


  SUBROUTINE cmlAddMetadataCh(xf, name, content, conv)
    
    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    character(len=*), intent(in) :: content
    character(len=*), optional, intent(in) :: conv
    
    call xml_NewElement(xf, 'metadata')
    call xml_AddAttribute(xf, 'name', name)
    call xml_AddAttribute(xf, 'content', content)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    call xml_EndElement(xf, 'metadata')

  END SUBROUTINE cmlAddMetadataCh

  SUBROUTINE cmlAddMetadataI(xf, name, content, conv)
    
    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in) :: name
    integer, intent(in) :: content
    character(len=*), intent(in), Optional :: conv
    
    call xml_NewElement(xf, 'metadata')
    call xml_AddAttribute(xf, 'name', name)
    call xml_AddAttribute(xf, 'content', content)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    call xml_EndElement(xf, 'metadata')

  END SUBROUTINE cmlAddMetadataI


  ! -------------------------------------------------
  ! 1. creates and writes an Char <parameter> element
  ! -------------------------------------------------


  SUBROUTINE cmlAddParameterCh(xf, value, ref, id, title, conv, cons, units, name, role, dictref)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*) :: value 
    character(len=*), optional :: ref 
    character(len=*), optional :: title
    character(len=*), optional :: id
    character(len=*), optional :: conv
    character(len=*), optional :: cons
    character(len=*), optional :: units
    character(len=*), optional :: name
    character(len=*), optional :: role
    character(len=*), intent(in), optional :: dictref

    call xml_NewElement(xf, 'parameter')
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(cons))    call xml_AddAttribute(xf, 'constraint', cons)
    if (present(name))    call xml_AddAttribute(xf, 'name', name)
    if (present(role))    call xml_AddAttribute(xf, 'role', role)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)

    call stmAddScalar(xf,value,dataType="xsd:string",units=units)

    call xml_EndElement(xf, 'parameter')

  END SUBROUTINE CMLADDPARAMETERCH


  ! -------------------------------------------------
  ! 2. creates and writes an SP <parameter> element
  ! -------------------------------------------------


  SUBROUTINE cmlAddParameterSP(xf, value, ref, title, id, conv, cons, units, name, role, dictref, fmt)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp) :: value 
    character(len=*), optional :: ref 
    character(len=*), optional :: title
    character(len=*), optional :: id
    character(len=*), optional :: conv
    character(len=*), optional :: cons
    character(len=*), optional :: units
    character(len=*), optional :: name
    character(len=*), optional :: role
    character(len=*), optional :: fmt
    character(len=*), intent(in), optional :: dictref

    call xml_NewElement(xf, 'parameter')
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(cons))    call xml_AddAttribute(xf, 'constraint', cons)
    if (present(name))    call xml_AddAttribute(xf, 'name', name)
    if (present(role))    call xml_AddAttribute(xf, 'role', role)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)

    call stmAddScalar(xf,value,dataType="xsd:float",fmt=fmt,units=units)

    call xml_EndElement(xf, 'parameter')

  END SUBROUTINE CMLADDPARAMETERSP


  ! -------------------------------------------------
  ! 3. creates and writes an DP <parameter> element
  ! -------------------------------------------------


  SUBROUTINE cmlAddParameterDP(xf, value, ref, title, id, conv, cons, units, name, role, dictref, fmt)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp) :: value 
    character(len=*), optional :: ref 
    character(len=*), optional :: title
    character(len=*), optional :: id
    character(len=*), optional :: conv
    character(len=*), optional :: cons
    character(len=*), optional :: units
    character(len=*), optional :: name
    character(len=*), optional :: role
    character(len=*), intent(in), optional :: dictref
    character(len=*), optional :: fmt    

    call xml_NewElement(xf, 'parameter')
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(cons))    call xml_AddAttribute(xf, 'constraint', cons)
    if (present(name))    call xml_AddAttribute(xf, 'name', name)
    if (present(role))    call xml_AddAttribute(xf, 'role', role)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)

    call stmAddScalar(xf,value,dataType="xsd:double",fmt=fmt,units=units)

    call xml_EndElement(xf, 'parameter')

  END SUBROUTINE CMLADDPARAMETERDP


  ! -------------------------------------------------
  ! 4. creates and writes an Integer <parameter> element
  ! -------------------------------------------------


  SUBROUTINE cmlAddParameterI(xf, value, ref, id, title, conv, cons, units, name, role, dictref)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    integer :: value 
    character(len=*), optional :: ref 
    character(len=*), optional :: title
    character(len=*), optional :: id
    character(len=*), optional :: conv
    character(len=*), optional :: cons
    character(len=*), optional :: units
    character(len=*), optional :: name
    character(len=*), optional :: role
    character(len=*), intent(in), optional :: dictref

    call xml_NewElement(xf, 'parameter')
    if (present(ref))   call xml_AddAttribute(xf, 'ref', ref)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(id))    call xml_AddAttribute(xf, 'id', id)
    if (present(conv))  call xml_AddAttribute(xf, 'convention', conv)
    if (present(cons))  call xml_AddAttribute(xf, 'constraint', cons)
    if (present(name))  call xml_AddAttribute(xf, 'name', name)
    if (present(role))  call xml_AddAttribute(xf, 'role', role)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)

    call stmAddScalar(xf,value,dataType="xsd:integer",units=units)

    call xml_EndElement(xf, 'parameter')

  END SUBROUTINE CMLADDPARAMETERI


  SUBROUTINE cmlAddParameterLG(xf, value, ref, id, title, conv, cons, units, name, role, dictref)

    implicit none
    type(xmlf_t),     intent(inout)        :: xf
    logical,          intent(in)           :: value 
    character(len=*), intent(in), optional :: ref 
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: cons
    character(len=*), intent(in), optional :: units
    character(len=*), intent(in), optional :: name
    character(len=*), intent(in), optional :: role
    character(len=*), intent(in), optional :: dictref

    call xml_NewElement(xf, 'parameter')
    if (present(ref))     call xml_AddAttribute(xf, 'ref', ref)
    if (present(title))   call xml_AddAttribute(xf, 'title', title)
    if (present(id))      call xml_AddAttribute(xf, 'id', id)
    if (present(conv))    call xml_AddAttribute(xf, 'convention', conv)
    if (present(cons))    call xml_AddAttribute(xf, 'constraint', cons)
    if (present(name))    call xml_AddAttribute(xf, 'name', name)
    if (present(role))    call xml_AddAttribute(xf, 'role', role)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)

    call stmAddScalar(xf,value,dataType="xsd:boolean",units=units)

    call xml_EndElement(xf, 'parameter')

  END SUBROUTINE CMLADDPARAMETERLG


! =================================================
! basic CML routines
! =================================================

  
  ! -------------------------------------------------
  ! 1. adds DP xyz3 to start tag
  ! -------------------------------------------------
  
  SUBROUTINE CMLATXYZ39DP(xf, x3, y3, z3, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp)      :: x3, y3, z3 ! coordinates
    character(len=*)  :: fmt        ! format (default '(f8.3)')
    character(len=45) :: x, y, z

    write(x,fmt) x3
    write(y,fmt) y3
    write(z,fmt) z3

    call xml_AddAttribute(xf, 'xyz3', trim(adjustl(x))//' '//trim(adjustl(y))//' '//trim(adjustl(z)) )

  END SUBROUTINE CMLATXYZ39DP


  ! -------------------------------------------------
  ! 2. adds SP xyz3 to start tag
  ! -------------------------------------------------

  SUBROUTINE CMLATXYZ39SP(xf, x3, y3, z3, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp)      :: x3, y3, z3 ! coordinates
    character(len=*)  :: fmt        ! format (default '(f8.3)')

    character(len=45) :: x, y, z

    write(x,fmt) x3
    write(y,fmt) y3
    write(z,fmt) z3

    call xml_AddAttribute(xf, 'xyz3', trim(adjustl(x))//' '//trim(adjustl(y))//' '//trim(adjustl(z)) )

  END SUBROUTINE CMLATXYZ39SP
  
  ! -------------------------------------------------
  ! 1. adds DP xyzFrac to start tag
  ! -------------------------------------------------
  
  SUBROUTINE CMLATXYZFRACT9DP(xf, x3, y3, z3, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp)      :: x3, y3, z3 ! coordinates
    character(len=*)  :: fmt        ! format (default '(f8.3)')

    character(len=45) :: x, y, z

    write(x,fmt) x3
    write(y,fmt) y3
    write(z,fmt) z3

    call xml_AddAttribute(xf, 'xyzFrac', trim(adjustl(x))//' '//trim(adjustl(y))//' '//trim(adjustl(z)) )

  END SUBROUTINE CMLATXYZFRACT9DP

  ! -------------------------------------------------
  ! 2. adds SP xyzFrac to start tag
  ! -------------------------------------------------

  SUBROUTINE CMLATXYZFRACT9SP(xf, x3, y3, z3, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)     :: x3, y3, z3 ! coordinates
    character(len=*), intent(in) :: fmt        ! format (default '(f8.3)')

    character(len=45) :: x, y, z

    write(x,fmt) x3
    write(y,fmt) y3
    write(z,fmt) z3

    call xml_AddAttribute(xf, 'xyzFrac', trim(adjustl(x))//' '//trim(y)//' '//trim(z))

  END SUBROUTINE CMLATXYZFRACT9SP


  ! -------------------------------------------------
  ! 1. adds DP x3, y3, z3 to start tag
  ! -------------------------------------------------

  SUBROUTINE CMLATX39DP(xf, x3, y3, z3, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)     :: x3, y3, z3 ! coordinates
    character(len=*), intent(in) :: fmt        ! format (default '(f8.3)')

    character(len=45) :: x, y, z

    write(x,fmt) x3
    write(y,fmt) y3
    write(z,fmt) z3

    call xml_AddAttribute(xf, 'x3', x)
    call xml_AddAttribute(xf, 'y3', y)
    call xml_AddAttribute(xf, 'z3', z)

  END SUBROUTINE CMLATX39DP

  ! -------------------------------------------------
  ! 2. adds SP x3, y3, z3 to start tag
  ! -------------------------------------------------

  SUBROUTINE CMLATX39SP(xf, x3, y3, z3, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp), intent(in)     :: x3, y3, z3 ! coordinates
    character(len=*), intent(in) :: fmt        ! format (default '(f8.3)')

    character(len=45) :: x, y, z

    write(x,fmt) x3
    write(y,fmt) y3
    write(z,fmt) z3

    call xml_AddAttribute(xf, 'x3', x)
    call xml_AddAttribute(xf, 'y3', y)
    call xml_AddAttribute(xf, 'z3', z)

  END SUBROUTINE CMLATX39SP


  ! -------------------------------------------------
  ! 1. adds DP xFract, yFract, zFract to start tag
  ! -------------------------------------------------

  SUBROUTINE CMLATXF9DP(xf, xFract, yFract, zFract, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp), intent(in)     :: xFract, yFract, zFract ! coordinates
    character(len=*), intent(in) :: fmt                    ! format (default '(f8.3)')

    character(len=45) :: x, y, z

    write(x,fmt) xFract
    write(y,fmt) yFract
    write(z,fmt) zFract

    call xml_AddAttribute(xf, 'xFract', x)
    call xml_AddAttribute(xf, 'yFract', y)
    call xml_AddAttribute(xf, 'zFract', z)

  END SUBROUTINE CMLATXF9DP
  
  ! -------------------------------------------------
  ! 2. adds SP xfrac, yFractractrac, zFractrac to start tag
  ! -------------------------------------------------
  
  SUBROUTINE CMLATXF9SP(xf, xFract, yFract, zFract, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp)     :: xFract, yFract, zFract   ! fractional coordinates
    character(len=*) :: fmt                      ! format (default '(f8.3)')

    character(len=45) :: x, y, z

    write(x,fmt) xFract
    write(y,fmt) yFract
    write(z,fmt) zFract

    call xml_AddAttribute(xf, 'xFract', x)
    call xml_AddAttribute(xf, 'yFract', y)
    call xml_AddAttribute(xf, 'zFract', z)

  END SUBROUTINE CMLATXF9SP


  ! -------------------------------------------------
  ! 1. adds DP x2, y2 to start tag
  ! -------------------------------------------------

  SUBROUTINE CMLATXY9DP(xf, x2, y2, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=dp)     :: x2, y2   ! coordinates
    character(len=*) :: fmt      ! format (default f8.3)

    character(len=45) :: x, y

    write(x,fmt) x2
    write(y,fmt) y2

    call xml_AddAttribute(xf, 'x2', x)
    call xml_AddAttribute(xf, 'y2', y)
    call xml_AddPcdata(xf, '>')

  END SUBROUTINE CMLATXY9DP

  ! -------------------------------------------------
  ! 2. adds SP x2, y2 to start tag
  ! -------------------------------------------------

  SUBROUTINE CMLATXY9SP(xf, x2, y2, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    real(kind=sp)     :: x2, y2   ! coordinates
    character(len=*) :: fmt      ! format (default f8.3)

    character(len=45) :: x, y

    write(x,fmt) x2
    write(y,fmt) y2

    call xml_AddAttribute(xf, 'x2', x)
    call xml_AddAttribute(xf, 'y2', y)
    call xml_AddPcdata(xf, '>')

  END SUBROUTINE CMLATXY9SP


  ! -------------------------------------------------
  ! 1. creates a DP <length> element
  ! -------------------------------------------------

  SUBROUTINE CMLLEN9DP(xf, id, atomRef1, atomRef2, length, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*) :: id           ! length id
    character(len=*) :: atomRef1     ! ref to first atom
    character(len=*) :: atomRef2     ! ref to second atom
    real(kind=dp)     :: length       ! the length
    character(len=*) :: fmt          ! format
    character(len=20) :: temp

    temp = atomRef1//' '//adjustl(atomRef2)

    call xml_NewElement(xf, 'length')
    call xml_AddAttribute(xf, 'id', id)
    call xml_AddAttribute(xf, 'atomRefs2', temp)
    call xml_AddPcdata(xf, length, fmt)
    call xml_EndElement(xf, 'length')

  END SUBROUTINE CMLLEN9DP
  
  ! -------------------------------------------------
  ! 2. creates a SP <length> element
  ! -------------------------------------------------
  
  SUBROUTINE CMLLEN9SP(xf, id, atomRef1, atomRef2, length, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*) :: id           ! length id
    character(len=*) :: atomRef1     ! ref to first atom
    character(len=*) :: atomRef2     ! ref to second atom
    real(kind=sp)     :: length       ! the length
    character(len=*) :: fmt          ! format
    character(len=20) :: temp

    temp = atomRef1//' '//adjustl(atomRef2)

    call xml_NewElement(xf, 'length')
    call xml_AddAttribute(xf, 'id', id)
    call xml_AddAttribute(xf, 'atomRefs2', temp)
    call xml_AddPcdata(xf, length, fmt)
    call xml_EndElement(xf, 'length')

  END SUBROUTINE CMLLEN9SP


  ! -------------------------------------------------
  ! 1. creates a DP <angle> element
  ! -------------------------------------------------

  SUBROUTINE CMLANG9DP(xf, id, atomRef1, atomRef2, atomRef3, angle, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*) :: id              ! angle id
    character(len=*) :: atomRef1        ! ref to first atom
    character(len=*) :: atomRef2        ! ref to second atom
    character(len=*) :: atomRef3        ! ref to third atom
    real(kind=dp)     :: angle           ! the angle
    character(len=*) :: fmt             ! format
    character(len=20) :: temp

    temp = atomRef1//' '//adjustl(atomRef2)//' '//adjustl(atomRef3)

    call xml_NewElement(xf, 'angle')
    call xml_AddAttribute(xf, 'id', id)
    call xml_AddAttribute(xf, 'atomRefs3', temp)
    call xml_AddPcdata(xf, angle, fmt)
    call xml_EndElement(xf, 'angle')

  END SUBROUTINE CMLANG9DP

  ! -------------------------------------------------
  ! 2. creates a SP <angle> element
  ! -------------------------------------------------

  SUBROUTINE CMLANG9SP(xf, id, atomRef1, atomRef2, atomRef3, angle, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*) :: id              ! angle id
    character(len=*) :: atomRef1        ! ref to first atom
    character(len=*) :: atomRef2        ! ref to second atom
    character(len=*) :: atomRef3        ! ref to third atom
    real(kind=sp)     :: angle           ! the angle
    character(len=*) :: fmt             ! format
    character(len=20) :: temp

    temp = atomRef1//' '//adjustl(atomRef2)//' '//adjustl(atomRef3)

    call xml_NewElement(xf, 'angle')
    call xml_AddAttribute(xf, 'id', id)
    call xml_AddAttribute(xf, 'atomRefs3', temp)
    call xml_AddPcdata(xf, angle, fmt)
    call xml_EndElement(xf, 'angle')

  END SUBROUTINE CMLANG9SP


  ! -------------------------------------------------
  ! 1. creates a DP <torsion> element
  ! -------------------------------------------------
  
  SUBROUTINE CMLTOR9DP(xf, id, atomRef1, atomRef2, atomRef3, atomRef4, torsion, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*) :: id              ! torsion id
    character(len=*) :: atomRef1        ! ref to first atom
    character(len=*) :: atomRef2        ! ref to second atom
    character(len=*) :: atomRef3        ! ref to third atom
    character(len=*) :: atomRef4        ! ref to fourth atom
    real(kind=dp)    :: torsion         ! the torsion
    character(len=*) :: fmt             ! format
    character(len=20) :: temp

    temp = atomRef1//' '//adjustl(atomRef2)//' '//adjustl(atomRef3)//' '//adjustl(atomRef4)

    call xml_NewElement(xf, 'torsion')
    call xml_AddAttribute(xf, 'id', id)
    call xml_AddAttribute(xf, 'atomRefs4', temp)
    call xml_AddPcdata(xf, torsion, fmt)
    call xml_EndElement(xf, 'torsion')

  END SUBROUTINE CMLTOR9DP

  ! -------------------------------------------------
  ! 2. creates a SP <torsion> element
  ! -------------------------------------------------

  SUBROUTINE CMLTOR9SP(xf, id, atomRef1, atomRef2, atomRef3, atomRef4, torsion, fmt)
    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*) :: id              ! torsion id
    character(len=*) :: atomRef1        ! ref to first atom
    character(len=*) :: atomRef2        ! ref to second atom
    character(len=*) :: atomRef3        ! ref to third atom
    character(len=*) :: atomRef4        ! ref to fourth atom
    real(kind=sp)     :: torsion         ! the torsion
    character(len=*) :: fmt             ! format
    character(len=20) :: temp

    temp = atomRef1//' '//adjustl(atomRef2)//' '//adjustl(atomRef3)//' '//adjustl(atomRef4)

    call xml_NewElement(xf, 'torsion')
    call xml_AddAttribute(xf, 'id', id)
    call xml_AddAttribute(xf, 'atomRefs4', temp)
    call xml_AddPcdata(xf, torsion, fmt)
    call xml_EndElement(xf, 'torsion')

  END SUBROUTINE CMLTOR9SP

  ! COMA
  ! Implements routines relating to the (currently unfinished)
  ! CML Condensed Matter schema

  subroutine cmlAddKPoint(xf, coords, weight, kptfmt, wtfmt &
       ,dictRef,convention,title,id,ref,label)
    type(xmlf_t), intent(inout)             :: xf
    real(kind=dp), dimension(3), intent(in) :: coords
    real(kind=dp), intent(in), optional     :: weight
    character(len=*), intent(in), optional   :: kptfmt
    character(len=*), intent(in), optional   :: wtfmt
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: label
    call cmlStartKpoint(xf, coords, weight, kptfmt, wtfmt &
         ,dictRef,convention,title,id,ref,label)
    call cmlEndKpoint(xf)
  end subroutine cmlAddKPoint

  subroutine cmlStartKPoint(xf, coords, weight, kptfmt, wtfmt &
       ,dictRef,convention,title,id,ref,label)
    type(xmlf_t), intent(inout)              :: xf
    real(kind=dp), dimension(3), intent(in)  :: coords
    real(kind=dp), intent(in), optional      :: weight
    character(len=*), intent(in), optional   :: kptfmt
    character(len=*), intent(in), optional   :: wtfmt
    character(len=*), intent(in), optional :: dictRef
    character(len=*), intent(in), optional :: convention
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: label

    character(len=60) :: aux_str
    
    call xml_NewElement(xf, "kpoint")
    if (present(dictRef)) call xml_addAttribute(xf, "dictRef", dictRef)
    if (present(convention)) call xml_addAttribute(xf, "convention", convention)
    if (present(title)) call xml_addAttribute(xf, "title", title)
    if (present(id)) call xml_addAttribute(xf, "id", id)
    if (present(ref)) call xml_addAttribute(xf, "ref", ref)
    if (present(label)) call xml_addAttribute(xf, "label", label)

    if (present(kptfmt)) then
       write(aux_str,fmt=kptfmt) coords
    else
       write(aux_str,fmt="(3f12.8)") coords
    endif
    call xml_AddAttribute(xf, "coords", trim(aux_str))

       
    if (present(weight)) then
       if (present(wtfmt)) then
          write(aux_str,fmt=wtfmt) weight
       else
          write(aux_str,fmt="(f12.8)") weight
       endif
       
       call xml_AddAttribute(xf, "weight", trim(aux_str))
    endif
    
  end subroutine cmlStartKPoint

  subroutine cmlEndKpoint(xf)
    type(xmlf_t), intent(inout) :: xf
    call xml_EndElement(xf, "kpoint")
  end subroutine cmlEndKpoint
  
  subroutine cmlAddBand(xf, kpoint, kweight, bands, kptfmt, eigfmt)

    implicit none
    type(xmlf_t), intent(inout)            :: xf
    real(dp), intent(in) :: kpoint(3)
    real(dp), intent(in) :: kweight
    real(dp), intent(in) :: bands(:)
    character(len=*), intent(in), optional :: kptfmt
    character(len=*), intent(in), optional :: eigfmt
    
    integer :: i, n
    character(len=20) :: k_fmt
    character(len=20) :: kp_c(3)

    if (present(kptfmt)) then
      if (len_trim(kptfmt) > 20) stop 'k-point format too long' 
      k_fmt=kptfmt
    else
      k_fmt='(f10.7)'
    endif

    n = size(bands)

    do i = 1, 3
      write(kp_c(i), k_fmt) kpoint(i)
    enddo

    call xml_NewElement(xf, 'band')
    call xml_AddAttribute(xf, 'kpoint', trim(kp_c(1))//' '//trim(kp_c(2))//' '//trim(kp_c(3)))
    call xml_AddAttribute(xf, 'weight', kweight)
    call stmAddArray(xf, array=bands, nvalue=n, fmt=eigfmt)
    call xml_EndElement(xf, 'band')

    return
    
  end subroutine cmlAddBand
    

  subroutine cmlStartBandList(xf, id, title, conv, dictref, ref, role)

    implicit none
    type(xmlf_t), intent(inout) :: xf
    character(len=*), intent(in), optional :: id
    character(len=*), intent(in), optional :: title
    character(len=*), intent(in), optional :: conv
    character(len=*), intent(in), optional :: dictref
    character(len=*), intent(in), optional :: ref
    character(len=*), intent(in), optional :: role
    
    call xml_NewElement(xf, 'bandList')
    if (present(id)) call xml_AddAttribute(xf, 'id', id)
    if (present(title)) call xml_AddAttribute(xf, 'title', title)
    if (present(dictref)) call xml_AddAttribute(xf, 'dictRef', dictref)
    if (present(conv)) call xml_AddAttribute(xf, 'convention', conv)
    if (present(ref)) call xml_AddAttribute(xf, 'ref', ref)
    if (present(role)) call xml_AddAttribute(xf, 'role', role)
    
  end subroutine cmlStartBandList


  subroutine cmlEndBandList(xf)

    implicit none
    type(xmlf_t), intent(inout) :: xf

    Call xml_EndElement(xf, 'bandList')
    
  end subroutine cmlEndBandList


end module m_wcml

program simple

use xmlf90_wxml

integer, parameter :: dp = selected_real_kind(15,100)

type(xmlf_t) :: xf

integer :: age = 34
real, dimension(20)  :: x
real, dimension(20,20)  :: y

call xml_OpenFile("simple.xml",xf, indent=.true.)

call xml_AddXMLDeclaration(xf,"UTF-8")
call xml_NewElement(xf,"john")
call xml_AddAttribute(xf,"age",age) ! Overloaded int, with trimming
call xml_NewElement(xf,"peter")
call xml_AddAttribute(xf,"with-blanks","  ..Ha..  ")  ! String, no trimming
call xml_NewElement(xf,"tim")
call xml_AddAttribute(xf,"age","37")  ! String, no trimming
call xml_AddAttribute(xf,"weight",123.45_dp,fmt="(f7.3)") ! Overloaded, trimming
call xml_AddAttribute(xf,"cholesterol",167.0,fmt="(f8.0)") ! Overloaded, trimming
call xml_AddAttribute(xf,"realdefault",137.01) ! Overloaded, default fmt, trimming
call xml_EndElement(xf,"tim")
call xml_AddPcdata(xf,"Ping-pong")
call xml_AddPcdata(xf,"champion", line_feed=.false.)
call xml_AddPcdata(xf," in 2004", space=.false., line_feed=.false.)
call xml_NewElement(xf,"data")
call xml_AddAttribute(xf,"units","eV")
call random_number(x)
call random_number(y)
call xml_AddArray(xf,x)
call xml_AddArray(xf,reshape(y,(/ 400 /)))
call xml_EndElement(xf,"data")
call xml_EndElement(xf,"peter")
call xml_EndElement(xf,"john")

call xml_Close(xf)

end program simple

module m_sax_dictionary

use m_sax_buffer
private
!
! A very rough implementation for now
! It uses fixed-length buffers for key/value pairs,
! and the maximum number of dictionary items is hardwired.

integer, parameter, private    :: MAX_ITEMS = 64
type, public :: dictionary_t
   private
   integer                               :: number_of_items
   type(buffer_t), dimension(MAX_ITEMS)  :: key
   type(buffer_t), dimension(MAX_ITEMS)  :: value
end type dictionary_t

!
! Building procedures
!
public  :: add_key_to_dict, add_value_to_dict, init_dict, reset_dict

!
! Query and extraction procedures
!
public  :: len
interface len
   module procedure number_of_entries
end interface
public  :: number_of_entries
public  :: get_key
public  :: get_value
public  :: has_key
public  :: print_dict
!
public  :: get_name

interface get_name
   module procedure get_key
end interface

interface get_value
   module procedure sax_get_value_qname
   module procedure sax_get_value_i
end interface
private :: sax_get_value_qname, sax_get_value_i

CONTAINS

!------------------------------------------------------
function number_of_entries(dict) result(n)
type(dictionary_t), intent(in)   :: dict
integer                          :: n

n = dict%number_of_items

end function number_of_entries

!------------------------------------------------------
function has_key(dict,key) result(found)
type(dictionary_t), intent(in)   :: dict
character(len=*), intent(in)     :: key
logical                          :: found

integer  :: n, i
found = .false.
n = dict%number_of_items
do  i = 1, n
      if (dict%key(i) .EQUAL. key) then
         found = .true.
         exit
      endif
enddo
end function has_key

!------------------------------------------------------
subroutine sax_get_value_qname(dict,key,value,status)
type(dictionary_t), intent(in)            :: dict
character(len=*), intent(in)              :: key
character(len=*), intent(out)             :: value
integer, intent(out)                      :: status
!
integer  :: n, i, ls

ls = len(value)

status = -1
n = dict%number_of_items
do  i = 1, n
      if (dict%key(i) .EQUAL. key) then
         value = str(dict%value(i))
         if (len(dict%value(i)) > ls) then
            status = -10
         else
            status = 0
         endif
         RETURN
      endif
enddo

end subroutine sax_get_value_qname

subroutine sax_get_value_i(dict,i,value,status)
type(dictionary_t), intent(in)            :: dict
integer,          intent(in)              :: i
character(len=*), intent(out)             :: value
integer,          intent(out)             :: status

integer :: ls
ls = len(value)

if (i <= dict%number_of_items) then
      value = str(dict%value(i))
      if (len(dict%value(i)) > ls) then
         status = -10
      else
         status = 0
      endif
else
   value = ""
   status = -1
endif

end subroutine sax_get_value_i


!------------------------------------------------------
subroutine get_key(dict,i,key,status)
!
! Get the i'th key
!
type(dictionary_t), intent(in)            :: dict
integer, intent(in)                       :: i
character(len=*), intent(out)             :: key
integer, intent(out)                      :: status

if (i <= dict%number_of_items) then
      key = str(dict%key(i))
      status = 0
else
      key = ""
      status = -1
endif

end subroutine get_key

!------------------------------------------------------
subroutine add_key_to_dict(key,dict)
type(buffer_t), intent(in)          :: key
type(dictionary_t), intent(inout)   :: dict

integer  :: n

n = dict%number_of_items
if (n == MAX_ITEMS) then
      write(unit=0,fmt=*) "Dictionary capacity exceeded ! size= ", max_items
      RETURN
endif

n = n + 1
dict%key(n) = key
dict%number_of_items = n

end subroutine add_key_to_dict

!------------------------------------------------------
! Assumes we build the dictionary in an orderly fashion,
! so one adds first the key and then immediately afterwards the value.
!
subroutine add_value_to_dict(value,dict)
type(buffer_t), intent(in)          :: value
type(dictionary_t), intent(inout)   :: dict

integer  :: n

n = dict%number_of_items
dict%value(n) = value

end subroutine add_value_to_dict

!------------------------------------------------------
subroutine init_dict(dict)
type(dictionary_t), intent(inout)   :: dict

integer  :: i

dict%number_of_items = 0
do i=1, MAX_ITEMS                      ! To avoid "undefined" status
   call init_buffer(dict%key(i))       ! (Fortran90 restriction)
   call init_buffer(dict%value(i))
enddo
end subroutine init_dict
!------------------------------------------------------
subroutine reset_dict(dict)
type(dictionary_t), intent(inout)   :: dict

dict%number_of_items = 0

end subroutine reset_dict

!------------------------------------------------------
subroutine print_dict(dict)
type(dictionary_t), intent(in)   :: dict

integer  :: i

do i = 1, dict%number_of_items
      print *, trim(str(dict%key(i))), " = ", trim(str(dict%value(i)))
enddo

end subroutine print_dict


end module m_sax_dictionary

module m_wxml_error

implicit none

public :: wxml_fatal, wxml_error

private

interface wxml_warning
  module procedure wxml_warning_base
end interface

interface wxml_error
  module procedure wxml_error_base
end interface

interface wxml_fatal
  module procedure wxml_fatal_base
end interface

contains
!---------------------------------------------------------
! Error handling/trapping routines:

    subroutine wxml_warning_base(msg)
      ! Emit warning, but carry on.
      character(len=*), intent(in) :: msg

      write(6,'(a)') 'WARNING(wxml)'
      write(6,'(a)')  msg

    end subroutine wxml_warning_base

    subroutine wxml_error_base(msg)
      ! Emit error message, clean up file and stop.
      character(len=*), intent(in) :: msg

      write(6,'(a)') 'ERROR(wxml)'
      write(6,'(a)')  msg

      stop

    end subroutine wxml_error_base

    subroutine wxml_fatal_base(msg)
      !Emit error message and abort with coredump. Does not try to
      !close file, so should be used from anything xml_Close might
      !itself call (to avoid infinite recursion!)

      character(len=*), intent(in) :: msg

      write(6,'(a)') 'ERROR(wxml)'
      write(6,'(a)')  msg

      !call pxfabort
      stop

    end subroutine wxml_fatal_base

end module m_wxml_error

program example

  use xmlf90_dom

  type(fnode), pointer     :: myDoc
  type(fnode), pointer     :: myNode, temp,  refNode
  type(fnodeList), pointer :: myList

  myDoc => parsefile(DOM_DATA_DIR//"pseudo.xml",verbose=.true.)
  call dumpTree(myDoc)
  call xmlize(myDoc,"out.xml")

! Get some nodes
  myList => getChildNodes(myDoc)
  print *, "Number of children of doc: ", getLength(myList) 

  myNode => item(myList, 0)
  myList => getChildNodes(myNode)
  print *, "Number of children of first child of doc: ", getLength(myList) 

  myNode => item(myList, 2)
  refNode => getNextSibling(myNode)
  call xmlize(refNode,"ref.xml")

!
!    Note: a single element dumped
!
     call xmlize(myNode,"node.xml")
     temp => cloneNode(myNode,deep=.true.)
     call xmlize(temp,"clone.xml")

     call destroyNode(myNode)
     call xmlize(myDoc,"nosemilocal.xml")
     myNode => insertBefore(getParentNode(refNode),temp,refNode)
     call xmlize(myDoc,"all.xml")

     myList => getElementsByTagName(myDoc,"data")
     print *, "Number of data nodes: ", getLength(myList) 

     call destroyNode(myDoc)

     print *, "Number of active nodes at the end: ", getNumberofAllocatedNodes()

end program example

 program example

   use xmlf90_wxml
   use xmlf90_cml

  integer,  parameter ::  sp = selected_real_kind(6,30)
  integer,  parameter ::  dp = selected_real_kind(14,100)
!
! NB normally you will be writting to the xml file
! from mulitple fortran files/subroutines, therefore
! type(xmlf_t) :: myfile   (below)
! would normally need to be treated as a global
! variable, either in a module or a common block.
! 
  type(xmlf_t) :: myfile
!

  integer           :: num, na
  character(len=10) :: jon
  character(len=2)  :: elements(3)
  real(kind=dp)      :: coords(3,3)
  real(kind=dp)      :: adp

  data coords(1:3,1)/0.0, 0.0, 0.0/
  data coords(1:3,2)/0.5, 0.5, 0.5/
  data coords(1:3,3)/0.4, 0.4, 0.4/

  adp=1.234567890
  na=3
  elements(1) = 'Ca'
  elements(2) = 'Si'
  elements(3) = 'O'
  num = 20
  jon = '   jon'
  
  call xml_OpenFile('output.xml', myfile, indent=.true.)

  ! Start element
  call xml_NewElement(myfile, 'foo')

  ! Add molecule
  call cmlAddMolecule(xf=myfile, natoms=na,elements=elements,coords=coords)                               

  ! Add molecule output in short style
  call cmlAddMolecule(xf=myfile, natoms=na,elements=elements,coords=coords, style='xyz3')

  ! Add molecule output in short style in user supplied format
  call cmlAddMolecule(xf=myfile, natoms=na,elements=elements,coords=coords, style='xyz3', fmt='(f12.6)')

  ! End and Close
  call xml_EndElement(myfile, 'foo')
  call xml_Close(myfile)
 
end program example

module m_xpath_api
!
! XPATH-like API for XML Parsing
! Copyright Alberto Garcia <wdpgaara@lg.ehu.es>, August 2003
!
use xmlf90_sax

private
!
public :: get_node, mark_node, enable_debug, disable_debug

private :: match, process_node, get_path
private :: begin_element, end_element, pcdata_handler, empty_element
private :: pause_parsing

!
integer, private, save                   :: global_status
integer, public, parameter               :: END_OF_FILE  = -1
integer, public, parameter               :: END_OF_ANCESTOR_ELEMENT = -2
integer, public, parameter               :: PCDATA_OVERFLOW = 7

logical, private, save                   :: debug_xpath = .false.
logical, private, save                   :: debug_sax = .false.
character(len=500), private, save        :: path_required
character(len=100), private, save        :: target_path      ! *** Hard limit


logical, private, save                   :: in_target_element = .false.
logical, private, save                   :: in_pcdata_level = .false.

logical, private, save                   :: stop_parsing = .false.
!
! This global variable determines whether we stop after
! getting the initial element tag, or after digesting the full node.
!
logical, private, save                   :: full_node = .true.

logical, private, save                   :: relative_path = .false.
logical, private, save                   :: looking_for_current_element
                             
logical, private, save                        :: attributes_requested
type(dictionary_t), private, save, pointer    :: attributes_recovered

integer, parameter, private                   :: MAX_PCDATA_SIZE = 65536
logical, private, save                        :: pcdata_requested 
character(len=MAX_PCDATA_SIZE), private, &
                                save          :: pcdata_recovered !*** Hard 
integer, private, save                        :: len_pcdata
integer, private, save                        :: max_len_pcdata

type(xml_t), pointer, save, private           :: xp

CONTAINS !===========================================================

!----------------------------------------------------
! Debugging control
!
subroutine enable_debug(sax)
logical, intent(in), optional  :: sax
  debug_xpath = .true.
  debug_sax = .false.
  if (present(sax)) then
     debug_sax = sax
  endif
end subroutine enable_debug

subroutine disable_debug()
  debug_xpath = .false.
end subroutine disable_debug

!----------------------------------------------------
! Main routines
!---------------------------------------------------------------------
subroutine mark_node(fxml,path,att_name,att_value,attributes,status)
!
! Performs a search of a given element (by path, and/or presence of
! a given attribute and/or value of that attribute), returning optionally
! the element's attribute dictionary, and leaving the file handle fxml
! ready to process the rest of the element's contents (child elements
! and/or pcdata).
!
! Side effects: it sets "ancestor_path" to the element's path
!
! If the argument "path" is present and evaluates to a relative path (a
! string not beginning with "/"), the search is interrupted after the end
! of the "ancestor_element" set by a previous call to "mark_node".
! If not earlier, the search ends at the end of the file.
!
! The status argument, if present, will hold a return value, 
! which will be:
!
!   0 on success,
!   negative in case of end-of-file or end-of-ancestor-element, or 
!   positive in case of a malfunction 
!
type(xml_t), intent(inout), target           :: fxml
character(len=*), intent(in), optional       :: path
character(len=*), intent(in), optional       :: att_name
character(len=*), intent(in), optional       :: att_value
type(dictionary_t), intent(out), optional    :: attributes
integer, intent(out), optional               :: status


character(len=200)         :: ancestor_path           ! local variable

     full_node = .false.
     call process_node(fxml,                    &
                       path,att_name,att_value, &
                       attributes,              &
                       status=status)
     if (status == 0) then
        call xml_mark_path(fxml,ancestor_path)
        if (debug_xpath) print *, "Setting ancestor_path to: ", trim(ancestor_path)
     endif

end subroutine mark_node

!--------------------------------------------------------------------
subroutine get_node(fxml,path,att_name,att_value,attributes,pcdata,status)
!
! Performs a search of a given element (by path, and/or presence of
! a given attribute and/or value of that attribute), returning optionally
! the element's attribute dictionary and any PCDATA characters contained
! in the element's scope (but not child elements). It leaves the file handle
! physically and logically positioned:
!
!     after the end of the element's start tag if 'pcdata' is not present
!     after the end of the element's end tag if 'pcdata' is present
!
! If the argument "path" is present and evaluates to a relative path (a
! string not beginning with "/"), the search is interrupted after the end
! of the "ancestor_element" set by a previous call to "mark_node".
! If not earlier, the search ends at the end of the file.
!
! The status argument, if present, will hold a return value, 
! which will be:
!
!   0 on success,
!   negative in case of end-of-file or end-of-ancestor-element, or 
!   positive in case of a malfunction (such as the overflow of the 
!   user's pcdata buffer).
!
type(xml_t), intent(inout), target           :: fxml
character(len=*), intent(in), optional       :: path
character(len=*), intent(in), optional       :: att_name
character(len=*), intent(in), optional       :: att_value
type(dictionary_t), intent(out), optional    :: attributes
character(len=*), intent(out), optional, target      :: pcdata
integer, intent(out), optional               :: status

     full_node = present(pcdata)
     call process_node(fxml,                    &
                       path,att_name,att_value, &
                       attributes,pcdata,       &
                       status=status)

end subroutine get_node
!
!--------------------------------------------------------------------
! Workhorse routines follow
!--------------------------------------------------------------------
subroutine process_node(fxml,path,att_name,att_value, &
                        attributes,pcdata,&
                        status)
type(xml_t), intent(inout), target           :: fxml
character(len=*), intent(in), optional       :: path
character(len=*), intent(in), optional       :: att_name
character(len=*), intent(in), optional       :: att_value
type(dictionary_t), intent(out), optional    :: attributes
character(len=*), intent(out), optional, target      :: pcdata
integer, intent(out), optional               :: status

logical :: path_present, att_name_present, att_value_present
logical :: attributes_present

character(len=3)   :: any_path  = "//*"
character(len=200) :: local_path, ancestor_path      ! *** Hard limit
character(len=500) :: value                          ! *** Hard limit
integer            :: local_status

type(dictionary_t) :: local_attributes

global_status = 0           ! reset

path_present = present(path)
attributes_present = present(attributes)
att_name_present = present(att_name)
att_value_present = present(att_value)

relative_path = .false.

if (path_present) then
   if (debug_xpath) print *, "SEARCHING for: ", trim(path)
   if (path(1:1) /= "/") then
      !
      ! Relative path search
      !
      call xml_path(fxml,local_path)
      call xml_get_path_mark(fxml,ancestor_path)
      if (ancestor_path == "") then
        if (debug_xpath) print *, "Relative search with null ancestor..."
      endif
      relative_path = .true.    
      if (debug_xpath) print *, "Relative search. ANCESTOR ELEMENT: ", &
                             trim(ancestor_path)
      !
      ! Convert to absolute path
      local_path = trim(local_path) // "/" // trim(path)
      if (debug_xpath) print *, "Converting ", trim(path), &
               " to absolute path: ", trim(local_path)
   else
      local_path = path
   endif
else
   local_path = any_path
endif

looking_for_current_element = (path == ".")
!
! Use local_attributes, since it is in principle possible that
! the user does not need to get back the attribute list.
!
do ! Loop until we satisfy the constraints 
   
   if (debug_xpath) print *, "--> Calling get_path ..."
   call get_path(fxml,local_path,local_attributes,pcdata,local_status)
   if (debug_xpath) print *, "-->Status after get_path: ", local_status
   if (local_status /= 0)  EXIT

   if (debug_xpath) print *, "FOUND path matching: ", trim(local_path)

   if (att_name_present) then
      if (debug_xpath) print *, "Checking ", trim(att_name), " among ", &
                          number_of_entries(local_attributes), " entries:"
      if (debug_xpath) call print_dict(local_attributes)

      if (has_key(local_attributes,att_name)) then

         if (att_value_present) then
            call get_value(local_attributes,att_name,value,local_status)
            if (local_status /= 0) then
               if (debug_xpath) print *, "Failed to get value of att: ", &
                                    trim(att_name)
               EXIT
            endif

            if (att_value == value)  then
               local_status = 0
               if (debug_xpath) print *, "Got correct att name and value "
               EXIT
            else
               if (debug_xpath) print *, "att value: ", trim(value), &
                                   " does not match"
               cycle        ! We keep searching
            endif
         else           ! Found att_name, and no value required
            local_status = 0
            if (debug_xpath) print *, "Got correct att name"
            EXIT
         endif
      else              ! Did not find that attribute name
         if (debug_xpath) print *, "Att name not present"
         cycle          ! keep searching
      endif
   else                 ! Found path, and no att info required
      local_status = 0
      if (debug_xpath) print *, "Found correct path. No other reqs."
      EXIT
   endif
   
enddo

if (present(status)) then
   status = local_status
   if (debug_xpath) print *, "--Returning status: ", status
endif

if (attributes_present) then
   attributes = local_attributes
endif

end subroutine process_node

!--------------------------------------------------------------------
subroutine get_path(fxml,path,attributes,pcdata,status)
type(xml_t), intent(inout), target           :: fxml
character(len=*), intent(in)                 :: path
type(dictionary_t), intent(out), optional, target    :: attributes
character(len=*), intent(out), optional, target      :: pcdata
integer, intent(out), optional                       :: status  

logical            :: status_present

xp => fxml

path_required = path
status_present = present(status)
pcdata_requested = (present(pcdata))

attributes_requested = (present(attributes))
if (attributes_requested) then
      call reset_dict(attributes)
      attributes_recovered => attributes
endif

if (pcdata_requested) then
!
!  Make sure we do not overstep the bounds of the supplied argument
!
   max_len_pcdata = min(len(pcdata),MAX_PCDATA_SIZE)
   len_pcdata = 0
   pcdata_recovered(1:max_len_pcdata) = ""
   if (debug_xpath) print *, "Max length of pcdata store: ", max_len_pcdata
endif

if (looking_for_current_element) then
   if (debug_xpath) print *, "Returning info about current element"

   ! We are now in the desired element, and we have the name and
   ! attribute list saved in xp.
   !
   if (attributes_requested) call xml_attributes(xp,attributes_recovered)
   !
   if (pcdata_requested) then
   !
   ! Set things up so that we can get the pcdata
   !
      call xml_path(xp,target_path)
      in_target_element = .true.
      in_pcdata_level = .true.
   else
      if (status_present) status = 0
      RETURN              ! We are done
   endif
else
   target_path = ""
   in_target_element = .false.
   in_pcdata_level = .false.
endif

stop_parsing = .false.

call xml_parse(fxml,  &
               begin_element_handler = begin_element , &
               end_element_handler = end_element,  &
               pcdata_chunk_handler = pcdata_handler, &
               verbose = debug_sax, signal_handler=pause_parsing, &
               empty_element_handler = empty_element)

if (eof_xmlfile(fxml)) then
   global_status = END_OF_FILE
   if (debug_xpath) print *, "Found end of file"
   if (pcdata_requested) pcdata = ""
else if (global_status == END_OF_ANCESTOR_ELEMENT) then
   if (debug_xpath) print *, "Found end of ancestor element"
   if (pcdata_requested) pcdata = ""
else
   if (debug_xpath) print *, "Parser found candidate element"
   if (pcdata_requested) then
      pcdata = pcdata_recovered(1:len_pcdata)
      if (debug_xpath) print *, "PCDATA recovered: ", pcdata_recovered(1:len_pcdata)
   endif
endif
if (global_status > 0) then
   if (debug_xpath) print *, "Something went slightly wrong. Status > 0"
endif
!
if (present(status)) status = global_status  


end subroutine get_path

!==================================================================
subroutine begin_element(name,attributes)
character(len=*), intent(in)   :: name
type(dictionary_t), intent(in) :: attributes

character(len=1000)   :: path              ! *** Hard limit

call xml_path(xp,path)
if (debug_xpath) print *, " begin_element ::: PATH: " ,  trim(path)
if (debug_xpath) print *, "path: ", trim(path), " req: ", trim(path_required)
if (match(path,path_required)) then
      if (debug_xpath) print *, " Match path: " ,  trim(path)
      in_target_element = .true.
      target_path = path
      in_pcdata_level = .true.
      if (debug_xpath) print *, "In element name: " , name
      if (attributes_requested) attributes_recovered = attributes
      ! stop parsing
      if (debug_xpath) print *, "full_node: ", full_node
      if (.not. full_node)  then
         if (debug_xpath) print *, "Stopping parsing after initial tag"
         stop_parsing = .true.
      endif
else 
   !
   ! If we are at the pcdata level and we enter another element, 
   ! we must not read pcdata
   !
   if (in_pcdata_level)   in_pcdata_level = .false.
endif

end subroutine begin_element
!------------------------------------------------------------
subroutine end_element(name)
character(len=*), intent(in)   :: name

character(len=300)   :: path             ! *** Hard limit
character(len=300)   :: left_path        ! *** Hard limit
character(len=300)   :: ancestor_path    ! *** Hard limit
!

call xml_path(xp,path)   ! path *after* leaving element
left_path = trim(path) // "/" // trim(name)

if (in_target_element) then
   if (path == target_path) then
      ! 
      ! We are back to pcdata level after visiting child elements
      !
      in_pcdata_level = .true.

   else  if (left_path == target_path) then

      ! We stop the parsing at the end of the element
      !
      if (debug_xpath) print *, "Exiting target element: ", trim(target_path)
      in_target_element = .false.
      in_pcdata_level = .false.
      if (debug_xpath) print *, "Stopping parsing after end of target element"
      stop_parsing = .true.
   endif
   
else if (relative_path) then
   !
   ! Check in case we go out of ancestor element
   !
   call xml_get_path_mark(xp,ancestor_path)
   if (match(left_path,ancestor_path)) then
      !
      ! We are leaving the ancestor element
      !
      if (debug_xpath) print *, "Relative search. End of element: ", name
      if (debug_xpath) print *, "Leaving Path: ", trim(left_path)
      if (debug_xpath) print *, "Ancestor Path: ", trim(ancestor_path)
      if (debug_xpath) print *, "Stopping parsing after end of ancestor element"
    
      stop_parsing = .true.
      global_status = END_OF_ANCESTOR_ELEMENT
   endif
endif
  
end subroutine end_element

!------------------------------------------------------------
subroutine empty_element(name,attributes)
character(len=*), intent(in)   :: name
type(dictionary_t), intent(in) :: attributes

character(len=300)   :: path              ! *** Hard limit

call xml_path(xp,path)
if (debug_xpath) print *, " empty_element ::: PATH: " ,  trim(path)
if (debug_xpath) print *, "path: ", trim(path), " req: ", trim(path_required)
if (match(path,path_required)) then
      if (debug_xpath) print *, " Match path: " ,  trim(path)
      if (debug_xpath) print *, "In (empty) element name: " , name
      if (attributes_requested) attributes_recovered = attributes
      ! stop parsing
      stop_parsing = .true.
      if (debug_xpath) print *, "Stopping parsing after empty tag"
      if (debug_xpath) print *, "full_node: ", full_node
      if (full_node)  then
         if (debug_xpath) print *, "*Warning: full_node requested, empty tag found"
      endif
endif
!
! There is no logic for ancestor element handling, as by definition
! an emtpy element cannot have children.
!
end subroutine empty_element

!-----------------------------------------------------------
subroutine pcdata_handler(chunk)
character(len=*), intent(in)   :: chunk

integer  :: len_chunk

if (in_pcdata_level) then
   ! 
   ! Build pcdata_recovered chunk by chunk, until it overflows
   !
   if (pcdata_requested) then
      if (debug_xpath) print *, "Found chunk of pcdata: ", chunk
      len_chunk = len(chunk)
      if ((len_pcdata + len_chunk) > max_len_pcdata) then
         !
         if (debug_xpath) print *, "***Pcdata Overflow "
         global_status = PCDATA_OVERFLOW
         stop_parsing = .true.
         return
      endif
      pcdata_recovered(len_pcdata+1:len_pcdata+len_chunk) = chunk
      len_pcdata = len_pcdata + len_chunk
   endif
endif

end subroutine pcdata_handler
!--------------------------------------------------------------------

subroutine pause_parsing(res)
logical, intent(out)  :: res

res =  stop_parsing

end subroutine pause_parsing
!--------------------------------------------------------------------

recursive function match(p,ptarget) result(res_match)
character(len=*), intent(in)  :: p
character(len=*), intent(in)  :: ptarget
logical                       :: res_match

!
! Checks whether a given XML path matches the target path ptarget
! Only absolute paths are considered.
!
! Examples of target paths:
!
!           /pseudo/vps/radfunc      [1]
!           //radfunc/data
!           //data
!           //*/vps/data                *//
!           //job//data      
!           //*                         *//
!
integer  :: len_target, len_path, pos_target, pos_path
character(len=100)   :: anchor_leaf                     ! *** Hard limit

res_match = .false.       

if (trim(p) == trim(ptarget)) then
   res_match = .true.
   return

else if (ptarget == "/") then
   ! We  process // in the middle below

   res_match = .true.
   return

else              ! We get the extreme elements

   len_target = len_trim(ptarget)
   len_path = len_trim(p)
   pos_target = index(ptarget,"/",back=.true.)
   pos_path = index(p,"/",back=.true.)

   if (pos_target == len_target) then   ! // in the middle...
      ! Get leaf further up
      search_anchor : do 
         pos_target = index(ptarget(1:len_target-1),"/",back=.true.)
         if (pos_target == 1) then  ! Target begins by /.// 
            res_match = .true.
            return
         endif
         anchor_leaf = ptarget(pos_target:len_target-1)
         if (anchor_leaf == "/.") then  ! keep searching
            len_target = pos_target 
            cycle search_anchor
         else
            exit search_anchor
         endif
      enddo search_anchor

      ! Note that the anchor includes the leading /
      ! Now we search for that anchor in the candidate path
      !
      pos_path = index(p(1:len_path),trim(anchor_leaf),back=.true.)
      if (pos_path /= 0) then

         ! Found anchor. Continue further up.
         !
         res_match = match(p(1:pos_path-1),ptarget(1:pos_target-1))
      endif

   else if  (ptarget(pos_target+1:len_target) == ".") then

      ! A dot is a dummy. Continue further up in target path.
      !
      res_match = match(p(1:len_path),ptarget(1:pos_target-1))

   else if  (ptarget(pos_target+1:len_target) == "*") then

      if (len_path == pos_path) then
         RETURN   ! empty path element
      endif

      ! A star matches any non-empty leaf. Continue further up.
      !
      res_match = match(p(1:pos_path-1),ptarget(1:pos_target-1))

   else  if (p(pos_path+1:len_path) ==  &
             ptarget(pos_target+1:len_target)) then 

      ! Leafs are equal. Continue further up.
      !
      res_match = match(p(1:pos_path-1),ptarget(1:pos_target-1))

   endif

endif

end function match

end module m_xpath_api

module m_dom_nodelist

use m_dom_types

private

public :: item
public :: getLength
public :: append

interface append
   module procedure append_nl
end interface

interface item
   module procedure item_nl
end interface

interface getLength
   module procedure getLength_nl
end interface

CONTAINS

  !-----------------------------------------------------------
  ! METHODS FOR NODELISTS
  !-----------------------------------------------------------
  function item_nl(nodeList, i)
    
    integer, intent(in)             :: i
    type(fnodeList), pointer        :: nodeList
    type(fnode), pointer            :: item_nl
    
    type(flistNode), pointer :: lp
    integer :: n

    item_nl => null()            ! In case there is no such item
    if (.not. associated(nodeList)) RETURN

    lp => nodeList%head
    n = -1
    do 
       if (.not. associated(lp))  exit
       n = n + 1
       if (n == i) then
          item_nl => lp%node
          exit
       endif
       lp => lp%next
    enddo

  end function item_nl

  !----------------------------------------------------------- 

  function getLength_nl(nodeList)
    
    type(fnodeList), pointer :: nodeList
    integer                  :: getLength_nl

    if (.not. associated(nodeList)) then
       getLength_nl = 0
    else
       getLength_nl = nodeList % length
    endif

  end function getLength_nl

  subroutine append_nl(nodeList,node)
    type(fnodeList), pointer :: nodeList
    type(fnode), pointer :: node

    if (.not. associated(nodeList)) then
       allocate(nodeList)
       nodelist%length = 1
       allocate(nodelist%head)
       nodelist%head%node => node
       nodelist%tail => nodelist%head
    else
       allocate(nodelist%tail%next)
       nodelist%tail%next%node => node
       nodelist%tail => nodelist%tail%next
       nodelist%length = nodelist%length + 1
    endif

  end subroutine append_nl

end module m_dom_nodelist

module m_dom_namednodemap
!
! This is basically a dictionary module, but written with the
! DOM node structure in mind.
!
use m_dom_types
use m_dom_strings

private
  !-------------------------------------------------------  
  ! METHODS FOR NAMEDNODEMAPS
  !-------------------------------------------------------   
  public :: getNamedItem
  public :: setNamedItem
  public :: removeNamedItem

  public :: item
  public :: getLength
  public :: append

  interface append
     module procedure append_nnm
  end interface

  interface item
     module procedure item_nnm
  end interface 

  interface getLength
     module procedure getLength_nnm
  end interface

CONTAINS

  function item_nnm(namedNodeMap, i)
    
    integer, intent(in)             :: i
    type(fnamedNodeMap), pointer    :: namedNodeMap
    type(fnode), pointer            :: item_nnm
    
    type(fnamedNode), pointer :: nnp

    integer :: n

    item_nnm => null()            ! In case there is no such item
    if (.not. associated(namedNodeMap)) RETURN

    nnp => namedNodeMap%head
    n = -1
    do 
       if (.not. associated(nnp))  exit
       n = n + 1
       if (n == i) then
          item_nnm => nnp%node
          exit
       endif
       nnp => nnp%next
    enddo

  end function item_nnm

  !----------------------------------------------------------- 
  
  function getLength_nnm(namedNodeMap)
  
    type(fnamedNodeMap), pointer :: namedNodeMap
    integer :: getLength_nnm

    getLength_nnm = 0
    if (.not. associated(namedNodeMap)) return

    getLength_nnm = namedNodeMap % length    
    
  end function getLength_nnm

  !----------------------------------------------------------- 


  subroutine append_nnm(nodeMap,node)
    type(fnamednodeMap), pointer :: nodeMap
    type(fnode), pointer :: node

    if (.not. associated(nodeMap)) then
       allocate(nodeMap)
       nodeMap%length = 1
       allocate(nodeMap%head)
       nodeMap%head%name = node%nodeName
       nodeMap%head%node => node
       nodeMap%tail => nodeMap%head
    else
       allocate(nodeMap%tail%next)
       nodeMap%tail%next%node => node
       nodeMap%tail%next%name =  node%nodeName
       nodeMap%tail => nodeMap%tail%next
       nodeMap%length = nodeMap%length + 1
    endif

  end subroutine append_nnm

  !----------------------------------------------------------- 

  function getNamedItem(namedNodeMap, name)
    
    type(fnamedNodeMap), pointer    :: namedNodeMap
    character(len=*), intent(in)    :: name
    type(fnode), pointer            :: getNamedItem

    type(fnamedNode), pointer :: nnp

    getNamedItem => null()
    if (.not. associated(namedNodeMap)) return 

    nnp => namedNodeMap%head
    do while (associated(nnp)) 
       if (nnp%name == name) then
          getNamedItem => nnp%node
          exit                 ! one or zero nodes with a given name
       endif
       nnp => nnp%next
    enddo

  end function getNamedItem

  
  function setNamedItem(namedNodeMap, node)

!!AG: Do we need to clone the node ?
    
    type(fnamedNodeMap), pointer    :: namedNodeMap
    type(fnode), pointer            :: node
    type(fnode), pointer            :: setNamedItem

    type(fnamedNode), pointer :: nnp

    if (.not. associated(namedNodeMap)) then

       call append(namedNodeMap,node)
       setNamedItem => node
      
    else

       nnp => namedNodeMap%head
       do while (associated(nnp)) 
          if (nnp%name == node%nodeName) then
             setNamedItem => nnp%node
             nnp%node => node
             setNamedItem => node
             return
          endif
          nnp => nnp%next
       enddo

       !   If not found, insert it at the end of the linked list

       call append(namedNodeMap,node)
       setNamedItem => node
    endif

  end function setNamedItem

!------------------------------------------------------------
   function removeNamedItem(namedNodeMap, name)
    
    type(fnamedNodeMap), pointer   :: namedNodeMap
    character(len=*), intent(in)   :: name
    type(fnode), pointer           :: removeNamedItem

    type(fnamedNode), pointer :: nnp, previous

    removeNamedItem => null()
    if (.not. associated(namedNodeMap)) return  

    previous => null()
    nnp => namedNodeMap%head
    do while (associated(nnp)) 
       if (nnp%name == name) then
          removeNamedItem => nnp%node
          if (associated(nnp,namedNodeMap%head)) then
             ! we remove the first fnamedNode in the chain...
             namedNodeMap%head => nnp%next
          else if (.not. associated(nnp%next)) then
             ! we remove the last fnamedNode in the chain
             previous%next => null()
             namedNodeMap%tail => previous
          else
             ! we remove a link in the middle of the chain
             previous%next => nnp%next
          endif
          namedNodeMap%length =  namedNodeMap%length - 1
          call unstring(nnp%name)
          deallocate(nnp)
          EXIT                 ! one or zero nodes with a given name
       endif
       previous => nnp
       nnp => nnp%next
    enddo

  end function removeNamedItem



end module m_dom_namednodemap

module m_psdom

use m_pseudo_types
use xmlf90_dom

private

public :: getVps
public :: getRadialFunction
public :: getGrid

CONTAINS

subroutine getVps(np,global_grid,pp)
type(fnode), pointer         :: np
type(vps_t), intent(inout)   :: pp
type(grid_t), intent(in)     :: global_grid

character(len=200)  :: value

         value = getAttribute(np,"l")
         if (value == "" ) call die("Cannot determine l for Vps")
         read(unit=value,fmt=*) pp%l

         value = getAttribute(np,"principal-n")
         if (value == "" ) call die("Cannot determine n for Vps")
         read(unit=value,fmt=*) pp%n

         value = getAttribute(np,"cutoff")
         if (value == "" ) call die("Cannot determine cutoff for Vps")
         read(unit=value,fmt=*) pp%cutoff

         value = getAttribute(np,"occupation")
         if (value == "" ) call die("Cannot determine occupation for Vps")
         read(unit=value,fmt=*) pp%occupation

         value = getAttribute(np,"spin")
         if (value == "" ) call die("Cannot determine spin for Vps")
         read(unit=value,fmt=*) pp%spin

         call getRadialFunction(np,global_grid,pp%V)

end subroutine getVps

!-----------------------------------------------------------------------
subroutine getRadialFunction(element,global_grid,rp)
use m_sax_converters, only: build_data_array
!
! Example of routine which packages parsing functionality for a
! common element. The <radfunc> element can appear under <vps>,
! <valence-charge>, and <pseudocore-charge> elements. 
! In all cases the parsing steps are exactly  the same.
! This routine accepts a pointer to the parent element and returns
! the data structure.
!
type(fnode), pointer         :: element
type(grid_t), intent(in)     :: global_grid
type(radfunc_t), intent(out) :: rp

type(fnode), pointer      :: np, radfuncp
type(fnodeList), pointer  :: lp
integer                   :: ndata
type(string)              :: pcdata, s

  s = getNodeName(element)
  print *, "Getting radfunc data from element ", char(s)
  lp => getElementsByTagName(element, "radfunc")
  radfuncp => item(lp,0)
  lp => getElementsByTagName(radfuncp, "grid")
  np => item(lp,0)
      if (associated(np))  then
         print *, " >> local grid found"
         call getGrid(np,rp%grid)
      else
         print *, " >> re-using global grid"
         rp%grid = global_grid
      endif

  lp => getElementsByTagName(radfuncp, "data")
  np => item(lp,0)
      if (associated(np))  then
         if (rp%grid%npts == 0) call die("Need grid information!")
         allocate(rp%data(rp%grid%npts))
         ndata = 0             ! To start the build up
         np => getFirstChild(np)
         do
            if (.not. associated(np)) exit
            if (getNodeType(np) /= TEXT_NODE) exit
            pcdata = getNodeValue(np)               ! text node 
            call build_data_array(char(pcdata),rp%data,ndata)
            np => getNextSibling(np)
         enddo
         if (ndata /= size(rp%data)) STOP "npts mismatch"
      else
         call die("Cannot find data element")
      endif
end subroutine getRadialFunction

!-----------------------------------------------------------------------
subroutine getGrid(element,grid)
type(fnode), pointer  :: element
type(grid_t), intent(out)       :: grid

character(len=200)  :: value

         grid%type = getAttribute(element,"type")
         if (grid%type == "" ) call die("Cannot determine grid type")

         value = getAttribute(element,"npts")
         if (value == "" ) call die("Cannot determine grid npts")
         read(unit=value,fmt=*) grid%npts

         value = getAttribute(element,"scale")
         if (value == "" ) call die("Cannot determine grid scale")
         read(unit=value,fmt=*) grid%scale

         value = getAttribute(element,"step")
         if (value == "" ) call die("Cannot determine grid step")
         read(unit=value,fmt=*) grid%step

end subroutine getGrid

!-----------------------------------------------------------------------
      subroutine die(str)
      character(len=*), intent(in), optional   :: str
      if (present(str)) then
         write(unit=0,fmt="(a)") trim(str)
      endif
      write(unit=0,fmt="(a)") "Stopping Program"
      stop
      end subroutine die


end module m_psdom

module m_wxml_array_str
!
! Utilities for character to character array
! conversions and tests of equality.
!
interface operator (.equal.)
 module procedure compare_array_str
end interface
!
! Not supported by all compilers...
! interface assignment (=)
!  module procedure assign_array_to_str !!!! , assign_str_to_array
! end interface

public :: operator(.equal.) !!!! , assignment(=)
public :: assign_array_to_str , assign_str_to_array
private

CONTAINS
!-------------------------------------------------------------
subroutine assign_array_to_str(str,s)
implicit none
character(len=1), dimension(:), intent(in)   :: s
character(len=*), intent(out) :: str

integer :: i, lstr

lstr = len(str)
do i = 1, min(size(s),lstr)
   str(i:i) = s(i)
enddo
do i = size(s)+1, lstr
   str(i:i) = " "
enddo
end subroutine assign_array_to_str

!-------------------------------------------------------------
! The NAG and Intel compilers cannot distinguish this from the
! intrinsic assignment... so we resort to using an explicit
! subroutine call.
!
subroutine assign_str_to_array(s,str)
implicit none
character(len=1), dimension(:), intent(out)   :: s
character(len=*), intent(in) :: str

integer :: i, lstr

lstr = len(str)
do i = 1, min(size(s),lstr)
   s(i) = str(i:i)
enddo

end subroutine assign_str_to_array

!-------------------------------------------------------------
function compare_array_str(s,str) result(equal) ! .equal. generic
implicit none
character(len=1), dimension(:), intent(in)   :: s
character(len=*), intent(in) :: str
logical                      :: equal
integer                      :: lens, lenstr, i


equal = .false.
lens = size(s)
lenstr = len(str)
if (lens .ne. lenstr) return

do i = 1, lens
 if (s(i) .ne. str(i:i)) return
enddo
equal = .true.

end function compare_array_str

end module m_wxml_array_str

program m

character(len=100) :: p, t
logical            :: result

do
   write(unit=*,fmt="(a)",advance="no")  "Target path: "
   read(unit=*,fmt="(a)") t
   write(unit=*,fmt="(a)",advance="no")  "Path: "
   read(unit=*,fmt="(a)") p

   result = match(p,t)
   print *, "Result: ", result

enddo


CONTAINS

recursive function match(p,ptarget) result(res_match)
character(len=*), intent(in)  :: p
character(len=*), intent(in)  :: ptarget
logical                       :: res_match

!
! Checks whether a given XML path matches the target path ptarget
! Only absolute paths are considered.
!
! Examples of target paths:
!
!           /pseudo/vps/radfunc      [1]
!           //radfunc/data
!           //data
!           //*/vps/data                 *//
!           //job//data
!           //*                          *//
!
integer  :: len_target, len_path, pos_target, pos_path
character(len=100)   :: anchor_leaf

res_match = .false.       

 print *, ":testing: "
 print *, "          ", trim(p)
 print *, " against: ", trim(ptarget)
 print *, "-----------------------------------------"

if (trim(p) == trim(ptarget)) then
   res_match = .true.
   print *, "outright equality"
   return

else if (ptarget == "/") then
   ! We  process // in the middle below

   res_match = .true.
   print *, "target begins by //"
   return

else              ! We get the extreme elements

   len_target = len_trim(ptarget)
   len_path = len_trim(p)
   pos_target = index(ptarget,"/",back=.true.)
   pos_path = index(p,"/",back=.true.)

   print *, " Path leaf: ", p(pos_path+1:len_path) 
   print *, " Target leaf: ", ptarget(pos_target+1:len_target)

   if (pos_target == len_target) then   ! // in the middle...
      ! Get leaf further up
      search_anchor : do 
         print *, "looking for anchor in: ", ptarget(1:len_target-1)
         print *, "press enter"
         read *
         pos_target = index(ptarget(1:len_target-1),"/",back=.true.)
         print *, "pos_target in anchor search: ", pos_target
         if (pos_target == 1) then  ! Target begins by /.// 
            res_match = .true.
            print *, "reached initial /.// in target"
            return
         endif
         anchor_leaf = ptarget(pos_target:len_target-1)
         print *, " Anchor leaf: ", trim(anchor_leaf)
         if (anchor_leaf == "/.") then  ! keep searching
            len_target = pos_target 
            cycle search_anchor
         else
            exit search_anchor
         endif
      enddo search_anchor

      ! Note that the anchor includes the leading /
      ! Now we search for that anchor in the candidate path
      !
      print *, " Searching anchor in : ", trim(p(1:len_path))
      pos_path = index(p(1:len_path),trim(anchor_leaf),back=.true.)
      if (pos_path /= 0) then

         ! Found anchor. Continue further up.
         !
         res_match = match(p(1:pos_path-1),ptarget(1:pos_target-1))
      endif

   else if  (ptarget(pos_target+1:len_target) == ".") then

      ! A dot is a dummy. Continue further up.
      !
      res_match = match(p(1:len_path),ptarget(1:pos_target-1))

   else if  (ptarget(pos_target+1:len_target) == "*") then

      if (len_path == pos_path) then
         print *, "empty element. len_path, pos_path: ", len_path, pos_path
         RETURN   ! empty path element
      endif

      ! A star matches any non-empty leaf. Continue further up.
      !
      res_match = match(p(1:pos_path-1),ptarget(1:pos_target-1))

   else  if (p(pos_path+1:len_path) ==  &
             ptarget(pos_target+1:len_target)) then 

      ! Leafs are equal. Continue further up.
      !
      res_match = match(p(1:pos_path-1),ptarget(1:pos_target-1))

   endif

endif

end function match

end program m

Module m_dom_types

  use m_dom_strings

  implicit none

  private

  !-------------------------------------------------------   
  ! A GENERIC NODE
  !-------------------------------------------------------   
  type, public :: fnode
     type(string)         :: nodeName    
     type(string)         :: nodeValue   
!!!     character(len=200)    :: nodeName  = ""
!!!     character(len=200)    :: nodeValue = ""
     integer              :: nc              = 0 
     integer              :: nodeType        = 0
     type(fnode), pointer :: parentNode      => null()
     type(fnodeList), pointer :: childNodes  => null()  ! New
     type(fnode), pointer :: firstChild      => null()
     type(fnode), pointer :: lastChild       => null()
     type(fnode), pointer :: previousSibling => null()
     type(fnode), pointer :: nextSibling     => null()
     type(fnode), pointer :: ownerDocument   => null()
     type(fnamedNodeMap), pointer :: attributes => null()
  end type fnode

  !-----------------------------------------------------------
  !  ONE WAY TO IMPLEMENT A NAMEDNODEMAP  (dictionary)
  !-----------------------------------------------------------

  ! Linked list of name/node pairs, with overall length variable

  type, public :: fnamedNode
     type(string)                   :: name
!!!     character(len=100)            :: name
     type(fnode), pointer          :: node => null()
     type(fnamedNode), pointer     :: next => null()
  end type fnamedNode

  type, public :: fnamedNodeMap
     integer :: length = 0
     type(fnamedNode), pointer  :: head => null()
     type(fnamedNode), pointer  :: tail => null()
  end type fnamedNodeMap

  !-----------------------------------------------------------
  !  ONE WAY TO IMPLEMENT A NODELIST 
  !-----------------------------------------------------------

  type, public :: flistNode
     type(fnode), pointer          :: node => null()
     type(flistNode), pointer      :: next => null()
  end type flistNode

  type, public :: fnodeList
     integer                      :: length = 0
     type(flistNode), pointer     :: head => null()
     type(flistNode), pointer     :: tail => null()
  end type fnodeList

!========================================================================
  integer, save, private          :: allocated_nodes = 0
!========================================================================

  !-------------------------------------------------------   
  ! NODETYPES
  !-------------------------------------------------------   
  integer, parameter, public :: ELEMENT_NODE                = 1
  integer, parameter, public :: ATTRIBUTE_NODE              = 2
  integer, parameter, public :: TEXT_NODE                   = 3
  integer, parameter, public :: CDATA_SECTION_NODE          = 4
  integer, parameter, public :: ENTITY_REFERENCE_NODE       = 5
  integer, parameter, public :: ENTITY_NODE                 = 6
  integer, parameter, public :: PROCESSING_INSTRUCTION_NODE = 7
  integer, parameter, public :: COMMENT_NODE                = 8
  integer, parameter, public :: DOCUMENT_NODE               = 9
  integer, parameter, public :: DOCUMENT_TYPE_NODE          = 10
  integer, parameter, public :: DOCUMENT_FRAGMENT_NODE      = 11
  integer, parameter, public :: NOTATION_NODE               = 12

  public :: node_class
  public :: createNode
  public :: destroyNode
  public :: destroyNamedNodeMap
  public :: destroyNodeList
  public :: getNumberofAllocatedNodes

CONTAINS

  function getNumberofAllocatedNodes() result(n)
    integer   :: n

    n = allocated_nodes
  end function getNumberofAllocatedNodes

!--------------------------------------------------------------
  function createNode() result(node)
    type(fnode), pointer  :: node

    allocate(node)
    allocated_nodes = allocated_nodes + 1

  end function createNode
!--------------------------------------------------------------

  function node_class(nodetype) result(class)
    integer, intent(in) :: nodetype
    character(len=10)  ::     class

    select case(nodetype)
    case(ELEMENT_NODE)
       class = "element"
    case(ATTRIBUTE_NODE)
       class = "attribute"
    case(TEXT_NODE)
       class = "text"
    case(COMMENT_NODE)
       class = "comment"
    case(DOCUMENT_NODE)
       class = "document"
    end select
  end function node_class

  subroutine destroyNamedNodeMap(nodemap)
    type(fnamedNodeMap), pointer :: nodemap

    type(fnamednode), pointer  :: nnp
    type(fnode), pointer       :: ghost
    
    if (.not. associated(nodemap)) return
    nnp => nodemap%head
    do while (associated(nnp))
       call unstring(nnp%name)
       ghost => nnp%node
       nnp => nnp%next
       call destroyNode(ghost)      ! We might not want to really destroy
    enddo
  end subroutine destroyNamedNodeMap

  subroutine destroyNodeList(nodelist)
    type(fnodeList), pointer :: nodelist

    type(flistnode), pointer   :: p
    type(fnode), pointer       :: ghost
    
    if (.not. associated(nodelist)) return
    p => nodelist%head
    do while (associated(p))
       ghost => p%node
       p => p%next
       call destroyNode(ghost)      ! We might not want to really destroy
    enddo
  end subroutine destroyNodeList

  recursive subroutine destroyNode(node)
    type(fnode), pointer  :: node
    
    type(fnode), pointer  :: np, ghost
    
    np => node
    do while (associated(np))
       if (associated(np%firstChild)) then
          call destroyNode(np%firstChild)
       endif
       if (associated(np%attributes)) call destroyNamedNodeMap(np%attributes)
       call unstring(np%nodeName)
       call unstring(np%nodeValue)
       if (associated(np%previousSibling)) & 
                np%previousSibling%nextSibling => np%nextSibling
       if (associated(np%nextSibling)) & 
                np%nextSibling%previousSibling => np%previousSibling
       if (associated(np%parentNode)) then
          if (associated(np%parentNode%firstChild,np)) &
               np%parentNode%firstChild => null()
          if (associated(np%parentNode%lastChild,np)) &
               np%parentNode%lastChild => null()
       endif
       if (associated(np,node)) then    
          deallocate(np)
          allocated_nodes = allocated_nodes - 1
          EXIT                           ! do not destroy siblings
       else
          ghost => np
          np => np%nextSibling
          deallocate(ghost)
          allocated_nodes = allocated_nodes - 1
       endif
    enddo
    node => null()     ! superfluous ?
  end subroutine destroyNode

end module m_dom_types

module m_pseudo
!
!  PSEUDO version 0.5 processing
!  A full example of the building up of a data structure using
!  the SAX paradigm.
!
use xmlf90_sax
use m_pseudo_types         ! Data types

private

!
! It defines the routines that are called from xml_parser in response
! to particular events.
!
public  :: begin_element, end_element, pcdata_chunk
private :: die

logical, private  :: in_vps = .false. , in_radfunc = .false.
logical, private  :: in_semilocal = .false. , in_header = .false.
logical, private  :: in_coreCharge = .false. , in_data = .false.
logical, private  :: in_valenceCharge = .false.

integer, private, save  :: ndata

type(pseudo_t), private, target, save :: pseudo
type(grid_t), private, save        :: grid
type(grid_t), private, save        :: global_grid
!
! Pointers to make it easier to manage the data
!
type(header_t), private, pointer   :: hp
type(vps_t), private, pointer      :: pp
type(radfunc_t), private, pointer  :: rp

CONTAINS  !===========================================================

!----------------------------------------------------------------------
subroutine begin_element(name,attributes)
character(len=*), intent(in)    :: name
type(dictionary_t), intent(in)  :: attributes

character(len=100)  :: value
integer             :: status


select case(name)

      case ("pseudo")
         call get_value(attributes,"version",value,status)
         if (value == "0.5") then
            print *, "Processing a PSEUDO version 0.5 XML file"
            pseudo%npots = 0
            global_grid%npts = 0
         else
            print *, "Can only work with PSEUDO version 0.5 XML files"
            STOP
         endif

      case ("header")
         in_header = .true.
         hp => pseudo%header
         
         call get_value(attributes,"symbol",hp%symbol,status)
         if (status /= 0 ) call die("Cannot determine atomic symbol")

         call get_value(attributes,"zval",value,status)
         if (status /= 0 ) call die("Cannot determine zval")
         read(unit=value,fmt=*) hp%zval
!
         call get_value(attributes,"creator",hp%creator,status)
         if (status /= 0 ) hp%creator="unknown"

         call get_value(attributes,"flavor",hp%flavor,status)
         if (status /= 0 ) hp%flavor="unknown"

         call get_value(attributes,"relativistic",value,status)
         if (status /= 0 ) value = "no"
         hp%relativistic = (value == "yes")

         call get_value(attributes,"polarized",value,status)
         if (status /= 0 ) value = "no"
         hp%polarized = (value == "yes")

         call get_value(attributes,"core-corrections", &
                                    hp%core_corrections,status)
         if (status /= 0 ) hp%core_corrections = "nc"

      case ("vps")
         in_vps = .true.

         pseudo%npots = pseudo%npots + 1
         pp => pseudo%pot(pseudo%npots)
         rp => pp%V                       ! Pointer to radial function

         call get_value(attributes,"l",value,status)
         if (status /= 0 ) call die("Cannot determine l for Vps")
         read(unit=value,fmt=*) pp%l

         call get_value(attributes,"principal-n",value,status)
         if (status /= 0 ) call die("Cannot determine n for Vps")
         read(unit=value,fmt=*) pp%n

         call get_value(attributes,"cutoff",value,status)
         if (status /= 0 ) call die("Cannot determine cutoff for Vps")
         read(unit=value,fmt=*) pp%cutoff

         call get_value(attributes,"occupation",value,status)
         if (status /= 0 ) call die("Cannot determine occupation for Vps")
         read(unit=value,fmt=*) pp%occupation

         call get_value(attributes,"spin",value,status)
         if (status /= 0 ) call die("Cannot determine spin for Vps")
         read(unit=value,fmt=*) pp%spin

      case ("grid")

         call get_value(attributes,"type",grid%type,status)
         if (status /= 0 ) call die("Cannot determine grid type")

         call get_value(attributes,"npts",value,status)
         if (status /= 0 ) call die("Cannot determine grid npts")
         read(unit=value,fmt=*) grid%npts

         call get_value(attributes,"scale",value,status)
         if (status /= 0 ) call die("Cannot determine grid scale")
         read(unit=value,fmt=*) grid%scale

         call get_value(attributes,"step",value,status)
         if (status /= 0 ) call die("Cannot determine grid step")
         read(unit=value,fmt=*) grid%step

         !
         ! In this way we allow for a private grid for each radfunc,
         ! or for a global grid specification
         !
         if (in_radfunc) then
            rp%grid = grid
         else
            global_grid = grid
         endif

      case ("data")
         in_data = .true.
         if (rp%grid%npts == 0) STOP "Grid not specified correctly"
         allocate(rp%data(rp%grid%npts))
         ndata = 0             ! To start the build up

      case ("radfunc")
         in_radfunc = .true.
         rp%grid = global_grid     ! Might be empty
                                   ! There should then be a local grid element
                                   ! read later

      case ("pseudocore-charge")
         in_coreCharge = .true.
         rp => pseudo%core_charge

      case ("valence-charge")
         in_valenceCharge = .true.
         rp => pseudo%valence_charge

      case ("semilocal")
         in_semilocal = .true.

         call get_value(attributes,"npots-down",value,status)
         if (status /= 0 ) call die("Cannot determine npots-down")
         read(unit=value,fmt=*) pseudo%npots_down

         call get_value(attributes,"npots-up",value,status)
         if (status /= 0 ) call die("Cannot determine npots-up")
         read(unit=value,fmt=*) pseudo%npots_up

end select

end subroutine begin_element
!----------------------------------------------------------------------

subroutine end_element(name)
character(len=*), intent(in)     :: name

select case(name)

      case ("vps")
         in_vps = .false.

      case ("radfunc")
         in_radfunc = .false.

      case ("data")
      !
      ! We are done filling up the radfunc data
      ! Check that we got the advertised number of items
      !
         in_data = .false.
         if (ndata /= size(rp%data)) STOP "npts mismatch"

      case ("pseudocore-charge")
         in_coreCharge = .false.

      case ("valence-charge")
         in_valenceCharge = .false.

      case ("semilocal")
         in_semilocal = .false.

      case ("pseudo")
         call dump_pseudo(pseudo)

end select

end subroutine end_element
!----------------------------------------------------------------------

subroutine pcdata_chunk(chunk)
character(len=*), intent(in) :: chunk


if (len_trim(chunk) == 0) RETURN     ! skip empty chunk

if (in_data) then
!
! Note that we know where we need to put it through the pointer rp...
!
      call build_data_array(chunk,rp%data,ndata)

else if (in_header) then
      !
      ! There should not be any pcdata in header in this version...

      print *, "Header data:"
      print *, trim(chunk)

endif

end subroutine pcdata_chunk
!----------------------------------------------------------------------

      subroutine die(str)
      character(len=*), intent(in), optional   :: str
      if (present(str)) then
         write(unit=0,fmt="(a)") trim(str)
      endif
      write(unit=0,fmt="(a)") "Stopping Program"
      stop
      end subroutine die


end module m_pseudo

program simple
use xmlf90_xpath

type(xml_t) :: fxml

integer  :: status
character(len=100)  :: what

call open_xmlfile(XPATH_DATA_DIR//"inventory.xml",fxml,status)
!
do
      call get_node(fxml,path="//description",pcdata=what,status=status)
      if (status < 0)   exit
      print *, "Appliance: ", trim(what)
enddo
end program simple

module m_aux

use xmlf90_xpath
private
public :: get_item_info

CONTAINS

subroutine get_item_info(context,what,price,currency)

type(xml_t), intent(in)       :: context
character(len=*), intent(out) :: what, price, currency

!
! Local variables
!
type(xml_t)        :: ff
integer            :: status
type(dictionary_t) :: attributes

  ! 
  ! context is read-only, so make a copy and sync just in case
  !
  ff = context
  call sync_xmlfile(ff,status)  
  !
  call get_node(ff,path="price", &
                attributes=attributes,pcdata=price,status=status)
  call get_value(attributes,"currency",currency,status)
  if (status /= 0) stop "missing currency attribute!"
  !
  ! Rewind to beginning of context
  !
  ff = context
  call sync_xmlfile(ff,status)  
  !
  call get_node(ff,path="description",pcdata=what,status=status)

end subroutine get_item_info

end module m_aux
!-----------------------------------------------------------------
!-----------------------------------------------------------------
program item_context2
use xmlf90_xpath
use m_aux          ! To access the subroutine

type(xml_t) :: fxml

integer  :: status
character(len=100)  :: what, price, currency

call open_xmlfile(XPATH_DATA_DIR//"inventory.xml",fxml,status)
!
do
  call mark_node(fxml,path="//item",status=status)
  if (status /= 0)   exit      ! No more items
  call get_item_info(fxml,what,price,currency)
  write(unit=*,fmt="(6a)") "Appliance: ", trim(what), &
                            ". Price: ", trim(price), " ", trim(currency)
  call sync_xmlfile(fxml,status)
enddo
end program item_context2

module m_wxml_dictionary

  use m_wxml_escape, only : check_Name
  use m_wxml_error,  only : wxml_fatal
  use m_wxml_array_str

  implicit none

private
!
integer, parameter, private    :: MAX_ITEMS = 30

type, private :: dict_item
  character(len=1), pointer, dimension(:) :: key
  character(len=1), pointer, dimension(:) :: value
end type dict_item

type, public :: wxml_dictionary_t
private
      integer                               :: number_of_items ! = 0
      type(dict_item), dimension(MAX_ITEMS) :: items
end type wxml_dictionary_t

!
! Building procedures
!
public :: init_dict
public :: reset_dict
public :: add_item_to_dict
!
! Query and extraction procedures
!
public  :: len
interface len
   module procedure number_of_entries
end interface
public  :: number_of_entries
public  :: get_key 
public  :: get_value
public  :: has_key
public  :: print_dict
!
interface get_value
   module procedure wxml_get_value, wxml_get_value_i
end interface

CONTAINS

!------------------------------------------------------
function number_of_entries(dict) result(n)
type(wxml_dictionary_t), intent(in)   :: dict
integer                          :: n

n = dict%number_of_items

end function number_of_entries

!------------------------------------------------------
function has_key(dict,key) result(found)
type(wxml_dictionary_t), intent(in)   :: dict
character(len=*), intent(in)     :: key
logical                          :: found

integer  ::  i
found = .false.
do  i = 1, dict%number_of_items
    if (dict%items(i)%key .equal. key) then
      found = .true.
      exit
    endif
enddo
end function has_key

!------------------------------------------------------
subroutine wxml_get_value(dict,key,value,status)
type(wxml_dictionary_t), intent(in)            :: dict
character(len=*), intent(in)              :: key
character(len=*), intent(out)             :: value
integer, intent(out)                      :: status
!
integer  :: i

status = -1
do  i = 1, dict%number_of_items
    if (dict%items(i)%key .equal. key) then
      call assign_array_to_str(value,dict%items(i)%value)
      status = 0
      exit
    endif
enddo

end subroutine wxml_get_value

function get_value_len(dict, key) result(value_len)
  type(wxml_dictionary_t), intent(in) :: dict
  character(len=*), intent(in) :: key
  integer :: value_len

  integer :: i

  value_len = 0
  do  i = 1, dict%number_of_items
      if (dict%items(i)%key .equal. key) then
        value_len = size(dict%items(i)%value)
        exit
      endif
  enddo

end function get_value_len


!------------------------------------------------------
subroutine get_key(dict,i,key,key_len,status)
!
! Get the i'th key
!
type(wxml_dictionary_t), intent(in)            :: dict
integer, intent(in)                       :: i
character(len=*), intent(out)             :: key
integer, intent(out)                      :: key_len
integer, intent(out)                      :: status

if (i>0 .and. i<=dict%number_of_items) then
      call assign_array_to_str(key,dict%items(i)%key)
      key_len = size(dict%items(i)%key)
      status = 0
else
      key = ' '
      key_len = 0
      status = -1
endif

end subroutine get_key
!------------------------------------------------------
subroutine wxml_get_value_i(dict,i,value,value_len,status)
!
! Get the i'th value
!
type(wxml_dictionary_t), intent(in)            :: dict
integer, intent(in)                       :: i
character(len=*), intent(out)             :: value
integer, intent(out)                      :: value_len
integer, intent(out)                      :: status

if (i>0 .and. i<=dict%number_of_items) then
      call assign_array_to_str(value,dict%items(i)%value)
      value_len = size(dict%items(i)%value)
      status = 0
else
      value = ' '
      value_len = 0
      status = -1
endif

end subroutine wxml_get_value_i

subroutine add_item_to_dict(dict, key, value)

  type(wxml_dictionary_t), intent(inout) :: dict
  character(len=*), intent(in)          :: key
  character(len=*), intent(in)          :: value

  character(len=len(key)) :: check_key
  integer  :: n, lenstr

  n = dict%number_of_items
  if (n == MAX_ITEMS) then
    write(unit=0,fmt=*) "Dictionary capacity exceeded !"
    RETURN
  endif

! keys may not have initial (or trailing; thus trim below) blanks:
!TOHW remove this check? shouldn't be passing blank-prefixed strings anyway.
  check_key=adjustl(key)
  if (.not.check_Name(trim(check_key))) then
    call wxml_fatal('attribute name is invalid')
  endif

  n = n + 1
  lenstr=len_trim(check_key)
  allocate(dict%items(n)%key(lenstr))
  call assign_str_to_array(dict%items(n)%key,check_key)
  allocate(dict%items(n)%value(len(value)))
  call assign_str_to_array(dict%items(n)%value,value)

  dict%number_of_items = n

end subroutine add_item_to_dict

!------------------------------------------------------
subroutine init_dict(dict)
  type(wxml_dictionary_t), intent(out)   :: dict

  integer :: i
  
  do i = 1, MAX_ITEMS
    nullify(dict%items(i)%key)
    nullify(dict%items(i)%key)
  enddo

  dict % number_of_items = 0

end subroutine init_dict
  
!------------------------------------------------------
subroutine reset_dict(dict)
  type(wxml_dictionary_t), intent(inout)   :: dict
  
  integer :: i
  do i = 1, dict%number_of_items
    deallocate(dict%items(i)%key)
    deallocate(dict%items(i)%value)
  enddo

  dict%number_of_items = 0

end subroutine reset_dict

!------------------------------------------------------
subroutine print_dict(dict)
type(wxml_dictionary_t), intent(in)   :: dict

integer  :: i

do i = 1, dict%number_of_items
      print *, dict%items(i)%key, " = ", dict%items(i)%value
enddo

end subroutine print_dict

end module m_wxml_dictionary

program twoelements
use xmlf90_xpath

type(xml_t) :: fxml

integer  :: status
character(len=100)  :: what, price, currency
type(dictionary_t)  :: attributes

call open_xmlfile(XPATH_DATA_DIR//"inventory.xml",fxml,status)
!
do
  call get_node(fxml,path="//description", &
                pcdata=what,status=status)
  if (status < 0)   exit                   ! No more items
  !
  ! Price comes right after description...
  !
  call get_node(fxml,path="//price", &
                attributes=attributes,pcdata=price,status=status)
  if (status /= 0) stop "missing price element!"
  
  call get_value(attributes,"currency",currency,status)
  if (status /= 0) stop "missing currency attribute!"
  
  write(unit=*,fmt="(6a)") "Appliance: ", trim(what), &
                           ". Price: ", trim(price), " ", trim(currency)
enddo
end program twoelements

module m_handlers
use xmlf90_sax
private
public :: begin_element, end_element, pcdata_chunk
!
logical, private            :: in_item, in_description, in_price
character(len=40), private  :: what, price, currency, id
!
contains !-----------------------------------------
!
subroutine begin_element(name,attributes)
   character(len=*), intent(in)     :: name
   type(dictionary_t), intent(in)   :: attributes
   
   integer  :: status
   
   select case(name)
     case("item")
       in_item = .true.
       call get_value(attributes,"id",id,status)
     
     case("description")
       in_description = .true.
       
     case("price")
       in_price = .true.
       call get_value(attributes,"currency",currency,status)

   end select
   
end subroutine begin_element
!---------------------------------------------------------------
subroutine pcdata_chunk(chunk)
   character(len=*), intent(in) :: chunk

   if (in_description) what = chunk
   if (in_price) price = chunk

end subroutine pcdata_chunk
!---------------------------------------------------------------
subroutine end_element(name)
   character(len=*), intent(in)     :: name
   
   select case(name)
     case("item")
       in_item = .false.
       write(unit=*,fmt="(5(a,tr1))") trim(id), trim(what), ":", &
                                     trim(price), trim(currency)
     
     case("description")
       in_description = .false.
       
     case("price")
       in_price = .false.

   end select
   
end subroutine end_element
!---------------------------------------------------------------
end module m_handlers

module m_sax_reader

private

integer, parameter, public              :: BUFFER_NOT_CONNECTED = -2048
integer, private, parameter             :: MAXLENGTH = 1024

type, public :: file_buffer_t
private
      logical                           :: connected
      logical                           :: eof
      integer                           :: lun
      character(len=50)                 :: filename
      integer                           :: counter
      character(len=MAXLENGTH)          :: buffer
      integer                           :: line
      integer                           :: col
      integer                           :: pos 
      integer                           :: nchars
      logical                           :: debug
      !
      integer                           :: io_eor
      integer                           :: io_eof
end type file_buffer_t

public  :: get_character, sync_file
public  :: line, column, nchars_processed
public  :: open_file, close_file_buffer, rewind_file, mark_eof_file
public  :: eof_file

private :: fill_buffer
private :: get_unit, find_eor_eof

CONTAINS

!-----------------------------------------
!
subroutine open_file(fname,fb,iostat,record_size,verbose)
character(len=*), intent(in)      :: fname
type(file_buffer_t), intent(out)  :: fb
integer, intent(out)              :: iostat
integer, intent(in), optional     :: record_size
logical, intent(in), optional     :: verbose

iostat = 0

call find_eor_eof(fb%io_eor,fb%io_eof)

fb%connected = .false.

if (present(verbose)) then
   fb%debug = verbose
else
   fb%debug = .false.
endif

call get_unit(fb%lun,iostat)
if (iostat /= 0) then
   if (fb%debug) print *, "Cannot get unit"
   return
endif

if (present(record_size)) then
   open(unit=fb%lun,file=fname,form="formatted",status="old", &
        action="read",position="rewind",recl=record_size,iostat=iostat)
else
   open(unit=fb%lun,file=fname,form="formatted",status="old", &
        action="read",position="rewind",recl=65536,iostat=iostat)
endif
if (iostat /= 0) then
   if (fb%debug) print *, "Cannot open file ", trim(fname), " iostat: ", iostat
   return
endif

fb%connected = .true.
fb%counter = 0
fb%eof = .false.
fb%line = 1
fb%col = 0
fb%filename = fname
fb%pos = 0
fb%nchars = 0
fb%buffer = ""

end subroutine open_file

!-------------------------------------------------
subroutine rewind_file(fb)
type(file_buffer_t), intent(inout)  :: fb

fb%eof = .false.
fb%counter = 0
fb%line = 1
fb%col = 0
fb%pos = 0
fb%nchars = 0
fb%buffer = ""

rewind(unit=fb%lun)

end subroutine rewind_file
!-----------------------------------------
subroutine mark_eof_file(fb)
type(file_buffer_t), intent(inout)  :: fb

fb%eof = .true.

end subroutine mark_eof_file

!-----------------------------------------
subroutine close_file_buffer(fb)
type(file_buffer_t), intent(inout)  :: fb

if (fb%connected) then
    close(unit=fb%lun)
    fb%connected = .false.
endif

end subroutine close_file_buffer

!-------------------------------------------------
function eof_file(fb) result (res)
type(file_buffer_t), intent(in)  :: fb
logical                          :: res

res = fb%eof

end function eof_file
!-----------------------------------------
!-----------------------------------------
! New version, able to cope with arbitrarily long lines 
! (still need to specify a big enough record_size if necessary)
!
subroutine fill_buffer(fb,iostat)
type(file_buffer_t), intent(inout)  :: fb
integer, intent(out)  :: iostat
! 
!
character(len=81)  :: str       ! 80 seems like a good compromise?
                                ! (1 extra for added newline, see below)
integer            :: len=-1    ! initialization for buggy compilers
!
read(unit=fb%lun,iostat=iostat,advance="no",size=len,fmt="(a80)") str

if (iostat == fb%io_eof) then
   
   ! End of file
   if (fb%debug) print *, "End of file."
   return

else if (iostat > 0) then

   ! Hard i/o error
   if (fb%debug) print *, "Hard i/o error. iostat:", iostat
   RETURN

else
!
 if (fb%debug) then
   print *, "Buffer: len, iostat", len, iostat
   print *, trim(str)
 endif

   fb%pos = 0

   if (iostat == 0) then

      !  Normal read, with more stuff left on the line
      !
      fb%buffer = str(1:len) 
      fb%nchars = len

   else         ! (end of record)
      !
      !  End of record. We mark it with an LF, whatever it is the native marker.
      !
!!      fb%buffer = str(1:len) // char(10)
      fb%buffer = str(1:len)             !! Avoid allocation of string
      len = len + 1                      !! by compiler
      fb%buffer(len:len) = char(10)   
      fb%nchars = len
      iostat = 0
   endif

endif

end subroutine fill_buffer

!---------------------------------------------------------------
subroutine get_character(fb,c,iostat)
character(len=1), intent(out) :: c
type(file_buffer_t), intent(inout)  :: fb
integer, intent(out)          :: iostat

character(len=1)   :: c_next

if (.not. fb%connected) then
      iostat = BUFFER_NOT_CONNECTED
      return
endif

if (fb%pos >= fb%nchars) then
      call fill_buffer(fb,iostat)
      if (iostat /= 0) return
endif
fb%pos = fb%pos + 1
c = fb%buffer(fb%pos:fb%pos)
fb%counter = fb%counter + 1              ! Raw counter
fb%col = fb%col + 1
!
! Deal with end-of-line handling on the processor...
!
if (c == char(10)) then
   ! Our own marker for end of line
   fb%line = fb%line + 1
   fb%col = 0
endif
if (c == char(13)) then
   c_next = fb%buffer(fb%pos+1:fb%pos+1)
   if (c_next == char(10)) then
      !
      ! Found CRLF. We replace it by LF, as per specs.
      c = c_next
      fb%pos = fb%pos + 1
      if (fb%debug) print *, "-/-> Removed CR before LF in get_character"
   else
      ! Replace single CR by LF
      c = char(10)
      if (fb%debug) print *, "-/-> Changed CR to LF in get_character -- line++"
      !
   endif
   ! In both cases we increase the line counter and reset the column
   !
   fb%line = fb%line + 1
   fb%col = 0
endif

iostat = 0

end subroutine get_character

!----------------------------------------------------
!----------------------------------------------------
! Error Location functions
!
function line(fb) result (ll)
type(file_buffer_t), intent(in)  :: fb
integer                          :: ll

ll = fb%line
end function line

!----------------------------------------------------
function column(fb) result (col)
type(file_buffer_t), intent(in)  :: fb
integer                          :: col

col = fb%col
end function column
!----------------------------------------------------
!----------------------------------------------------
function nchars_processed(fb) result (nc)
type(file_buffer_t), intent(in)  :: fb
integer                          :: nc

nc = fb%counter
end function nchars_processed
!----------------------------------------------------

subroutine sync_file(fb,iostat)
type(file_buffer_t), intent(inout)  :: fb
integer, intent(out)                :: iostat
!
! Repositions the file so that it matches with
! the stored file_buffer information
!
integer          :: target_counter
character(len=1) :: c

target_counter = fb%counter
call rewind_file(fb)
iostat = 0
do
   if (fb%counter == target_counter) exit
   call get_character(fb,c,iostat)
   if (iostat /= 0) return
enddo

end subroutine sync_file

! ----------------------------------------------------------------------
subroutine get_unit(lun,iostat)

! Get an available Fortran unit number

integer, intent(out)  :: lun
integer, intent(out)  :: iostat

integer :: i
logical :: unit_used

do i = 10, 99
   lun = i
   inquire(unit=lun,opened=unit_used)
   if (.not. unit_used) then
      iostat = 0
      return
   endif
enddo
iostat = -1
lun = -1
end subroutine get_unit
! ----------------------------------------------------------------------

subroutine find_eor_eof(io_eor,io_eof)
!
! Determines the values of the iostat values for End of File and 
! End of Record (in non-advancing I/O)
!
integer, intent(out)           :: io_eor
integer, intent(out)           :: io_eof

integer           :: lun, iostat
character(len=1)  :: c

call get_unit(lun,iostat)

if (iostat /= 0) stop "Out of unit numbers"

open(unit=lun,status="scratch",form="formatted", &
     action="readwrite",position="rewind",iostat=iostat)
if (iostat /= 0)   stop "Cannot open test file"

write(unit=lun,fmt=*)  "a"
write(unit=lun,fmt=*)  "b"

rewind(unit=lun)

io_eor = 0
do
  read(unit=lun,fmt="(a1)",advance="NO",iostat=io_eor) c
  if (io_eor /= 0) exit
enddo

io_eof = 0
do
  read(unit=lun,fmt=*,iostat=io_eof)
  if (io_eof /= 0) exit
enddo

close(unit=lun,status="delete")

end subroutine find_eor_eof

end module m_sax_reader

module m_wxml_escape

implicit none

private

public  :: check_Name

character(len=*), parameter :: LETTER = 'abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ'
character(len=*), parameter :: DIGIT  = '1234567890'
character(len=*), parameter :: ESCAPE = '&<'//'"'//"'"

CONTAINS

function check_Name(name) result(good)
 character(len=*), intent(in) :: name
 logical :: good
! Validates a string against the XML requirements for a NAME
! Is not fully compliant; ignores UTF issues.

 integer :: n, i

 good=.true.

 n = len(name)
 if (n == 0) then
   write(0,*) "tagName is an empty string."
   good=.false.
 elseif (good) then
   if (scan(name(1:1), LETTER//'_'//':') == 0) then
     write(0,*) "tagName must begin with a letter, underscore or colon: '", name(1:1), "'."
     good=.false.
   endif
 elseif (good) then
   do i = 1, n
     if (scan(name(i:i), LETTER//DIGIT//'.'//'-'//'_'//':') == 0) then
       write(0,*) "tagName contains a forbidden character: '", name(i:i), "'."
       good=.false.
       exit
     endif
   enddo
 elseif (good) then
   if (scan(name(1:1), 'Xx') == 1 .and. &
       scan(name(2:2), 'Mm') == 1 .and. &
       scan(name(3:3), 'Ll') == 1) then
     write(0,*) "tagName cannot start with the characters 'XML'."
     good=.false.
   endif
 endif
       
end function check_Name

end module m_wxml_escape

program text

  use xmlf90_dom

  implicit none

  type(fnode), pointer :: myDoc, n
  type(fnodeList), pointer :: myList, childList
  type(string)  :: s

  integer  :: i, j, nels

  myDoc => parsefile(DOM_DATA_DIR//"big-file.xml")!! , verbose=.true.)
  print *, "allocated nodes: ", getNumberofAllocatedNodes()
!  call dumpTree(myDoc)
  call xmlize(myDoc,"dumptext.xml")

  myList => getElementsbyTagName(myDoc, "para")
  nels = getLength(myList)
  print *, "number of para elements: ", nels
  print *, "Dumping pure text under them..."
  do i = 0, nels - 1
     n => item(myList,i)
     childList => getChildNodes(n)
     do j = 0, getLength(childList) - 1
        n => item(childList,j)
        if (getNodeType(n) == TEXT_NODE) then
           s = getNodeValue(n)
           print *, "|", char(s), "|"
        endif
     enddo
  enddo

  print *, "Normalizing..."
  print *, "===================================================="
  call normalize(myDoc)
!  call dumpTree(myDoc)
  print *, "allocated nodes: ", getNumberofAllocatedNodes()
 myList => getElementsbyTagName(myDoc, "para")
  nels = getLength(myList)
  print *, "number of para elements: ", nels
  print *, "Dumping pure text under them..."
  do i = 0, nels - 1
     n => item(myList,i)
     childList => getChildNodes(n)
     do j = 0, getLength(childList) - 1
        n => item(childList,j)
        if (getNodeType(n) == TEXT_NODE) then
           s = getNodeValue(n)
           print *, "|", char(s), "|"
        endif
     enddo
  enddo


end program text

program count
  
  use xmlf90_sax
  use m_count

  integer :: i, iostat
  type(xml_t)  :: fxml

  call open_xmlfile(SAX_DATA_DIR//"big-file.xml",fxml,iostat)
  if (iostat /= 0) stop "Cannot open file."

  call xml_parse(fxml, &
                  begin_element_handler, &
                  end_element_handler,   &
                  pcdata_chunk_handler) 
  
  do i=1,nhash
     write(unit=*,fmt="(3a,i6)") "Number of ",trim(element_hash(i)%elm), & 
                 " elements: ",element_hash(i)%num
  enddo

end program count

module m_dom_utils

  use m_dom_types
  use m_dom_element
  use m_dom_document
  use m_dom_node
  use m_dom_namednodemap
  use m_dom_debug
  use m_dom_strings

  use xmlf90_wxml

  public :: dumpTree
  public :: xmlize

  private

CONTAINS

  subroutine dumpTree(startNode)

    type(fnode), pointer :: startNode   

    character(len=50) :: indent = " "
    integer           :: indent_level
    type(string)      :: s

    indent_level = 0

    call dump2(startNode)

  contains

    recursive subroutine dump2(input)
      type(fnode), pointer :: input
      type(fnode), pointer :: temp     
      temp => input
      do while(associated(temp))
         s = getNodeName(temp)
         write(*,'(3a,i3)') indent(1:indent_level), &
                        char(s), " of type ", &
                        getNodeType(temp)
         if (hasChildNodes(temp)) then
            indent_level = indent_level + 3
            call dump2(getFirstChild(temp))
            indent_level = indent_level - 3
         endif
         temp => getNextSibling(temp)
      enddo

    end subroutine dump2

  end subroutine dumpTree
!----------------------------------------------------------------

  subroutine xmlize(startNode,fname)

    type(fnode), pointer :: startNode   
    character(len=*), intent(in) :: fname

    type(xmlf_t)  :: xf
    type(string)  :: s, sv, sn       ! to avoid memory leaks

    call xml_OpenFile(fname,xf)
    call dump_xml(startNode)
    call xml_Close(xf)

  contains

    recursive subroutine dump_xml(input)
      type(fnode), pointer         :: input
!
!     Just this node and its descendants, no siblings. 
!     Of course, the document node has only children...
!
      type(fnode), pointer         :: node, attr
      type(fnamedNodeMap), pointer :: attr_map
      integer  ::  i

      node => input
      do
         if (.not. associated(node)) exit
         select case (getNodeType(node))

          case (DOCUMENT_NODE)

             call xml_AddXMLDeclaration(xf)
             if (hasChildNodes(node)) call dump_xml(getFirstChild(node))

          case (ELEMENT_NODE)

             s = getNodeName(node)
             call xml_NewElement(xf,char(s))
             attr_map => getAttributes(node)
             do i = 0, getLength(attr_map) - 1
                attr => item(attr_map,i)
                sn = getNodeName(attr)
                sv = getNodeValue(attr)
                call xml_AddAttribute(xf, char(sn),char(sv))
             enddo
             if (hasChildNodes(node)) call dump_xml(getFirstChild(node))
             s = getNodeName(node)
             call xml_EndElement(xf,char(s))

          case (TEXT_NODE)
             
             s = getNodeValue(node)
             call xml_AddPcdata(xf,char(s))

          case (CDATA_SECTION_NODE)
             
             s = getNodeValue(node)
             call xml_AddCdataSection(xf,char(s))

          case (COMMENT_NODE)
             
             s = getNodeValue(node)
             call xml_AddComment(xf,char(s))

        end select
        if (associated(node,StartNode)) exit  ! In case we request the 
                                              ! dumping of a single element,
                                              ! do not do siblings
        node => getNextSibling(node)
     enddo

    end subroutine dump_xml

  end subroutine xmlize

end module m_dom_utils

module m_dom_document

use m_dom_types
use m_dom_strings

private

  !-------------------------------------------------------  
  ! METHODS FOR DOCUMENT NODES
  !-------------------------------------------------------   
  public :: createDocumentNode
  public :: createDocumentFragment
  public :: createTextNode
  public :: createAttribute
  public :: createElement
  public :: createComment
  public :: createCdataSection

CONTAINS

  !-----------------------------------------------------------
  ! METHODS FOR DOCUMENT NODES
  !-----------------------------------------------------------

  function createDocumentNode()

    type(fnode), pointer :: createDocumentNode
    
    createDocumentNode => createNode()
    createDocumentNode % nodeType = DOCUMENT_NODE
    createDocumentNode % nodeName = "#document"
    
  end function createDocumentNode
!-------------------------------------------------------------------
  function createDocumentFragment()

    type(fnode), pointer :: createDocumentFragment
    
    createDocumentFragment => createNode()
    createDocumentFragment % nodeType = DOCUMENT_FRAGMENT_NODE
    createDocumentFragment % nodeName = "#document-fragment"
    
  end function createDocumentFragment
!-------------------------------------------------------------------
  function createTextNode(data)

    character(len=*), intent(in) :: data
    type(fnode), pointer :: createTextNode
    
    createTextNode => createNode()
    createTextNode % nodeType = TEXT_NODE
    createTextNode % nodeName = "#text"
    createTextNode % nodeValue = data  ! NB need to split this string 
                                       ! across several nodes 
    
  end function createTextNode

  !-----------------------------------------------------------

  function createAttribute(name)
    
    character(len=*), intent(in) :: name
    type(fnode), pointer :: createAttribute
  
    createAttribute => createNode()
    createAttribute % nodeName = name
    createAttribute % nodeType = ATTRIBUTE_NODE
  
  end function createAttribute

  !-----------------------------------------------------------

  function createElement(tagName)
    
    character(len=*), intent(in) :: tagName
    type(fnode), pointer :: createElement
  
    createElement => createNode()
    createElement % nodeName = tagName
    createElement % nodeType = ELEMENT_NODE
  
  end function createElement

  !-----------------------------------------------------------

  function createComment(data)
    
    character(len=*), intent(in) :: data
    type(fnode), pointer :: createComment
  
    createComment => createNode()
    createComment % nodeName = "#comment"
    createComment % nodeValue = data
    createComment % nodeType = COMMENT_NODE
  
  end function createComment

  !-----------------------------------------------------------

  function createCdataSection(data)
    
    character(len=*), intent(in) :: data
    type(fnode), pointer :: createCdataSection
  
    createCdataSection => createNode()
    createCdataSection % nodeName = "#cdata-section"
    createCdataSection % nodeValue = data
    createCdataSection % nodeType = CDATA_SECTION_NODE
  
  end function createCdataSection

  
end module m_dom_document

module m_dom_node

use m_dom_types
use m_dom_nodelist
use m_dom_namednodemap
use m_dom_debug
use m_dom_error

use m_dom_strings

private

  !-------------------------------------------------------   
  ! METHODS FOR NODES
  !-------------------------------------------------------   

  public :: getNodeName
  public :: getNodevalue	
  public :: getNodeType
  public :: hasChildNodes
  public :: hasAttributes
  public :: getParentNode
  public :: getFirstChild
  public :: getLastChild
  public :: getNextSibling
  public :: getPreviousSibling
  public :: getOwnerDocument
  public :: getAttributes
  public :: getChildNodes
  public :: setNodeValue
  public :: appendChild
  public :: removeChild
  public :: replaceChild
  public :: cloneNode  
  public :: isSameNode
  public :: insertBefore

  private :: name_len, value_len

CONTAINS

  pure function name_len(node)
    type(fnode), pointer :: node
    integer :: name_len

    name_len = len_trim(node % nodeName)

  end function name_len

  pure function value_len(node)
    type(fnode), pointer :: node
    integer :: value_len

    value_len = len_trim(node % nodeValue)

  end function value_len

  !-----------------------------------------------------------
  !  METHODS FOR NODES
  !-----------------------------------------------------------
  function getNodeName(node)

    type(fnode), pointer :: node
!    character(len=len_trim(node%nodeName)) :: getNodeName
    type(string)  :: getNodeName
    if (.not. associated(node))  &
               call dom_error("getNodeName",0,"Node not allocated")
    getNodeName = node % nodeName

  end function getNodeName

  !-----------------------------------------------------------

  function getNodeValue(node)

    type(fnode), pointer :: node
!    character(len=len_trim(node%nodeValue)) :: getNodeValue
    type(string)  :: getNodeValue

    if (.not. associated(node))  &
               call dom_error("getNodeValue",0,"Node not allocated")
    getNodeValue = node % nodeValue

  end function getNodeValue

  !-----------------------------------------------------------

  function getNodeType(node)

    type(fnode), pointer :: node
    integer :: getNodeType

    if (.not. associated(node)) call dom_error("getNodeType",0,"Node not allocated")
    getNodeType = node % nodeType

  end function getNodeTYpe

  !-----------------------------------------------------------

  function hasChildNodes(node)

    type(fnode), pointer :: node
    logical :: hasChildNodes

    if (.not. associated(node)) call dom_error("hasChildNodes",0,"Node not allocated")
    hasChildNodes = associated(node % firstChild)

  end function hasChildNodes

  !-----------------------------------------------------------

  function hasAttributes(node)

    type(fnode), pointer    :: node
    logical                 :: hasAttributes

    hasAttributes = .false.
    if (.not. associated(node)) call dom_error("hasAttributes",0,"Node not allocated")
    if (node % nodeType /= ELEMENT_NODE) RETURN
    if ( getLength(node%attributes) > 0) hasAttributes = .true.

  end function hasAttributes

  !-----------------------------------------------------------

  function getParentNode(node)

    type(fnode), pointer    :: node
    type(fnode), pointer    :: getParentNode

    if (.not. associated(node)) call dom_error("getParentNode",0,"Node not allocated")
    getParentNode => node % parentNode
    
  end function getParentNode
  
  !-----------------------------------------------------------

  function getFirstChild(node)

    type(fnode), pointer    :: node
    type(fnode), pointer    :: getFirstChild

    if (.not. associated(node)) call dom_error("getFirstChild",0,"Node not allocated")
    getFirstChild => node % firstChild

  end function getFirstChild

  !-----------------------------------------------------------

  function getLastChild(node)

    type(fnode), pointer :: node
    type(fnode), pointer    :: getLastChild

    if (.not. associated(node)) call dom_error("getLastChild",0,"Node not allocated")
    getLastChild => node % lastChild

  end function getLastChild

  !-----------------------------------------------------------

  function getNextSibling(node)

    type(fnode), pointer :: node
    type(fnode), pointer    :: getNextSibling

    if (.not. associated(node)) call dom_error("getNextSibling",0,"Node not allocated")
    getNextSibling => node % nextSibling

  end function getNextSibling

  !-----------------------------------------------------------

  function getPreviousSibling(node)

    type(fnode), pointer     :: node
    type(fnode), pointer    :: getPreviousSibling

    if (.not. associated(node)) call dom_error("getPreviousSibling",0,"Node not allocated")
    getPreviousSibling => node % previousSibling

  end function getPreviousSibling

  !-----------------------------------------------------------

  function getOwnerDocument(node)

    type(fnode), pointer    :: node
    type(fnode), pointer    :: getOwnerDocument

    if (.not. associated(node)) call dom_error("getOwnerDocument",0,"Node not allocated")
    getOwnerDocument => node % ownerDocument

  end function getOwnerDocument

  !----------------------------------------------------------- 

  function getChildNodes(node) result(nodelist)
    
    type(fnode), pointer        :: node
    type(fnodeList), pointer    :: nodelist      !!! NB nodeList

    type(fnode), pointer        :: np

    if (.not. associated(node)) call dom_error("getChildNodes",0,"Node not allocated")
    nodelist => null()
    np => node%firstChild
    do 
       if (.not. associated(np)) exit
       call append(nodelist,np)
       np => np%nextSibling
    enddo

  end function getChildNodes

  !----------------------------------------------------------- 

  function getAttributes(node)

    type(fnode), pointer         :: node
    type(fnamedNodeMap), pointer :: getAttributes       !!! NB namedNodeMap
    
    if (.not. associated(node))  &
               call dom_error("getAttributes",0,"Node not allocated")
    getAttributes => node % attributes

  end function getAttributes

  !----------------------------------------------------------- 

  subroutine setNodeValue(node, value)

    type(fnode), pointer :: node
    character(len=*), intent(in) :: value
    
    if (.not. associated(node))  &
               call dom_error("setNodeValue",0,"Node not allocated")

    select case(node % nodeType)

    case(ATTRIBUTE_NODE)
       node % nodeValue = trim(value)    !!AG: use just value ??

    case(COMMENT_NODE)
       node % nodeValue = value

    case(TEXT_NODE)
       node % nodeValue = value

    case(PROCESSING_INSTRUCTION_NODE)
       node % nodeValue = value

    case(CDATA_SECTION_NODE)
       node % nodeValue = value

    end select

  end subroutine setNodeValue

  !-----------------------------------------------------------
  
  function appendChild(node, newChild)
    type(fnode), pointer :: node
    type(fnode), pointer :: newChild
    type(fnode), pointer :: appendChild
    
    if (.not. associated(node))  & 
               call dom_error("appendChild",0,"Node not allocated")

    if ((node%nodeType /= ELEMENT_NODE) .and. &
        (node%nodeType /= DOCUMENT_NODE)) &
    call dom_error("appendChild",HIERARCHY_REQUEST_ERR, &
           "this node cannot have children")

    if (.not.(associated(node % firstChild))) then
       node % firstChild => newChild
    else 
       newChild % previousSibling   => node % lastChild
       node % lastChild % nextSibling => newChild 
    endif

    node % lastChild               => newChild
    newChild % parentNode          => node
    newChild % ownerDocument       => node % ownerDocument
    node%nc  = node%nc + 1

    appendChild => newChild

  end function appendChild

  !-----------------------------------------------------------
  
  function removeChild(node, oldChild)

    type(fnode), pointer :: removeChild
    type(fnode), pointer :: node
    type(fnode), pointer :: oldChild
    type(fnode), pointer :: np
    
    if (.not. associated(node)) call dom_error("removeChild",0,"Node not allocated")
    np => node % firstChild

    do while (associated(np))
       if (associated(np, oldChild)) then   ! Two argument form 
                                              !  of associated()
          if (associated(np,node%firstChild)) then
             node%firstChild => np%nextSibling
             if (associated(np % nextSibling)) then
                np%nextSibling % previousSibling => null()
             else
                node%lastChild => null()    ! there was just 1 node
             endif
          else if (associated(np,node%lastChild)) then
             ! one-node-only case covered above
             node%lastChild => np%previousSibling
             np%previousSibling%nextSibling => null()
          else
             np % previousSibling % nextSibling => np % nextSibling
             np % nextSibling % previousSibling => np % previousSibling
          endif
          node%nc = node%nc -1
          np % previousSibling => null()    ! Are these necessary?
          np % nextSibling => null()
          np % parentNode => null()
          removeChild => oldChild
          RETURN
       endif
       np => np % nextSibling
    enddo

    call dom_error("removeChild",NOT_FOUND_ERR,"oldChild not found")

  end function removeChild

 !-----------------------------------------------------------
  
  function replaceChild(node, newChild, oldChild)

    type(fnode), pointer :: replaceChild
    type(fnode), pointer :: node
    type(fnode), pointer :: newChild
    type(fnode), pointer :: oldChild

    type(fnode), pointer :: np
    
    if (.not. associated(node)) call dom_error("replaceChild",0,"Node not allocated")
    if ((node%nodeType /= ELEMENT_NODE) .and. &
        (node%nodeType /= DOCUMENT_NODE)) &
    call dom_error("replaceChild",HIERARCHY_REQUEST_ERR, &
           "this node cannot have children")

    np => node % firstChild

    do while (associated(np))    
       if (associated(np, oldChild)) then
          if (associated(np,node%firstChild)) then
             node%firstChild => newChild
             if (associated(np % nextSibling)) then
                oldChild%nextSibling % previousSibling => newChild
             else
                node%lastChild => newChild    ! there was just 1 node
             endif
          else if (associated(np,node%lastChild)) then
             ! one-node-only case covered above
             node%lastChild => newChild
             oldChild%previousSibling%nextSibling => newChild
          else
             oldChild % previousSibling % nextSibling => newChild
             oldChild % nextSibling % previousSibling => newChild
          endif

          newChild % parentNode      => oldChild % parentNode
          newChild % nextSibling     => oldChild % nextSibling
          newChild % previousSibling => oldChild % previousSibling
          replaceChild => oldChild
          RETURN
       endif
       np => np % nextSibling
    enddo

    call dom_error("replaceChild",NOT_FOUND_ERR,"oldChild not found")

  end function replaceChild

  !-----------------------------------------------------------

  function cloneNode(node, deep)             
    type(fnode), pointer :: cloneNode
    type(fnode), pointer :: node

    logical, optional :: deep
    logical           :: do_children

    type(fnode), pointer :: original
    type(fnode), pointer :: parent_clone
    
    if (.not. associated(node)) call dom_error("cloneNode",0,"Node not allocated")

    do_children = .false.
    if (present(deep)) then
       do_children = deep
    endif
    
    original => node             ! Keep node
    cloneNode => null()
    parent_clone => null()
    call recursive_clone(original, cloneNode)
    cloneNode%parentNode => null()     ! as per specs   , superfluous
 
  Contains

    recursive subroutine recursive_clone(original, cloneNode)
      type(fnode), pointer :: original        ! node to clone
      type(fnode), pointer :: cloneNode       ! new node

      type(fnode), pointer :: np, clone
      type(fnode), pointer :: previous_clone, attr, newattr
      type(string)         :: name
      logical :: first_sibling
      integer :: i

      np => original
      previous_clone => null()
      first_sibling = .true.
      do 

         ! Keep going across siblings
         ! (2nd and lower levels only)

         if (.not.(associated(np))) EXIT


         !----------------------------------------------------!
         clone => createNode()
         if (first_sibling) then
            cloneNode => clone       ! Rest of siblings are chained
                                     ! automatically, but must not
                                     ! be aliases of cloneNode !!
            first_sibling = .false.
         endif
         clone % nodeName    = np % nodeName
         name = np%nodeName
         if (dom_debug) print *, "Cloning ", char(name)
         clone % nodeValue   = np % nodeValue
         clone % nodeType    = np % nodeType
         clone % ownerDocument => np % ownerDocument
         clone % parentNode  => parent_clone
         !
         ! always deep copy attributes, as per specs
         ! Note that this will not work for "deep" attributes, with
         ! hanging entity nodes, etc
         if (associated(np % attributes)) then
            do i = 0, getLength(np%attributes) - 1
               attr => item(np%attributes,i)
               newattr => createNode()
               newattr%nodeName = getNodeName(attr)
               newattr%nodeValue = getNodeValue(attr)
               newattr%nodeType = ATTRIBUTE_NODE
               call append(clone%attributes, newattr)
            enddo
         endif

         ! Deal with first sibling
         if (associated(previous_clone)) then
            if (dom_debug) print *, "linking to previous sibling"
            previous_clone%nextSibling => clone
            clone%previousSibling => previous_clone
         else
            if (dom_debug) print *, "marking as first child of parent"
            if (associated(parent_clone))  &
                           parent_clone%firstChild => clone
         endif

         ! Deal with last sibling
         if (.not. associated(np%nextSibling)) then
            if (dom_debug) print *, "this is the last sibling"
            if (associated(parent_clone)) then
               if (dom_debug) print *, "marking as last child of parent"
               parent_clone%lastChild => clone
            endif
         endif
            
         if (do_children .and. associated(np%firstChild)) then
            parent_clone => clone
            if (dom_debug) print *, ".... going for its children"
            call recursive_clone(np%firstChild,clone%firstChild)
            parent_clone => clone%parentNode
         endif

         if (associated(np,node)) then
            if (dom_debug) print *, "No more siblings of ", char(name)
            EXIT  ! no siblings of master node
         endif
         np => np % nextSibling
         previous_clone => clone

      enddo 

    end subroutine recursive_clone

  end function cloneNode

  !-----------------------------------------------------------

  function isSameNode(node1, node2)    ! DOM 3.0
    type(fnode), pointer :: node1
    type(fnode), pointer :: node2
    logical :: isSameNode

    isSameNode = associated(node1, node2)

  end function isSameNode

  !-----------------------------------------------------------

  function insertBefore(node, newChild, refChild)
    type(fnode), pointer :: insertBefore
    type(fnode), pointer :: node
    type(fnode), pointer :: newChild
    type(fnode), pointer :: refChild
    type(fnode), pointer :: np

    if (.not. associated(node)) call dom_error("insertBefore",0,"Node not allocated")
    if ((node%nodeType /= ELEMENT_NODE) .and. &
        (node%nodeType /= DOCUMENT_NODE)) &
    call dom_error("insertBefore",HIERARCHY_REQUEST_ERR, &
           "cannot insert node here")

    if (.not.associated(refChild)) then
       insertBefore => appendChild(node, newChild)
       RETURN
    endif

    np => node % firstChild
    do while (associated(np))
       if (associated(np, refChild)) then
          if (associated(np,node%firstChild)) then
             node%firstChild => newChild
          else
             refChild%previousSibling%nextSibling => newChild
          endif

          refChild % previousSibling => newChild
          newChild % nextSibling => refChild
          newChild % parentNode => node
          newChild % ownerDocument => refChild % ownerDocument
          insertBefore => newChild
          RETURN
       endif
       np => np % nextSibling
    enddo

    call dom_error("insertBefore",NOT_FOUND_ERR,"refChild not found")

  end function insertBefore

!----------------------------------------------------------------------

end module m_dom_node

program pseudoread

use m_pseudo_types

! Module
  use xmlf90_dom

type(pseudo_t), target :: pseudo
type(grid_t)           :: global_grid
!
type(string)           :: s         ! to avoid memory leaks

! Pointers to make it easier to manage the data
!
type(header_t),  pointer   :: hp
type(vps_t),  pointer      :: pp

  type(fnode), pointer          :: myDoc
  type(fnode), pointer          :: myNode, np
  type(fnodeList), pointer      :: myList

  integer :: npseudos, i
  character(len=200)  :: value      ! Could be larger, or made into a string

! Parse
! No constructor method - this is fortran !
  myDoc => parsefile(DOM_DATA_DIR//"pseudo.xml")  !  ,verbose=.true.)
  print *, "Number of active nodes: ", getNumberofAllocatedNodes()

!  call dumpTree(myDoc)
  print *, "Normalizing...(can take long if big file --- not really needed)"
  call normalize(myDoc)
!  call dumpTree(myDoc)

  print *, "Number of active nodes: ", getNumberofAllocatedNodes()  

!----------------------------------------------------------  

  myList => getElementsByTagName(myDoc, "pseudo")
  if (getLength(myList) == 0) then
     call die("Did not found any pseudo elements...")
  endif
  myNode => item(myList, 0)

  value = getAttribute(myNode,"version")
  if (value == "0.5") then
     print *, "Processing a PSEUDO version 0.5 XML file"
     pseudo%npots = 0
     global_grid%npts = 0
  else
     print *, "Can only work with PSEUDO version 0.5 XML files"
     STOP
  endif

  global_grid%npts = 0          ! To flag absence of global grid info
  myList => getChildNodes(myNode)
  do i=0, getLength(myList) - 1
     np => item(myList,i)
     s = getNodeName(np)
     if (s == "grid") then
        print *, "This file has a global grid... "
        call get_grid_data(np,global_grid)
        exit
     endif
  enddo
!
! Header
!
  myList => getElementsByTagName(myDoc, "header")
  if (getLength(myList) == 0) then
     call die("Did not found any header elements...")
  endif
  myNode => item(myList, 0)
  print *, "Processing header..."
         hp => pseudo%header
         
         hp%symbol = getAttribute(myNode,"symbol")
         if (hp%symbol == "" ) call die("Cannot determine atomic symbol")

         value = getAttribute(myNode,"zval")
         if (value == "") call die("Cannot determine zval")
         read(unit=value,fmt=*) hp%zval
!
         hp%creator = getAttribute(myNode,"creator")
         if (hp%creator == "" ) hp%creator="unknown"

         hp%flavor = getAttribute(myNode,"flavor")
         if (hp%flavor == "" ) hp%flavor="unknown"

         value = getAttribute(myNode,"relativistic")
         if (value == "") hp%relativistic = .false.
         hp%relativistic = (value == "yes")

         value = getAttribute(myNode,"polarized")
         if (value == "") hp%polarized = .false.
         hp%polarized = (value == "yes")

         hp%core_corrections = getAttribute(myNode,"core-corrections")
         if (hp%core_corrections == "" ) hp%core_corrections="nc"

!
!  Valence charge
!
  myList => getElementsByTagName(myDoc, "valence-charge")
  if (getLength(myList) == 0) then
     call die("Did not found the valence charge ...")
  endif
  np => item(myList,0)
  if (associated(np)) then
     print *, "Processing valence charge..."
   !
   !  Get the data (and possible private grid)
   !
     call get_radfunc_data(np,global_grid,pseudo%valence_charge)
  endif

!  Core charge
!
  myList => getElementsByTagName(myDoc, "pseudocore-charge")
     np => item(myList,0)
     if (associated(np)) then
        print *, "Processing core charge..."
   !
   !  Get the data (and possible private grid)
   !
     call get_radfunc_data(np,global_grid,pseudo%core_charge)
  endif

!
! Semilocal Pseudos
!
  myList => getElementsByTagName(myDoc, "semilocal")
  if (getLength(myList) == 0) then
     call die("Did not found the semilocal element...")
  endif
  np => item(myList, 0)
  if (associated(np)) then
        print *, "Processing semilocal..."

         value = getAttribute(np,"npots-down")
         if (value == "" ) call die("Cannot determine npots-down")
         read(unit=value,fmt=*) pseudo%npots_down

         value = getAttribute(np,"npots-up")
         if (value == "" ) call die("Cannot determine npots-up")
         read(unit=value,fmt=*) pseudo%npots_up

  else
     call die("Cannot find semilocal element")
  endif

  pseudo%npots = 0
  myList => getElementsByTagName(np, "vps")
  if (getLength(myList) == 0) then
     call die("Did not found any vps elements...")
  endif
  npseudos = getLength(myList) 
  do i = 0, npseudos - 1
     print *, "Processing vps i = ", i , "---------------------"
     myNode => item(myList, i)
     pseudo%npots = pseudo%npots + 1
     pp => pseudo%pot(pseudo%npots)

         value = getAttribute(myNode,"l")
         if (value == "" ) call die("Cannot determine l for Vps")
         read(unit=value,fmt=*) pp%l

         value = getAttribute(myNode,"principal-n")
         if (value == "" ) call die("Cannot determine n for Vps")
         read(unit=value,fmt=*) pp%n

         value = getAttribute(myNode,"cutoff")
         if (value == "" ) call die("Cannot determine cutoff for Vps")
         read(unit=value,fmt=*) pp%cutoff

         value = getAttribute(myNode,"occupation")
         if (value == "" ) call die("Cannot determine occupation for Vps")
         read(unit=value,fmt=*) pp%occupation

         value = getAttribute(myNode,"spin")
         if (value == "" ) call die("Cannot determine spin for Vps")
         read(unit=value,fmt=*) pp%spin

         call get_radfunc_data(myNode,global_grid,pp%V)

  enddo

!
!  Show some of the information
!
call dump_pseudo(pseudo)

CONTAINS

!-----------------------------------------------------------------------
subroutine get_radfunc_data(element,global_grid,rp)
use m_sax_converters, only: build_data_array
!
! Example of routine which packages parsing functionality for a
! common element. The <radfunc> element can appear under <vps>,
! <valence-charge>, and <pseudocore-charge> elements. 
! In all cases the parsing steps are exactly  the same.
! This routine accepts a pointer to the parent element and returns
! the data structure.
!
type(fnode), pointer      :: element
type(grid_t), intent(in)     :: global_grid
type(radfunc_t), intent(out) :: rp

type(fnode), pointer      :: np, radfuncp
type(fnodeList), pointer  :: lp
integer                   :: ndata
type(string)              :: pcdata, s

  s = getNodeName(element)
  print *, "Getting radfunc data from element ", char(s)
  lp => getElementsByTagName(element, "radfunc")
  radfuncp => item(lp,0)
  lp => getElementsByTagName(radfuncp, "grid")
  np => item(lp,0)
      if (associated(np))  then
         print *, " >> local grid found"
         call get_grid_data(np,rp%grid)
      else
         print *, " >> re-using global grid"
         rp%grid = global_grid
      endif

  lp => getElementsByTagName(radfuncp, "data")
  np => item(lp,0)
      if (associated(np))  then
         if (rp%grid%npts == 0) call die("Need grid information!")
         allocate(rp%data(rp%grid%npts))
         ndata = 0             ! To start the build up
         np => getFirstChild(np)
         do
            if (.not. associated(np)) exit
            if (getNodeType(np) /= TEXT_NODE) exit
            pcdata = getNodeValue(np)               ! text node 
            call build_data_array(char(pcdata),rp%data,ndata)
            np => getNextSibling(np)
         enddo
         if (ndata /= size(rp%data)) STOP "npts mismatch"
      else
         call die("Cannot find data element")
      endif
end subroutine get_radfunc_data
!-----------------------------------------------------------------------
subroutine get_grid_data(element,grid)
type(fnode), pointer  :: element
type(grid_t), intent(out)       :: grid

character(len=100)  :: value

         grid%type = getAttribute(element,"type")
         if (grid%type == "" ) call die("Cannot determine grid type")

         value = getAttribute(element,"npts")
         if (value == "" ) call die("Cannot determine grid npts")
         read(unit=value,fmt=*) grid%npts

         value = getAttribute(element,"scale")
         if (value == "" ) call die("Cannot determine grid scale")
         read(unit=value,fmt=*) grid%scale

         value = getAttribute(element,"step")
         if (value == "" ) call die("Cannot determine grid step")
         read(unit=value,fmt=*) grid%step

end subroutine get_grid_data

!-----------------------------------------------------------------------
      subroutine die(str)
      character(len=*), intent(in), optional   :: str
      if (present(str)) then
         write(unit=0,fmt="(a)") trim(str)
      endif
      write(unit=0,fmt="(a)") "Stopping Program"
      stop
      end subroutine die


end program pseudoread

module m_wxml_text

implicit none
!
integer, private, parameter ::  sp = selected_real_kind(6,30)
integer, private, parameter ::  dp = selected_real_kind(14,100)
!
private
public :: str

interface str
   module procedure  str_integer_fmt, str_integer, &
                     str_logical_fmt, str_logical, &
                     str_real_dp, str_real_sp
end interface

CONTAINS

      function str_integer_fmt(i,format) result(s)
      integer, intent(in)   :: i
      character(len=*), intent(in) :: format
      character(len=100)    :: s

      write(s,format) i
      s = adjustl(s)
      end function str_integer_fmt

      function str_integer(i) result(s)
        ! This will work correctly (return an appropriately-sized
        ! string) for integers i s.t. -99999999<=i<=999999999
        integer, intent(in) :: i
#ifndef WXML_INIT_FIX
        character(len=int(merge(log10(real(max(abs(i),1)))+1, &
                                log10(real(max(abs(i),1)))+2, &
                          sign(1,i)>0))) :: s
#else
! Some compilers have trouble with the above
        character(len=int(log10(real(max(abs(i),1)))+2))  :: s
#endif
        character(len=4) :: form
        
        write(form,'(a,i1,a)') '(i',len(s),')'
        write(s, form) i

      end function str_integer

      function str_logical_fmt(l,format) result(s)
      logical, intent(in)   :: l
      character(len=*), intent(in) :: format
      character(len=100)    :: s

      write(s,format) l
      s = adjustl(s)

      end function str_logical_fmt

      function str_logical(l) result(s)
        logical, intent(in)   :: l
        character(len=merge(4,5,l)) :: s
        
        if (l) then
          s='true'
        else
          s='false'
        endif
      end function str_logical

      function str_real_dp(x,format) result(s)
      real(kind=dp), intent(in)   :: x
      character(len=*), intent(in), optional  :: format
      character(len=100)    :: s

      character(len=50) :: fmt_local

      if (present(format)) then
         ! Catch FoX's optional "rX" descriptor
         ! which encodes a number of digits after the decimal point
         if ((format(1:1)=="r") .or. (format(1:1)=="R")) then
            write(fmt_local,"(a)") "(f99." // trim(format(2:)) // ")"
         else
            fmt_local = format
         endif
         write(s,fmt_local) x
      else
         if (abs(nint(x)-x) .lt. epsilon(x)) then
            write(s,"(i0)") nint(x)
         else
            write(s,"(g22.12)") x
         endif
      endif
      s = adjustl(s)
      end function str_real_dp

      function str_real_sp(x,format) result(s)
      real(kind=sp), intent(in)   :: x
      character(len=*), intent(in), optional  :: format
      character(len=100)    :: s

      character(len=50) :: fmt_local
      
      if (present(format)) then
         ! Catch FoX's optional "rX" descriptor
         ! which encodes a number of digits after the decimal point
         if ((format(1:1)=="r") .or. (format(1:1)=="R")) then
            write(fmt_local,"(a)") "(f99." // trim(format(2:)) // ")"
         else
            fmt_local = format
         endif
         write(s,fmt_local) x
      else
         if (abs(nint(x)-x) .lt. epsilon(x)) then
            write(s,"(i0)") nint(x)
         else
            write(s,"(g22.12)") x
         endif
      endif
      s = adjustl(s)
      end function str_real_sp


end module m_wxml_text

module m_dom_parse

  use m_dom_types
  use m_dom_element
  use m_dom_document
  use m_dom_node
!  use m_dom_namednodemap
  use m_dom_debug

  use xmlf90_sax

  implicit none
  
  private

  public :: parsefile

  type(fnode), pointer, private, save  :: main
  type(fnode), pointer, private, save  :: current


CONTAINS

  subroutine begin_element_handler(name,attrs)

    character(len=*),   intent(in) :: name
    type(dictionary_t), intent(in) :: attrs
   
    type(fnode), pointer :: temp
    character(len=400)   :: attr_name, attr_value
    integer              :: status
    integer              :: i

    if (dom_debug) print *, "Adding node for element: ", name

    temp => createElement(name)
    current => appendChild(current,temp)
!
!   Add attributes
!
    do i = 1, len(attrs)
       call get_name(attrs, i, attr_name, status)
       call get_value(attrs, attr_name, attr_value, status)
       if (dom_debug) print *, "Adding attribute: ", &
                       trim(attr_name), ":",trim(attr_value)
       call setAttribute(current,attr_name,attr_value)
    enddo

  end subroutine begin_element_handler

!---------------------------------------------------------

  subroutine end_element_handler(name)
    character(len=*), intent(in)     :: name

!!AG for IBM    type(fnode), pointer :: np

    if (dom_debug) print *, "End of element: ", name
!!AG for IBM    np => getParentNode(current)
!!AG for IBM    current => np
    current => getParentNode(current)
  end subroutine end_element_handler

!---------------------------------------------------------

  subroutine pcdata_chunk_handler(chunk)
    character(len=*), intent(in) :: chunk

    type(fnode), pointer :: temp, dummy
    
    if (dom_debug) print *, "Got PCDATA: |", chunk, "|"

    temp => createTextNode(chunk)
    dummy => appendChild(current,temp)

  end subroutine pcdata_chunk_handler

!---------------------------------------------------------

  subroutine comment_handler(comment)
    character(len=*), intent(in) :: comment

    type(fnode), pointer :: temp, dummy

    if (dom_debug) print *, "Got COMMENT: |", comment, "|"

    temp => createComment(comment)
    dummy => appendChild(current,temp)

  end subroutine comment_handler
!---------------------------------------------------------
  subroutine cdata_section_handler(chunk)
    character(len=*), intent(in) :: chunk

    type(fnode), pointer :: temp, dummy
    
    if (dom_debug) print *, "Got CDATA_SECTION: |", chunk, "|"

    temp => createCdataSection(chunk)
    dummy => appendChild(current,temp)

  end subroutine cdata_section_handler

!***************************************************
!   PUBLIC PROCEDURES
!***************************************************


  function parsefile(filename, verbose, sax_verbose)

    character(len=*), intent(in) :: filename
    logical, intent(in), optional :: verbose
    logical, intent(in), optional :: sax_verbose

    type(fnode), pointer :: parsefile

    logical :: sax_debug = .false.

    type(xml_t) :: fxml
    integer :: iostat

    if (present(verbose)) then
       dom_debug = verbose
    endif

    if (present(sax_verbose)) then
       sax_debug = sax_verbose
    endif
    
    call open_xmlfile(filename, fxml, iostat)

    if (iostat /= 0) then
       print *,  "Cannot open file " // trim(filename)
    endif

    main => createDocumentNode()
    current => main

    call xml_parse(fxml,  &
           begin_element_handler, end_element_handler, pcdata_chunk_handler, &
           comment_handler, cdata_section_handler=cdata_section_handler, &
           verbose = sax_debug)    
    call close_xmlfile(fxml)

    parsefile => main
    if (dom_debug) print *, "Number of allocated nodes: ", getNumberofAllocatedNodes()

  end function parsefile


END MODULE m_dom_parse

program self
use xmlf90_xpath
!
! Example of re-scanning of an element
!
type(xml_t) :: fxml
type(dictionary_t) :: attributes

integer  :: status
character(len=100)  :: id, currency, price

call open_xmlfile(XPATH_DATA_DIR//"inventory.xml",fxml,status)
!
do
      call mark_node(fxml,path="//item",status=status)
      if (status < 0)   exit
      !
      ! Pretend we forgot to get the id attribute...
      !
      call get_node(fxml,path=".",attributes=attributes,status=status)
      if (status < 0)   exit
      call get_value(attributes,"id",id,status)
      if (status /= 0) stop "missing id attribute!"
      print *, "Id: ", trim(id)
      !
      ! Now perform a relative search in two stages:
      !  First the attributes...
      !
      call get_node(fxml,path="price",attributes=attributes,status=status)
      if (status < 0)   exit
      call get_value(attributes,"currency",currency,status)
      if (status /= 0) stop "missing currency attribute!"
      print *, "Currency: ", trim(id)

      !  And then the pcdata. Note that "." refers now to the /item/price
      !  element, since fxml has been running through the file and we
      !  have not saved any context to get back to.
      !
      call get_node(fxml,path=".",pcdata=price,status=status)
      if (status /= 0) stop "error in retrieving price data"
      print *, "Price: ", trim(price)
enddo
end program self

#!/bin/sh
#
# Copyright (C) 2015 Y. Pouillon
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation; either version 3 of the License, or 
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
#

# Note: this script is temporary and will be removed upon release.

# Stop at first error and echo commands
set -ev

# Check that we are in the correct directory
test -s "configure.ac" -a -s "src/sax/m_xml_parser.f90" || exit 0

# Fix permissions
chmod -R u+w .

# Init build parameters
export CC="gcc"
#export CFLAGS="-O0 -g3 -ggdb -Wall -Wextra -fbounds-check -fno-inline"
export CFLAGS="-O0 -g3 -ggdb -Wall -Wextra -fno-inline"
export FC="gfortran"
#export FCFLAGS="-O0 -g3 -ggdb -Wall -Wextra -fbounds-check -fno-inline -fbacktrace"
export FCFLAGS="-O0 -g3 -ggdb -Wall -Wextra -fno-inline -fbacktrace"

# Prepare source tree
./wipeout.sh
./autogen.sh

# Check default build
mkdir tmp-default
cd tmp-default
../configure
sleep 3
make dist -j4
make -j4
make clean && make -j4
make check -j4
mkdir install-test
make install DESTDIR="${PWD}/install-test"
ls -lR install-test >install-test.log
cd ..

# Check docgen build
mkdir tmp-docgen
cd tmp-docgen
../configure --enable-docgen
sleep 3
make check -j4
mkdir install-test
make install DESTDIR="${PWD}/install-test"
ls -lR install-test >install-test.log
cd ..

# Make distcheck
mkdir tmp-distcheck
cd tmp-distcheck
../configure
sleep 3
make distcheck -j4
make distcleancheck
cd ..

# Clean-up the mess
rm -rf tmp-default tmp-docgen tmp-distcheck

#!/bin/sh
#
# Copyright (C) 2010 Yann Pouillon
#
# This file is part of the XMLF90 software package. For license information,
# please see the COPYING file in the top-level directory of the source
# distribution.
#

#
# IMPORTANT NOTE:
#
#   For maintainer use only!
#
#   PLEASE DO NOT EDIT THIS FILE, AS IT COULD CAUSE A SERIOUS LOSS OF DATA.
#   *** YOU HAVE BEEN WARNED! ***
#

# Check that we are in the right directory
if test ! -s "./configure.ac" -o ! -s "src/sax/m_xml_parser.f90"; then
  echo "wipeout: Cowardly refusing to remove something from here!"
  exit 1
fi

# Fix permissions
chmod -R u+w .

# Remove temporary directories and files
echo "Removing temporary directories and files..."
rm -rf tmp*
find . -depth -name 'tmp-*' -exec rm -rf {} \;
find src -name '*.~[0-9]~' -exec rm -f {} \;
echo "done."

# Remove autotools files
echo "Removing autotools files..."
find src -depth -name '.deps' -exec rm -rf {} \;
find src -depth -name '.libs' -exec rm -rf {} \;
find . -name '*.pc' -exec rm {} \;
rm -f core config.log config.status stamp-h1 config.h config.h.in*
rm -rf aclocal.m4 autom4te.cache configure confstat*
(test -e config/gnu && cd config/gnu && rm -f compile config.guess config.sub depcomp install-sh ltmain.sh missing)
(test -e config/m4 && cd config/m4 && rm -f libtool.m4 ltoptions.m4 ltsugar.m4 ltversion.m4 lt~obsolete.m4)
echo "done."

# Remove Makefiles and machine-generated files
echo "Removing generated makefiles and libtool scripts..."
rm -f libtool
find . -name Makefile -exec rm {} \;
find . -name Makefile.in -exec rm {} \;
echo "done."

# Remove object files, libraries and programs
echo "Removing object files, libraries and programs..."
find src -name '*.a' -o -name '*.o' -exec rm {} \;
find src -name '*.la' -o -name '*.lo' -exec rm {} \;
find src -name '*.mod' -exec rm {} \;
find src -name '*.x' -exec rm {} \;
echo "done."

# Remove distribution files
echo "Removing distribution files..."
rm -rf xmlf90-[0-9].[0-9].[0-9].[0-9]*
echo "done."

#!/bin/sh
#
# Copyright (C) 2010 Yann Pouillon
#
# This file is part of the XMLF90 software package. For license information,
# please see the COPYING file in the top-level directory of the source
# distribution.
#

# Stop at first error encountered
set -e

# Check that we are in the right directory
if test ! -s "./configure.ac" -o ! -s "src/sax/m_xml_parser.f90"; then
  echo "This is not a XMLF90 source tree - aborting now"
  exit 1
fi

# Create possibly missing directories
mkdir -p config/gnu config/m4

# Generate libtool scripts
echo "Generating libtool scripts..."
libtoolize --automake --copy --force
echo "done."

# Generate M4 includes
echo "Generating aclocal.m4..."
aclocal -I config/m4
echo "done."

# Generate configure auxiliary files
#echo "Generating config.h.in..."
#autoheader
#echo "done."

# Generate configure
echo "Generating configure script..."
autoconf
echo "done."

# Generate makefile inputs
# Do not use "automake --force-missing", as it overwrites the INSTALL file.
echo "Generating Makefile.in for each directory..."
automake --add-missing --copy
echo "done."
